
Year=2023
.weak
VERSION=""
.endweak


selfmod=0 ;self-modified code default value
selfmodA=$1111 ;self-modified address default value
cmd_rts=$60 ;for self-modified code (player-handling)
cmd_nop=$EA


;machine-info ---------------------------------------------------------
.weak
 EMULATOR = 0 ;is TEDzakker translated for emulator (e.g. save-dialog can read dir by default fast, folder-change?)
 MIDI = 1
;MACHINE=1 ;set in player ;0:C16(too small memory for the whole program, simplifications), 1:plus4, 2:C64(TED-emulation on SID)
;VIDEO_STANDARD=0 ;PAL or NTSC (Plus4/C16 can be both)
HORIZONTAL_ORDERLIST = 0 ;0:vertical 1:horizontal
.endweak

.if (EMULATOR!=0)
TZEMU_FOLDER_CHAR = $7F ;should match the emulator's
.fi

;features to have (especially needed to disable memory-hungry parts on Commodore16)
.if (MACHINE==0) ;C16
MENU_SUPPORT=0 ;if no menu, C=+L and C=+S can be used as Load/Save commands (, C=+D as disk-directory command, C=+E to export PRG)
TUNEINIT_SUPPORT=0 ;clear ins./tune, set global patt.length
COLOR_SUPPORT=0
INFOBAR_SUPPORT=0
COPYPASTE_SUPPORT=0
HELPTEXT_SUPPORT=0
FILEDIALOG_SUPPORT=0
EXAMPLE_TUNE_SUPPORT=0
PLAYABLE_EXPORT_SUPPORT=0
;PLAYABLE_IMPORT_SUPPORT=0
 RELOCATION_SUPPORT=0 ;depends on PLAYABLE_EXPORT_SUPPORT ; required by RUNNABLE_EXPORT_SUPPORT
RUNNABLE_EXPORT_SUPPORT=0
RASTERCROWDING_SUPPORT=0
INSTRUMENT_LOADSAVE_SUPPORT=0
TED_EMULATION_BY_SID_SUPPORT=0
TED_SOUND_SUPPORT=1 ;of course use TED on TED-machines :)... if SID-card is used, TEDzakker is not the best one to compose.
HERMIDI_SUPPORT=0

.elsif (MACHINE==1) ;Plus4
MENU_SUPPORT=1
TUNEINIT_SUPPORT=1 ;clear ins./tune, set global patt.length
COLOR_SUPPORT=1
INFOBAR_SUPPORT=1
COPYPASTE_SUPPORT=1
HELPTEXT_SUPPORT=1
FILEDIALOG_SUPPORT=1
EXAMPLE_TUNE_SUPPORT=1
PLAYABLE_EXPORT_SUPPORT=1
;PLAYABLE_IMPORT_SUPPORT=0 ;unimplemented yet; kinda goes together with PLAYABLE_EXPORT_SUPPORT and RUNNABLE_EXPORT_SUPPORT (in-place decompression of them)
 RELOCATION_SUPPORT=1
RUNNABLE_EXPORT_SUPPORT=1 ;TED(TMF)
 ;TMF_EXPORT_SUPPORT=(EMULATOR>0)?1:0
RASTERCROWDING_SUPPORT=1
INSTRUMENT_LOADSAVE_SUPPORT=1
TED_EMULATION_BY_SID_SUPPORT=0
TED_SOUND_SUPPORT=1
HERMIDI_SUPPORT=MIDI ;(EMULATOR==0)?1:0

.elsif (MACHINE==2) ;C64
MENU_SUPPORT=1
TUNEINIT_SUPPORT=1 ;clear ins./tune, set global patt.length
COLOR_SUPPORT=1
INFOBAR_SUPPORT=1
COPYPASTE_SUPPORT=1
HELPTEXT_SUPPORT=1
FILEDIALOG_SUPPORT=1
EXAMPLE_TUNE_SUPPORT=1
PLAYABLE_EXPORT_SUPPORT=1
;PLAYABLE_IMPORT_SUPPORT=0
 RELOCATION_SUPPORT=1
RUNNABLE_EXPORT_SUPPORT=1
RASTERCROWDING_SUPPORT=1
INSTRUMENT_LOADSAVE_SUPPORT=1
TED_EMULATION_BY_SID_SUPPORT=1 ;by default it makes sound on SID and TED at the same time
TED_SOUND_SUPPORT=0 ;the motivation behind this is to disable TED-writing if wished to avoid writing to $FF0E..$FF12 mem.addresses
HERMIDI_SUPPORT=MIDI ;1
.fi


;machtype=0 ;0:PAL,1:NTSC  ; PAL crystal-osc.frequency: 17.734470MHz, divided by 20 -> mainboard-bus clock: 0.886MHz
TED_PAL_CLOCKFREQ=17734470.00 ;Hz
TED_NTSC_CLOCKFREQ=14318180.00 ;Hz
BUS_PAL_CLOCKFREQ=TED_PAL_CLOCKFREQ/20.00 ;Hz (886723.5Hz)
BUS_NTSC_CLOCKFREQ=TED_NTSC_CLOCKFREQ/20.00 ;Hz (715909Hz)

;Cplus4 info (sound-related are in the player)
.if(MACHINE<2)
ROMoff=$ff3f ;(writing anything to $ff3f disables ROMs)   banksel=$fdd0 ;RAM/ROM banking (?)
ROMon=$ff3e
.else
banksel=$01
.fi
;TED: (sound-related is in player-code)
TED=$FF00 
.if (MACHINE==2)
VIC=$D000
SID=$D400
CIA1=$DC00
CIA2=$DD00
.fi
vmodeyscroll=(MACHINE<2)?  TED+6:VIC+17
cmodexscroll=(MACHINE<2)?  TED+7:VIC+22
keylatch =   (MACHINE<2)?  TED+8:CIA1+1  ;keyboard/joystick input-latch
keymatrix=   (MACHINE<2)?  $fd30:CIA1+0 ;needed to scan keys, not just joysticks
irqstatus=   (MACHINE<2)?  TED+9:VIC+25 ;to refresh in raster-IRQ
irqctrl=     (MACHINE<2)? TED+10:VIC+26 ;default value: $A2, rastercomparator-MSB:bit0, raster-IRQ:bit1, timer-IRQ:bit3/4/6
rasterIRQenable=(MACHINE<2)? $A2:1
rasterIRQdisable=(MACHINE<2)?$A0:0
rastercmp=   (MACHINE<2)? TED+11:VIC+18 ;raster-counter(read) / raster-comparator(write)
.if(MACHINE<2)
curposhi=TED+12
curposlo=TED+13
bitmapaddr=   TED+18
chsetaddr1MHz=TED+19
VRAMaddr=     TED+20
VRAMposhi=    TED+26
VRAMposlo=    TED+27
cursorflashcnt=TED+31
.else
VICbank=CIA2+0
vid_ch_pos=VIC+24
.fi
bgcol    =   (MACHINE<2)? TED+21:VIC+33 ;21...24: background colours 0..3
ECMcapcol=   (MACHINE<2)? TED+22:VIC+34 ;background colour in ECM mode for capital characters
ECMinvcol=   (MACHINE<2)? TED+23:VIC+35 ;background colour in ECM mode for inverted characters
bordcol  =   (MACHINE<2)? TED+25:VIC+32 ;border-colour
vscanpos8=   (MACHINE<2)? TED+28:vmodeyscroll
vscanpos =   (MACHINE<2)? TED+29:rastercmp ;vertical scan-position

tapebuffer=(MACHINE<2)? $0332:$0334
tapebuffer_end=(MACHINE<2)? $03F2:$03FF
instemp=tapebuffer ;temporary place for packed instrument before load/save operation
insnametemp=VRAM+0 ;temporary place for all instrument-names (needed when exporting playable/runnable)

VRAM=(MACHINE<2)? $0C00:$0400 
CRAM=(MACHINE<2)? VRAM-$400:$D800 ;color-RAM and attributes (blink)
ROMstart=(MACHINE<2)? $8000:$A000
rowlen=40
lastcolumn=rowlen-1
rowamount=25
lastrow=rowamount-1

PAL_SCANLINES=$138
PAL_FRAMERATE=50 ;Hz
NTSC_SCANLINES=$106
NTSC_FRAMERATE=60 ;Hz
singlerast=(MACHINE<2)? $0D0:$0FC


;ZEROPAGE (free areas not used by KERNEL: $D1..$E8) -------------------
devnum_zp = (MACHINE<2)? $AE:$BA

.if (EMULATOR!=0)
 mouseZP=$B0 ;same as in TZemu KERNAL.asm and mouse.c!
 mouseZPclick=mouseZP+0 ;mouse-click signal (handshaked/cleared on action)
 mouseZPx=mouseZP+1 ;mouse-click character-coordinate X
 mouseZPy=mouseZP+2 ;mouse-click character-coordinate y
.fi

;zp_min=$D1     ;($f9 serial/parallel IEC-flag is used by the loader, altering it causes freezes)
;zeropage locations used by main loop (display/menu/filedialog):
compzp=$D1
datzp=$D3
tempzp=$D5
diszp=$D7
colorzp=$D9
rowzp=$DB
divzp=rowzp
columnzp=$DC
;zeropage used by filedialog only:
filercolumnzp=$DD
filerlenzp=$DE
filerposzp=$DF

;zeropage to be used by IRQ:
idatzp=$E0
keyzp1=$E2
keyzp2=$E3

;player-routine zeropage pointer (the last zeropage never used by KERNEL, so music-routine can be used beside BASIC-prompt)
playzp_default=$E6 ;($FE would be the last zeropage, but it's cursor-handling work-areas, $FF is ASC/floating work-area)

;packer/relocator zeropage-pointers:
ptnptloadd=$58 ;$57..$70 is used by BASIC-ROM only (for floating point)
ptnpthiadd=$5A
ptninsindexadd=$5C
ptnfxindexadd=$5E
insptloadd=$60
inspthiadd=$62
.if (SUBTUNE_SUPPORT!=0)
seqptloadd=$64
seqpthiadd=$66
.else
orderlistadd=$64
.fi
tunebaseptr=$68
tuneendptr=$6A ;ptrzp=$D0
basediff=$6C

;zeropage for TED-simulations
.if(MACHINE==2)
cposx=$6E
cposy=$6F
cursorflashcnt=$70
.fi
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
inametmptr=$71
.fi


;player & editor - settings -------------------------------------------
;PLAYERADDR=$1800 ;default player address of exported tune - better being automatic
CHANNELAMOUNT=2
repdelay=$d
repspeed=2
pageupdn=8
maxframespeed=8
maxoctave=9
maxnotenum=(maxoctave+1)*12+1
defptnlen=$20 ;(maxptnlen>=$40)? $40: (maxptnlen>=$20)? $20: $10 ;(MACHINE>0)? $40:$20


;settings/theme/config ------------------------------------------------
.if (MACHINE<2)
flashspeed_edit=1 ;20
;flashspeed_jam=0
.fi
bordercolor=(MACHINE<2)? $00:$00
bgcolor=    (MACHINE<2)? $01:$0B
fgcolor=    (MACHINE<2)? ((EMULATOR==1)?$3:$41) : $0F
tuneplaybarcol=(MACHINE<2)? $33:$03
pattplaybarcol=(MACHINE<2)? $44:$04
jamplaybarcol= (MACHINE<2)? $22:$02
mulbarcol=     (MACHINE<2)? $03:$06
pattposx=(HORIZONTAL_ORDERLIST>0)? 2:7 ;pattern-editor dimensions
pattposy=2
pattheight=rowamount-(HORIZONTAL_ORDERLIST*(CHANNELAMOUNT+1))-pattposy-1 ;19
trkposy=0
trkwidth=(HORIZONTAL_ORDERLIST>0)? 11:10 ;track-dimensions
trkcurcolumns=5
trkgapx=(HORIZONTAL_ORDERLIST>0)? 1:0
notecolumnx=2
playposcolumnx=notecolumnx+notewidth
instcolumnx=6
fxcolumnx=(HORIZONTAL_ORDERLIST>0)? 9:8
pnotesubpos=0
pinstsubpos=1
pfxsubpos=3
poscolor= (MACHINE<2)? ((EMULATOR==1)?$2:$21) : $0C
playposcolor=(MACHINE<2)? ((EMULATOR==1)?$B:$6D) : $0E
notecolor=(MACHINE<2)? ((EMULATOR==1)?$5:$71) : $01
mutecolor=(MACHINE<2)? ((EMULATOR==1)?$2:$31) : $0C
inscolor= (MACHINE<2)? ((EMULATOR==1)?$3:$51) : $0F
fxcolor=  (MACHINE<2)? ((EMULATOR==1)?$6:$4C) : $03
wfcolor= (MACHINE<2)? ((EMULATOR==1)?$A:$63) : $0F
frqcolor=(MACHINE<2)? ((EMULATOR==1)?$3:$61) : $0F
volcolor=(MACHINE<2)? ((EMULATOR==1)?$B:$6D) : $0F
olicolor=      (MACHINE<2)? ((EMULATOR==1)?$C:$4E) : $0F
seqplayposcol= (MACHINE<2)? ((EMULATOR==1)?$F:$77) : $01
seqplaymarkcol=(MACHINE<2)? ((EMULATOR==1)?$E:$62) :$0D
.if (HORIZONTAL_ORDERLIST==0)
olicolor2=      (MACHINE<2)? ((EMULATOR==1)?$B:$4D) : $0F
seqplayposcol2= (MACHINE<2)? ((EMULATOR==1)?$5:$71) : $01
seqplaymarkcol2=(MACHINE<2)? ((EMULATOR==1)?$D:$64) : $0D
.fi
datacolor=     (MACHINE<2)? ((EMULATOR==1)?$4:$61) : $01
notewidth=3
oliposx=(HORIZONTAL_ORDERLIST>0)? 1:0 ;orderlist
oliposy=(HORIZONTAL_ORDERLIST>0)? pattposy+pattheight+1 : pattposy
.if (HORIZONTAL_ORDERLIST>0)
oliwidth=rowlen-2
seqdilen=(HORIZONTAL_ORDERLIST>0)? oliwidth/3+1 : oliheight
.else
oliwidth=2+CHANNELAMOUNT+1
oliheight=pattheight
seqdilen=oliheight
.fi

instbwidth=12
instbcurcolumns=6
instbposx=(HORIZONTAL_ORDERLIST>0)? rowlen-instbwidth-1 : rowlen-instbwidth
instbposy=pattposy
instbaddy=4
instbheight=pattheight-4
iwfcolumnx=3
ifreqcolumnx=6
instb_max_note=$80+maxnotenum
ivolcolumnx=10
iwfsubpos=0
inotesubpos=2
ivolsubpos=4
mainhdwidth=(HORIZONTAL_ORDERLIST>0)? 14:20
mainhdposx=(HORIZONTAL_ORDERLIST>0)? rowlen-mainhdwidth : rowlen-20
mainhdposy=0

menufgcol=    (MACHINE<2)? ((EMULATOR==1)?$8:$65) : $03
menubgcol=    (MACHINE<2)? $00:$00
menuhelpcol=  (MACHINE<2)? ((EMULATOR==1)?$1:$11) : $0B
menubarcol=   (MACHINE<2)? $13:$06
menuactivecol=(MACHINE<2)? ((EMULATOR==1)?$9:$75) : $0D

helpfgcol=(MACHINE<2)? ((EMULATOR==1)?$7:$45) : $0D
helpbgcol=(MACHINE<2)? $15:$05

filerfgcol=    (MACHINE==2)? $03: (EMULATOR==1)? $A : ((MACHINE>0)?$63:$61)
filerbgcol=    (MACHINE==2)? $06: (MACHINE>0)? $1D:$00
filerbordercol=(MACHINE==2)? $00:$00
extlen=3
maxfilenamelen=16

exefgcol=(MACHINE<2)? $51:$0C
exebgcol=(MACHINE<2)? $00:$00
exebordcol=exebgcol
exebarcol=(MACHINE<2)? $26:$06
exebarcol2=(MACHINE<2)? $16:$0B
exerast1=(MACHINE<2)? $0CC:$0FE ;single-speed raster-row for executable export

stopmode=0
tuneplaymode=1
pattplaymode=2
fastfwdspeed=(MULTISPEED_ENTRY_SUPPORT!=0)? 6:4

exitmode_noexit=0
exitmode_justlaunch=1
exitmode_softrestart=2
exitmode_restart=3

reloc_hi_min=$02
reloc_hi_max=$FC

