;--------------------------------
irq		pha				;store sensitive registers and maybe bank status
		txa
		pha
		tya
		pha

playbar ldx #(MACHINE<2)? ((EMULATOR>0)? 1:7) : 11 ;beautify flicker
        dex
        bpl *-1   

.if (RUNNABLE_EXPORT_SUPPORT>0)
        lda playmode
        cmp #tuneplaymode ;if exiting playback, throw away the measurement
        beq +
        jsr resetMeas
.fi
+
        ldy fspdcnt
        bne multspd
singspd lda #jamplaybarcol 
        ldx playmode
        beq +
        lda #tuneplaybarcol
+       cpx #pattplaymode
        bne +
        lda #pattplaybarcol
+       sta bordcol
        lda playmode
        ;cmp #stopmode
        bne fastfwd ;normply
        jsr player.playsnd ;jamPLAY
        jmp +
fastfwd lda #selfmod
        beq normspd
        lda #fastfwdspeed-1
        sta ffwdcnt
-       jsr player.playsnd ;PLAY ;edplay
        jsr countTime
        dec ffwdcnt
        bne -
normspd jsr player.playsnd ;PLAY ;edplay
        jsr countTime
        .if (RUNNABLE_EXPORT_SUPPORT>0)
        jsr regTime
        .fi
+       lda #bordercolor
        sta bordcol

.if (HERMIDI_SUPPORT>0)
        lda HerMIDIswitch   
        beq +
        jsr MIDIcall        
.fi
+       jsr keyer ;can take a longer time (e.g. insert/del/copy in pattern)

        lda jamnote+1
        sta prvnote+1

        jsr dispcursor

        lda followmode
        beq +
        jsr followplay
+       

cflash .if (MACHINE<2)
;        lda #flashspeed_edit
        ldy jammode
        bne chfrspd ;beq +
        lsr cursorflashcnt ;lda #flashspeed_jam
;+       clc
;        adc cursorflashcnt
;        bcc +
;        lda #$ff ;make sure the flash-overflow appens so the cursor changes state and doesn't disappear
;+       sta cursorflashcnt ;$ff1f
       .else
        lda cursorflashcnt
        ldy jammode
        beq +
        lsr
+       and #$0f
        tay
        lda curcolors,y
        sta $d027
        inc cursorflashcnt
       .fi
 
chfrspd ldy tuneheader.framespd
        cpy #2
        bpl +
        jmp retirq
+       dey
        sty fspdcnt
        jmp nextrst

multspd lda #mulbarcol
        sta bordcol
.if (MULTISPEED_ENTRY_SUPPORT==0)
        lda playmode
        ;cmp #stopmode
        bne chkffwd ;normply
        jsr player.playsnd ;jamPLAY
        jmp +
chkffwd lda fastfwd+1
        beq normply
        lda #fastfwdspeed-1
        sta ffwdcnt
-       jsr player.playsnd ;PLAY ;edplay
        dec ffwdcnt
        bne -
.fi
normply jsr (MULTISPEED_ENTRY_SUPPORT!=0) ? player.playmul : player.playsnd   ;player.MULPLAY
+       lda #bordercolor
        sta bordcol

advarst dec fspdcnt
        bne nextrst
mulsend ldx #<singlerast
        stx rscntst+1
        lda #>singlerast
        sta rscn8st+1
        jmp wrirast

nextrst ldy tuneheader.framespd
        lda fspdtable,y
.if (RASTERCROWDING_SUPPORT>0)
        bit mspdmod+1
        bpl +
        lda fspdtable2,y
+
.fi
        clc
        adc rscntst+1
        sta rscntst+1
        lda rscn8st+1
        adc #0 ;add Carry
        sta rscn8st+1
        cmp #>PAL_SCANLINES
        bcc chkover
        lda rscntst+1
        sec
        sbc #<PAL_SCANLINES
        bcc chkover
        sta rscntst+1
        lda #0
        sta rscn8st+1
chkover lda rscntst+1 ;rastercmp ;check if the rasterline is over (by keyer) and need to set the next
        sta rscnst2+1
        lda rscn8st+1
        sta rsc8st2+1
        ldy vscanpos
        sty vspstor+1
        lda vscanpos8
.if (MACHINE==2)
        asl ;bit7 to Carry
        rol ;Carry to bit1
.fi
        and #1
        sta vsp8sto+1
        bne rsoffst    ;cmp #>singlerast ;bcc/bcs
.if (MACHINE<2)
        cpy #<singlerast
        bcc rscnst2
.else
        ldy rsc8st2+1
        bne advarst 
        beq rscnst2
.fi
rsoffst ldy rsc8st2+1
        bne rscnst2 ;cmp #>singlerast ;bcc/bcs
        ldy rscnst2+1
        cpy #<singlerast
        bcs rscnst2
        lda #<PAL_SCANLINES
        clc
        adc rscnst2+1
        sta rscnst2+1
        lda rsc8st2+1
        clc
        adc #>PAL_SCANLINES
        sta rsc8st2+1
rscnst2 lda #selfmod
        sec
        sbc #4 ;safety-zone (to have enough gap for new upcoming raster-IRQ)
        bcs vspstor
        eor #$FF
vspstor cmp #selfmod
rsc8st2 lda #selfmod
vsp8sto sbc #selfmod
        bcs rscntst
        jmp advarst
rscntst ldx #selfmod
rscn8st lda #selfmod
wrirast stx rastercmp
.if (MACHINE<2)
        ora #rasterIRQenable
        sta irqctrl
.else
        lsr ;bit0 to Carry
        ror ;Carry to bit7
        ora #$1B
        sta vmodeyscroll
.fi

retirq  lda #$FF ;lda #2 ;reset raster-IRQ bit
        sta irqstatus
		pla
		tay
		pla
		tax
		pla
		rti

dummynmi pha				;store sensitive registers and bank status
		txa
		pha
		tya
		pha         
        .if (MACHINE==2)
        ldy currwin
        jsr pageup
        .fi
        jmp retirq


countTime
FramCnt ldy #0 ;selfmod
        iny
        cpy #PAL_FRAMERATE ;50
        bcc updFrCt
        ldy #0
;        inc playtime+0
;        bne +
;        inc playtime+1
+       sed
        lda seconds
        clc
        adc #1
        sta seconds
        cmp #$60
        bne updFrCt
        lda #0
        sta seconds
        lda minutes
        clc
        adc #1
        sta minutes
updFrCt cld
        sty FramCnt+1
        rts

.if (RUNNABLE_EXPORT_SUPPORT>0)
regTime lda FullyPlayed
        beq noTiReg
prevFuP lda #1 ;selfmod
        bne noTiReg
        lda cursubtune
        asl
        tay
        sed
        lda seconds ;round upwards (add 1 second to playtime in BCD-mode)
        clc
        adc #1
        tax
        cpx #$60
        lda minutes
        bcc +
        adc #0 ;add Carry (1)
        ldx #0
+       cld
        cpy #0
        bne + ;register only subtune0 into workfile-header
        sta tuneheader.playtime0+0 ;minutes
        stx tuneheader.playtime0+1 ;seconds
+       sta SubtuneDurationsBCDminSec+0,y ;(EXEstarter.SubtuneDurations-BASIC_START)+EXEstarter+0,y
        txa
        sta SubtuneDurationsBCDminSec+1,y ;(EXEstarter.SubtuneDurations-BASIC_START)+EXEstarter+1,y
noTiReg lda FullyPlayed
        sta prevFuP+1
        rts
resetMeas lda #1
        sta FullyPlayed
        sta prevFuP+1
        rts
SubtuneDurationsBCDminSec .fill maxsubtuneamount*2, $00 ;minute&second in BCD-form, will be converted into EXEstarter.SubtuneDurations on export
.fi


followplay
        ldx #CHANNELAMOUNT-1
follplp lda playmode
        cmp #pattplaymode
        beq +
        lda player.seqcnt,x
        bmi cntfltr
+       lda playerpatt,x ;currpatt,x
        beq cntfltr
        cmp #maxptnamount+1
        bcs cntfltr
        sta currptn,x
        tay
        lda ptnlen,y
        sec
        sbc #pattheight
        bcc +
        sta flplsto+1
        lda playerpcnt,x ;pattcnt,x
        bmi cntfltr
        sec
        sbc #pattheight/2
        bcc +
flplsto cmp #selfmod
        bcc ++
        lda flplsto+1
        jmp ++
+       lda #0
+       sta ptnindex,x
cntfltr dex
        bpl follplp
        jsr getcurtrk
        lda playmode
        cmp #pattplaymode
        beq +
        lda player.seqcnt,y
        bmi ++
+       lda playerpcnt,y ;pattcnt,y
        sec
        sbc ptnindex,y
        bmi +
        sta curwinposy+ptnwin
+       rts

fspdtable .byte 0,<PAL_SCANLINES
          .for i=2,i<=maxframespeed,i=i+1
            .byte round(PAL_SCANLINES/i)
          .next

.if (RASTERCROWDING_SUPPORT>0)
fspdtable2 .byte 0,<PAL_SCANLINES
          .for i=2,i<=maxframespeed,i=i+1
            .byte round((PAL_SCANLINES-200-10)/(i-1))
          .next
.fi
