;============================ keyhandler ===============================
keyer   jsr shcbget		;shift & CBM key requester

		lda #7
		sta keyzp2
keylp1	ldy keyzp2
		lda keyrows,y
		sta keymatrix
        sta keylatch
		lda keylatch
		cmp #$ff
		beq skiprow
		ldx #7
keylp2	ldy keyzp2
		lda keylatch
		and keycols,x
		bne nextkey
		stx keyzp1
		tya
		asl
		asl
		asl
		clc
		adc keyzp1
		asl ;x2 (.word)
		tay
		
		cpy #15*2    	;Left Shift?   -not to count shift/cbm keys now, done already in 'shcbget'
		beq nextkey		;check next
		cpy #61*2		;C= key?
		beq nextkey		;check next
        .if (MACHINE==2)
		cpy #52*2   	;Right-Shift?
		beq nextkey		;check next
        .fi
zprvkey	cpy #selfmod	;self-written - compare previous key to current, if different, reset repeat-counter
		beq +			;if the same key is pressed, no counter-reset
		ldx #repdelay	;no pressed key, repeatcounter resets
		stx repecnt		;using X to preserve A
+		sty zprvkey+1
		
		ldx keyermode ;ldx currwin	;name-typing mode?
        ;cmp #keymode_editor
        beq edikeys ;cpx #inamewin
cmenuky	cpx #keymode_menu ;lda menumode
		bne +;beq +
        jmp (MENU_SUPPORT>0)? menukeyer:retukey
+       jmp nametyper
		
edikeys	lda keyjmp+0,y
		sta keyJump+1
		lda keyjmp+1,y
		sta keyJump+2
.if (INFOBAR_SUPPORT>0)
 .if (HORIZONTAL_ORDERLIST>0)
        lda editinf+1
 .else
editinf lda #selfmod
 .fi
        beq keyJump
        jsr delinfo
.fi
keyJump	jmp dummykey	;self-written - jump
nextkey	dex
		bpl keylp2
skiprow	dec keyzp2
        bmi +
		jmp keylp1
+
nokey	
.if (EMULATOR!=0)
        lda mouseZPclick
        beq noMouse
        lda #0 ;acknowledge/handshake
        sta mouseZPclick
        lda mouseZPx
        ldy mouseZPy
        bpl +
        lda #inswin
        sta currwin
        jmp gotoMen
+       cpy #24
        bcs noMouse
        cmp #27
        bcs chkins
chkpatt sbc #7-1 ;cmp #7
        bcs chtrack
        cpy #2
        bcc +
;        adc #7-2 ;sbc #2-1
;        bcs +
;        lda #0
;+       and #3
;        sta curwinposx+oliwin
        dey
        dey
        sty curwinposy+oliwin
+       lda #keymode_editor ;instrument-namer caught exit-signal
        sta keyermode
        jmp gotooli
chtrack sbc #17-7 ;cmp #17 ;19
        lda #0
        tax
        bcc +
        lda #trkcurcolumns
        ldx #1
+       cpy #2
        bcs +
        jmp muteSub
+       sta curwinposx+ptnwin
        dey
        dey
        sty curwinposy+ptnwin
        jmp gonampt ;gotoptn
chkins  tya
        sbc #6 ;4 ;cpy #4
        bcc +
        sta curwinposy+inswin
        jmp exitina ;gotoins
+       jmp goiname
noMouse
.fi
.if (HERMIDI_SUPPORT>0)
        lda HerMIDIswitch
        beq +
MIDIsig lda #selfmod ;MIDIsig+1
        bne retukey ;++
.fi
+       lda #repdelay	;no pressed key, repeatcounter resets
		sta repecnt
		ldx #0
		stx fastfwd+1
+       lda playmode
        bne retukey
jamnote	lda #selfmod  ;0 already?
        beq retukey ;bne endnote      
;.if (HERMIDI_SUPPORT>0)
;        lda HerMIDIswitch
;        beq endnote
;MIDIsig lda #selfmod ;lda #0 ;lda prvnote+1 ;detect 1st frame of key-release
;        bne retukey ;sta jamnote+1 ;beq retukey
;.fi
endnote lda #0
        sta jamnote+1
        ldx #CHANNELAMOUNT-1
-       ldy player.currinst,x
        lda insptlo,y
        sta playzp_default+0
        lda inspthi,y
        sta playzp_default+1
        ;lda #cmd_rts
        ;sta player.return0
        jsr player.setgoff
        ;lda #cmd_nop
        ;sta player.return0
        dex
        bpl -
retukey rts

nametyper sta goediky+1
		lsr
		tay
        ;lda shiftsig
        ;ora cbmsig
        ;bne retnamt
		lda keychr,y	;(from datatables.inc)
        sta astore8+1
		beq retukey	;gonextk	;no process if 0 
.if (FILEDIALOG_SUPPORT>0)
        ldx keyermode ;ldy currwin
        cpx #keymode_filer ;cpy #inamewin ;file-dialog?
        bne +
		jsr repeatex
        lda astore8+1
        jmp filedialog.filenamer
.fi
+       cpy #55 ;slash-key? (page up/down)
        beq goediky
        cpy #(MACHINE<2)? 40:7 ;cursor down?
        beq goediky
        .if (MACHINE<2)
        cpy #48 ;cursor left?
        beq goediky
        .fi
        cpy #(MACHINE<2)? 51:2 ;cursor-right?
        beq goediky
        cpy #0 ;del-key?
        beq goediky
        .if (MACHINE==2)
        cpy #48 ;Pound (Insert in Vice)
        beq goediky
        .fi
        cpy #(MACHINE<2)? 57:$33 ;home-key?
        beq goediky
        cpy #(MACHINE<2)? $36:$28 ;plus-key?
        beq goediky
        cpy #(MACHINE<2)? $2E:$2B ;minus-key?
        beq goediky
        cmp #$80 
        bcc typechr  ;type character if $01..$7F
        cmp #$C0
        bcc retukey ;gonextk ;no process if $00 or $80..$BF
exitina lda #keymode_editor ;instrument-namer caught exit-signal
        sta keyermode
        jmp gotoins
typechr jsr repeatex
        jsr getcurinsaddr
astore8 lda #selfmod
        ;and #$3F ;transform shifted characters to normal
        sta (idatzp),y
        jmp crsrrig
goediky ldy #selfmod
        jmp edikeys

repeatex				;repeat-counter routine, return only if repeat can be done (shouldn't affect X or Y registers)
		lda repecnt		;keyrepeat-counter
		bne norsrep		;check, if repeat counter is 0
		lda #repspeed	;default repeat-speed 2
		sta repecnt		;if 0, reset counter to repeatspeed 2
noret	pla 			;getting back Program-counter from stack? (injected by Soci)
		pla				;causing '2-level rts'?
		rts				;repeat not allowed here
norsrep cmp #repdelay	;check, of repeat counter is initial value (repeatspeed 1)
		bne repcan		;if no, then just decrease the repeat counter
		dec repecnt		;if yes, decrease by one, and reset Z-flag - repeat possible
		rts				;repeat allowed here
repcan	dec repecnt
		bne noret		;if reaches 0, a repeat occurs, next round will reset to speed 2
		rts				;repeat allowed here
repecnt	.byte 0

shcbget	ldx #0			;get status of SHIFT and CBM keys
		stx shiftsig
		stx cbmsig
		ldy #(MACHINE<2)? 1:2
-		lda modkeyc,y
        sta keymatrix
		sta keylatch
		lda keylatch
		and modkeyr,y
		bne +
		inc shiftsig,x
+		dey
		bne +
		inx
+		bpl -
		rts
shiftsig	.byte 0
cbmsig  .byte 0 ;strictly be right after shiftsig (indexing by shcbget)

.if (MACHINE<2)
modkeyc .byte $7f,$fd;columns of CBM, SHIFT
modkeyr .byte $20,$80;rows of CBM, SHIFT
.else
modkeyc .byte $7f,$bf,$fd;columns of CBM, Right-SHIFT, Left-Shift
modkeyr .byte $20,$10,$80;rows of CBM, Right-SHIFT, Left-Shift
.fi

keyjmp .block ;keyboard-jumptable                                             ;- 01 - 02 - 04 - 08 - 10 - 20 - 40 - 80 ---
 .word keyDel  ,keyRet  ,key02j  ,keyHlpf7,key04j  ,key05j  ,key06j  ,key07j  ; DEL |RETU|poun|HELP|F1F4|F2F5|F3F6| @  |fe
 .word key3sub ,keyWsub ,keyAsub ,key4sub ,keyZsub ,keySsub ,keyEsub ,nextkey ;  3  | W  | A  | 4  | Z  | S  | E  |Shft|fd
 .word key5sub ,keyRsub ,keyDsub ,key6sub ,keyCsub ,keyFsub ,keyTsub ,keyXsub ;  5  | R  | D  | 6  | C  | F  | T  | X  |fb
 .word key7sub ,keyYsub ,keyGsub ,key8sub ,keyBsub ,keyHsub ,keyUsub ,keyVsub ;  7  | Y  | G  | 8  | B  | H  | U  | V  |f7
 .word key9sub ,keyIsub ,keyJsub ,key0sub ,keyMsub ,keyKsub ,keyOsub ,keyNsub ;  9  | I  | J  | 0  | M  | K  | O  | N  |ef
 .word key28j  ,keyPsub ,keyLsub ,key2Bj  ,keyDot  ,keyColon,key2Ej  ,keyComma; crdn| P  | L  |crup| .  | :  | -  | ,  |df
 .word key30j  ,keyStar ,keySeCol,key33j  ,key34j  ,keyEqual,key36j  ,keySlash; crle| *  | ;  |crri|ESC | =  | +  | /  |bf
 .word key1sub ,key39j  ,keyCtrl ,key2sub ,keySpace,nextkey ,keyQsub ,keyStop ;  1  |HOME|CTRL| 2  |SPC | C= | Q  |stop|7f
;keyboard-compatibility list/layer between C64 and C264 models
key02j=(MACHINE<2)? keyPound:keyRiC64 ;keyCuRi
key04j=(MACHINE<2)? keyf1f4:keyf1f2
key05j=(MACHINE<2)? keyf2f5:keyf3f4
key06j=(MACHINE<2)? keyf3f6:keyf5f6
key07j=(MACHINE<2)? keyAt:keyDnC64 ;keyCuDn
key28j=(MACHINE<2)? keyCuDn:keyPlus
key2Bj=(MACHINE<2)? keyCuUp:keyMinus
key2Ej=(MACHINE<2)? keyMinus:keyAt
key30j=(MACHINE<2)? keyCuLe:keyPound ;pound is used in Vice X64 as "Insert"
key33j=(MACHINE<2)? keyCuRi:keyHome
key34j=(MACHINE<2)? keyEsc:nextkey ;right-shift on C64
key36j=(MACHINE<2)? keyPlus:pgdown ;no up-arrow on Plus4, but it's still usable as PageUp/Dn beside RESTORE-key in VICE X64)
key39j=(MACHINE<2)? keyHome:keyEsc
;(RESTORE key on C64 would be handled from NMI of dummyIRQ, usable as PageUp/Dn beside up-arrow key in VICE)
.bend

;.enc screen ;.enc namechars
;.cdef "AZ",$40, "09"
keychr .block
       .byte fdel, facc, fk02, fexi, fdir, fpdn, fpdn, fk07
       .byte "3" , "W" , "A" , "4" , "Z" , "S" , "E" ,  0  
       .byte "5" , "R" , "D" , "6" , "C" , "F" , "T" , "X"  
       .byte "7" , "Y" , "G" , "8" , "B" , "H" , "U" , "V"  
       .byte "9" , "I" , "J" , "0" , "M" , "K" , "O" , "N"  
       .byte fk28, "P" , "L" , fk2B, "." , ":" , fk2E, ","
       .byte fk30, $00 , ";" , fk33, fk34, "=" , fk36, "/" ;$00
       .byte "1" , fk39, ftab, "2" , " " ,  0  , "Q" , fexi 
;compatibility list for file-dialog controls
fk02=(MACHINE<2)?  $00:fcri ;pound is not used on plus4
fk07=(MACHINE<2)?  $00:fcdn
fk28=(MACHINE<2)? fcdn:"+"
fk2B=(MACHINE<2)? fcup:"-"
fk2E=(MACHINE<2)?  "-":$00 ;"@"
fk30=(MACHINE<2)? fcle:fins ;Pound-key in VICE emulator is bound to 'insert' by default
fk33=(MACHINE<2)? fcri:fhom
fk34=(MACHINE<2)? fexi: 0 ;right-Shift
fk36=(MACHINE<2)?  "+": 0 ;'up-arrow' (might be used as page-up on C64, but there's no such function in file-dialog)
fk39=(MACHINE<2)? fhom:fexi
;.enc none
;file-dialog/name-typer control-signals ;value $00 and $80..$BF are ignored by instrument-nametyper, $Fx exits nametypers, and are controls for filenamer
fdel=$80 ;delete one character back
fcdn=$81 ;cursor-down
fcup=$82 ;cursor-up
fcle=$83 ;cursor-left
fcri=$84 ;cursor-right
fhom=$85 ;home (beginning of field)
fins=$86 ;insert (no Insert key, only 'pound' in VICE can be used)
fdir=$F8 ;directory read
fpdn=$F9 ;page-down in directory (next screen-chunk of filelist)
ftab=$FA ;tabulating in file-dialog between subwindows
fexi=$FE ;exit
facc=$FF ;accept value
.bend


keycols .byte $01,$02,$04,$08,$10,$20,$40,$80
keyrows .byte $fe,$fd,$fb,$f7,$ef,$df,$bf,$7f



;=============== key subroutines (navigation,settings) =================
winposxmax .byte trkcurcolumns*CHANNELAMOUNT-1, (HORIZONTAL_ORDERLIST>0)? seqdilen*2-1 : CHANNELAMOUNT*2-1, instbcurcolumns-1, instbwidth-1
winposymax .byte pattheight-1, (HORIZONTAL_ORDERLIST>0)? CHANNELAMOUNT-1 : seqdilen-1
           .byte (instbheight<=maxinstblen)? instbheight-1:maxinstblen-1 ,0

keySpace ;toggle jamming/editing  /  set playmark in orderlist (Shift)  /  play pattern from cursor-position (Shift)
        jsr repeatex
        lda shiftsig
        bne chpospl
        lda cbmsig
        bne setmark
        lda jammode
        eor #1
        sta jammode
retSpce rts
chpospl lda currwin
        ;cmp #ptnwin
        bne chpmark
        ldy #$FF ;0
        jmp playptn
chpmark cmp #oliwin
        bne chkoffp
allmark ldx #CHANNELAMOUNT-1
-       txa
        jsr getseqa
        sta playmark,x
        dex
        bpl -
        rts
setmark lda currwin
        cmp #oliwin
        bne retSpce
        jsr getcurseqaddr
.if (HORIZONTAL_ORDERLIST>0)
        ldy curwinposy+oliwin
.else
        ldx curwinposx+oliwin
        ldy oliindex,x
.fi
        sta playmark,y
        rts        
chkoffp cmp #inswin
        bne retSpce
        jsr getcurinsaddr
        lda curwinposx+inswin
        lsr
        tax
wftbstartindex=insheadersize
        lda #wftbstartindex ;player.wftbstartindex
        cpx #0
        beq +
        ldy noteonidx,x
        lda (idatzp),y
+       sta tboffst+1
        ldy noteoffidx,x
        lda curwinposy+inswin
        sec
        sbc insindex
        clc
tboffst adc #selfmod
        cmp (idatzp),y
        bne +
        lda #0 ;if exists at cursor-position, reset it
+       sta (idatzp),y
        rts
noteoffidx .byte wftbnoteoffindexpos,freqtbnoteoffindexpos,voltbnoteoffindexpos
noteonidx .byte wftbstartindex,freqtbstartindexpos,voltbstartindexpos
.if (HORIZONTAL_ORDERLIST==0)
oliindex .byte 0,0,1,1
.fi


.if (MACHINE==2)
keyRiC64 lda shiftsig
        beq keyCuRi
        jmp keyCuLe
.fi
keyCuRi jsr repeatex
crsrrig ldx currwin
        lda curwinposx,x
        cmp winposxmax,x
        beq +
        inc curwinposx,x
        rts
+       cpx #oliwin
        bne chptnri
.if (HORIZONTAL_ORDERLIST>0)
olright lda seqindex
        clc
        adc #seqdilen
        cmp #maxseqlen
        beq retCuRi
        inc seqindex
.else
        lda curwinposy+oliwin
        sta curwinposy+ptnwin
        lda #0
        sta curwinposx+ptnwin
        jmp gotoptn
.fi
retCuRi rts
chptnri cpx #ptnwin
        bne retCuRi
        lda #0
        sta curwinposx+inswin
        lda curwinposy+ptnwin
        bne +
        jmp goiname
+       sec
        sbc #instbaddy
        bpl +
        lda #0
+       sta curwinposy+inswin
        jmp gotoins


keyCuLe jsr repeatex
crsrlef ldx currwin
        lda curwinposx,x
        beq +
        dec curwinposx,x
        rts
+       cpx #oliwin
.if (HORIZONTAL_ORDERLIST>0)
        bne chinsle
olileft lda seqindex
        beq retCuLe
        dec seqindex
.else
        beq +
        cpx #ptnwin
        bne chinsle
        lda curwinposy+ptnwin
        sta curwinposy+oliwin
        lda #3
        sta curwinposx+oliwin
        jmp gotooli
+       rts ;jmp gotoins
.fi
retCuLe rts
chinsle lda curwinposy+inswin
        cpx #inswin
        beq +
        cpx #inamewin
        bne retCuLe
        lda #<(0-instbaddy)
+       clc
        adc #instbaddy
        sta curwinposy+ptnwin
        lda winposxmax+ptnwin
        sta curwinposx+ptnwin
gonampt lda #keymode_editor
        sta keyermode
        jmp gotoptn


pgdown  ;jsr repeatex
        ;ldy currwin
        ;jmp pagedown

keySlash ;page up/down (orderlist:left/right)
        jsr repeatex
        ldy currwin
        ldx shiftsig
        bne pageup
pagedown 
.if (HORIZONTAL_ORDERLIST>0)
        cpy #oliwin
        beq cholis0
.fi
        ldy #pageupdn
-       jsr crsrdn
        dey
        bne -
retSlas rts
.if (HORIZONTAL_ORDERLIST>0)
cholis0 ldy #pageupdn/2
-       jsr crsrrig
        dey
        bne -
        rts
.fi
pageup  
.if (HORIZONTAL_ORDERLIST>0)
        cpy #oliwin
        beq cholisl
.fi
        ldy #pageupdn
-       jsr crsrup
        dey
        bne -
        rts
.if (HORIZONTAL_ORDERLIST>0)
cholisl ldy #pageupdn/2
-       jsr crsrlef
        dey
        bne -
        rts
.fi


.if(MACHINE==2)
keyDnC64 lda shiftsig
        beq keyCuDn
        jmp keyCuUp
.fi
keyCuDn jsr repeatex
crsrdn  ldx currwin        ;don't use Y register here, needed by page-up/down
        lda curwinposy,x
        cmp winposymax,x
        beq +
        inc curwinposy,x
        rts
+
.if (HORIZONTAL_ORDERLIST==0)
        cpx #oliwin
        bne +
        lda seqindex
        clc
        adc #seqdilen
        cmp #maxseqlen
        beq retCuUp
        inc seqindex
+
.fi
        cpx #ptnwin
        bne chinsdn
ptndown ldx #CHANNELAMOUNT-1 ;ldx currtrk
-       lda ptnindex,x
        clc
        adc #pattheight
        cmp #maxptnlen
        beq +
        inc ptnindex,x
+       dex
        bpl -
        rts
chinsdn cpx #inswin
        bne chinadn
insdown lda insindex
        clc
        adc #instbheight
        cmp #maxinstblen
        bcs retCuDn
        inc insindex
retCuDn rts
chinadn cpx #inamewin
        bne retCuDn
        lda #0
        sta curwinposy+inswin
        lda #keymode_editor
        sta keyermode
        jmp gotoins


keyCuUp jsr repeatex
crsrup  ldx currwin        ;don't use Y register here, needed by page-up/down
        lda curwinposy,x
        beq +
        dec curwinposy,x
        rts
+
.if (HORIZONTAL_ORDERLIST==0)
        cpx #oliwin
        bne +
        lda seqindex
        beq retCuUp
        dec seqindex
+
.fi
        cpx #ptnwin
        bne chinsup
ptnup   ldx #CHANNELAMOUNT-1
-       lda ptnindex,x
        beq +
        dec ptnindex,x
+       dex
        bpl -
        rts
chinsup cpx #inswin
        bne retCuUp ;choliup
insup   lda insindex
        beq retCuUp ;bne +
        ;jmp goiname ;retCuUp
+       dec insindex
retCuUp rts
;choliup cpx #oliwin
;        bne retCuUp
;        jmp gotoptn


keyRet ;enter area, put noteon/noteoff
        jsr repeatex
        lda currwin
        ;cmp #ptnwin ;it's actually 0
        bne cholire
        ldy curwinposx+ptnwin
        lda cbmsig
        beq +
setplen ldx trkselect,y
        ldy currptn,x
        lda curwinposy+ptnwin
        sec ;add 1
        adc ptnindex,x
        sta ptnlen,y
        rts
+       lda shiftsig
        bne putNoteOn ;retkRet ;note-on
        lda trksubpos,y
        cmp #pinstsubpos
        beq callins
        cmp #pinstsubpos+1
        bne chfxcol ;chnotec
callins jsr getcurptnaddr
        lda (idatzp),y
        beq retkRet ;crnextr ;chnotec
        cmp #maxinstamount+1
        bcs retkRet ;crnextr ;retkRet
        sta currins
        jsr newinst
        jmp gotoins
chfxcol cmp #pfxsubpos+1
        bcc chnotec
crnextr jsr crsrlef
        jmp crsrdn
chnotec lda curwinposx+ptnwin
        beq putNoteOff ;retkRet
        cmp #trkcurcolumns
        beq putNoteOff ;retkRet
        rts ;jmp gotooli
cholire cmp #oliwin
        bne chinsre ;retkRet
        lda shiftsig
        beq selptns
selptn  
.if (HORIZONTAL_ORDERLIST>0)
        ldx curwinposy+oliwin
.else
        ldy curwinposx+oliwin
        ldx oliindex,y
.fi
        jsr selpatt
        bcs retkRet
        jmp gotoptn
selptns ldx #CHANNELAMOUNT-1
-       jsr selpatt
        dex
        bpl -
        jmp selptn ;gotoptn
chinsre cmp #inswin
        bne retkRet
        lda curwinposx+inswin
        and #1
        beq retkRet
        jmp crnextr
retkRet rts



putNoteOn lda #noteon
        .byte $2c		;skip
putNoteOff
        lda #noteoff
wnotfx2 ldy jammode
        bne retkRet ;retKeyM
        jmp wnotfx3


selpatt txa
        jsr getseqa
        lda (idatzp),y
        beq dontmov
        cmp #maxptnamount+1
        bcs dontmov
        sta currptn,x
        lda #0
        sta ptnindex,x
        sta curwinposy+ptnwin
        lda trkorigo,x
        sta curwinposx+ptnwin
        clc
        rts
dontmov sec
        rts


keyEsc  lda shiftsig
        beq +
        jsr repeatex
        lda followmode
        eor #1
        sta followmode
        rts
+       lda cbmsig
        beq +
        jsr repeatex
        lda autoflw+1
        eor #1
        sta autoflw+1
        sta followmode
        rts
+       inc fastfwd+1 ;? +fast-forward? / toggle auto follow-play?
        rts

keyStop ;stop/continue playback
        jsr repeatex
stopcont lda playmode
        ;cmp #stopmode
        bne stopply
contply lda playmodestore 
        sta playmode
        lda cbmsig
        sta followmode
        ldx #CHANNELAMOUNT-1
-       lda playinstore,x
        sta player.currinst,x
        ;lda #0
        ;sta stopmutesig,x
        dex
        bpl -
.if (MAIN_VOLUME_SUPPORT!=0)
        lda mainvolstore
        sta player.mainvol+1
.fi 
        rts
stopply lda playmode
        sta playmodestore
        lda #stopmode
        sta playmode
        lda #0
        sta followmode
        sta jamnote+1
        sta prvnote+1
        ldx #CHANNELAMOUNT-1
-       lda player.currinst,x
        sta playinstore,x
        lda #0
        ;sta player.currinst,x
        ;sta player.notevol,x
.if (NOTEVOLUME_FADE_SUPPORT!=0)
        sta player.fadespd,x
.fi
        lda #$FF
        sta stopmutesig,x
        dex
        bpl -
.if (MAIN_VOLUME_SUPPORT!=0)
        lda player.mainvol+1
        sta mainvolstore
        cmp #8 ;if volume is too silent, use 8 (half of the max) as volume to hear the sound
        bcs +
        lda #8
        sta player.mainvol+1
.fi
+       jmp player.silence
        ;rts
playmodestore .byte 0
playinstore .fill CHANNELAMOUNT,0
.if (MAIN_VOLUME_SUPPORT!=0)
mainvolstore .byte $0F
.fi

keyCtrl ;tabulate between tracks (and instrument/orderlist windows)
        jsr repeatex
        ldx shiftsig
        lda currwin
        ;cmp #ptnwin
        bne chinstb
pattab  lda curwinposx+ptnwin
        cpx #0 ;shift?
        beq ptabfwd
ptabbwd cmp #trkcurcolumns
        bpl +
        jmp gotooli ;ptabfwd
+       sec
        sbc #trkcurcolumns
        jmp setptnx
ptabfwd cmp #trkcurcolumns
        bmi +
        jmp gotoins
+       clc
        adc #trkcurcolumns
setptnx sta curwinposx+ptnwin
        rts
chinstb cmp #inswin
        bne cholitb
        cpx #0 ;shift?
        bne +
        jmp gotooli
+       lda #trkcurcolumns
        jsr setptnx ;sta curwinposx+ptnwin
        jmp gotoptn
cholitb cmp #oliwin
        bne retkCtl
        cpx #0 ;shift?
        bne tabinst
        lda curwinposx+ptnwin
        cmp #trkcurcolumns
        bmi +
        jsr ptabbwd
+       jmp gotoptn
tabinst jmp gotoins
retkCtl rts


.if (MACHINE<2)
keyf1f4 ;play / followplay(C=) tune from beginning   /   stop/continue playback (Shift)
        jsr repeatex
        lda shiftsig
        beq playbeg
        jmp stopcont
.else
keyf1f2 jsr repeatex
        lda shiftsig
        beq playbeg
        jmp playmrk
.fi
playbeg lda #0 ;play from beginning
        .if (RUNNABLE_EXPORT_SUPPORT>0)
        sta FullyPlayed
        .fi
playtun sta player.markply+1
        lda cursubtune
        jsr player.initzak ;INIT
        lda #tuneplaymode
        sta playmode
chkflwp ldy #0
autoflw lda #selfmod ;auto-follow? (no need to press CBM-key)
        bne +
        lda cbmsig
        beq ++
+       iny
+       sta followmode
        rts


.if (MACHINE<2)
keyf2f5 ;play / followplay(C=) tune from mark  /  goto/toggle pattern-window (Shift)
        jsr repeatex
        lda shiftsig
        bne togglpt
.else
keyf3f4 jsr repeatex
        lda shiftsig
        bne +
        jmp playpbg
+       jmp stopcont
.fi
playmrk .if (RUNNABLE_EXPORT_SUPPORT>0)
        jsr resetMeas
        .fi
        lda #1 ;play from mark
        jmp playtun
togglpt lda currwin
        ;cmp #ptnwin
        beq gotooli
gotoptn lda #ptnwin
        sta currwin
        rts
    
 
.if (MACHINE<2)
keyf3f6 ;play / followplay(C=) pattern  /  toggle orderlist/patternwindow (Shift)
        jsr repeatex
        lda shiftsig
        bne toggoli
.else
keyf5f6 jsr repeatex
        lda shiftsig
        bne +
        jmp togglpt
+       jmp toggoli        
.fi
playpbg ldy #0 ;<(-1)
playptn sty chplbeg+1
        lda #pattplaymode
        sta playmode
        jsr player.softini
        ldx #CHANNELAMOUNT-1
        lda #cmd_rts
        sta player.return0
ptplylp lda currptn,x
        sta player.currpatt,x
        lda #0
        sta player.pattcnt,x ;jsr rnewptn
        ;sta player.currinst,x ;init, 'readptn' will fill it
chplbeg lda #selfmod
        beq ptlpend
-       lda #0 ;better silencing previous note's tail, we only need to get instruments
        sta player.currnote,x
        ldy trkselect,x
        lda curwinposy+ptnwin
        clc
        adc ptnindex,y
        cmp player.pattcnt,x ;jsr rnewptn
        beq ptlpend
        bcc ptlpend
        lda #cmd_rts
        sta player.return0
        jsr player.readptn
        lda #cmd_nop
        sta player.return0
        jmp -
ptlpend dex
        bpl ptplylp
        lda #cmd_nop
        sta player.return0
        jsr player.softini
        jmp chkflwp
toggoli lda currwin
        cmp #oliwin
        beq gotoptn
gotooli lda #oliwin
        sta currwin
        rts


keyHlpf7 ;toggle instrument-window/patternwindow  /  menu 
        jsr repeatex
        lda shiftsig
       .if (MACHINE<2)
        bne toggins 
       .else
        beq toggins
       .fi
gotoMen lda #keymode_menu ;inc menusig+1
        sta keyermode
.if (MENU_SUPPORT==0)
        ldx #0
 .if (INSTRUMENT_LOADSAVE_SUPPORT>0)
        lda currwin
        cmp #inswin
        beq +
        ldx #2
 .fi
+       lda cbmsig
        beq +
        inx
+       stx filmode+1
.fi
        rts
toggins lda currwin
        cmp #inswin
        bne gotoins
        jmp gotoptn
gotoins lda #inswin
        sta currwin
        rts


keyHome  ;HOME
        jsr repeatex
        lda #0
        ldy currwin
cholihm cpy #oliwin
        bne chptihm
        ldx (HORIZONTAL_ORDERLIST>0)? curwinposx,y : curwinposy,y
        beq +
        sta (HORIZONTAL_ORDERLIST>0)? curwinposx,y : curwinposy,y
        rts
+       sta seqindex
        rts
chptihm ldx curwinposy,y
        beq +
        sta curwinposy,y
        rts
+       cpy #ptnwin
        bne chinshm
        ldy #CHANNELAMOUNT
-       sta ptnindex,y
        dey
        bpl -
retkHom rts
chinshm cpy #inswin
        bne chitbhm
        sta insindex
        rts
chitbhm cpy #inamewin
        bne rethome
        sta curwinposx+inamewin
rethome rts


keyDel  jsr repeatex
        lda shiftsig
        beq delete
        jmp insert
delete  lda currwin
        ;cmp #ptnwin
        bne choldel
        jsr getcurtrk
        ldx #pnotesubpos ;note-column
        jsr delptco
        ldx #pinstsubpos ;ins-column
        jsr delptco
        ldx #pfxsubpos ;fx-column
        ;jmp delptco
delptco jsr getptna
setdlen sta dlensto+1
        lda cbmsig
        beq dlensto
        lda #0
        jmp filend3
dlensto cpy #selfmod
        beq fillend
        iny
        lda (idatzp),y
        dey
        sta (idatzp),y
        iny
        bne dlensto
fillend lda #0
filend2 dey
filend3 sta (idatzp),y
        rts
choldel cmp #oliwin
        bne chitdel
        jsr getcurseqaddr
        lda #maxseqlen
        jmp setdlen
chitdel cmp #inswin
        bne delinam ;retdele
        lda cbmsig
        bne dallitb
        jsr getcurinstbaddr
        lda #maxinstblen
        jmp setdlen
dallitb ldx #iwfsubpos
        jsr delinco
        ldx #inotesubpos
        jsr delinco
        ldx #ivolsubpos
        ;jmp delinco
delinco jsr getitba
        lda #maxinstblen
        jmp setdlen
delinam cmp #inamewin
        bne retdele
        jsr getcurinsaddr
        cpy #insnamepos
        beq retdele
-       lda (idatzp),y
        dey
        sta (idatzp),y
        iny
        iny
        cpy #insnamepos+insnamelen
        bne -
        lda #" "
        jsr filend2
        jmp crsrlef
retdele rts
        

insert  lda currwin
        ;cmp #ptnwin
        bne cholins
        jsr getcurtrk
        ldx #pnotesubpos ;note-column
        jsr insptco
        ldx #pinstsubpos ;ins.column
        jsr insptco
        ldx #pfxsubpos ;fxcolumn
        ;jmp insptco
insptco jsr getptna
        sty instart+1
        tay
        dey
instart cpy #selfmod
        beq filstrt
        dey
        lda (idatzp),y
        iny
        sta (idatzp),y
        dey
        bne instart
filstrt lda #0
        sta (idatzp),y 
        rts
cholins cmp #oliwin
        bne chitins
        jsr getcurseqaddr
        sty instart+1
        ldy #maxseqlen-1
        jmp instart
chitins cmp #inswin
        bne insinam
        lda cbmsig
        bne iallitb
        jsr getcurinstbaddr
setista sty instart+1
        ldy #maxinstblen-1
        jmp instart
iallitb ldx #iwfsubpos
        jsr insinco
        ldx #inotesubpos
        jsr insinco
        ldx #ivolsubpos
        ;jmp insinco
insinco jsr getitba
        jmp setista
insinam cmp #inamewin
        bne retinse
        jsr getcurinsaddr
        sty inastrt+1
        ldy #insnamepos+insnamelen-1
inastrt cpy #selfmod
        beq +
        dey
        lda (idatzp),y
        iny
        sta (idatzp),y
        dey
        bne inastrt
+       lda #" "
        sta (idatzp),y
retinse rts


key0sub ldx #$00 ;note / octave 0 (C=)
		.byte $2c		;skip
key1sub ldx #$01 ;note? / mute/unmute channel1 (shift) / octave (C=)
		.byte $2c		;skip
key2sub ldx #$02 ; note /  mute/unmute channel2 (shift) / octave (C=)
		lda shiftsig
		beq octa012
muteSol	jsr repeatex  ;mute/solo tracks
		dex
        bmi retMute 
MuteSub lda mutesolo,x
        eor muteormask,x
       	sta mutesolo,x  
retMute rts
muteormask .byte $10,$60


octa012 lda cbmsig  ;octave selection
		bne setocta
		jmp datawriter


key3sub ldx #$03
		.byte $2c		;skip
key4sub ldx #$04
		.byte $2c		;skip
key5sub ldx #$05
		.byte $2c		;skip
key6sub ldx #$06
		.byte $2c		;skip
key7sub ldx #$07
		.byte $2c		;skip
key8sub ldx #$08
		.byte $2c		;skip
key9sub ldx #$09
setocta	lda cbmsig
		beq +
		jsr repeatex
		stx octave
		rts
+		jmp datawriter


keyAsub ldx #$0A
		lda shiftsig
        ora cbmsig
        beq +
        jsr repeatex
        lda advance
        eor #1
        sta advance
+       jmp datawriter

keyBsub ldx #$0B
godatwr jmp datawriter


keyDsub ldx #$0D ;slide-down (dovetailing?)
		lda shiftsig
        beq +
        jsr repeatex
        lda #slidedn_nfx+defaultslidespd
        jmp wnotfx3
+       jmp godatwr

keyEsub ldx #$0E  ;note / first unused entry? (shift)
        jmp datawriter
        
keyFsub ldx #$0f ;decrement framespeed, hexa value F, note
		lda cbmsig
.if (RASTERCROWDING_SUPPORT!=0)
        beq +
		jsr repeatex
mspdmod lda #0 ;selfmod
        eor #$80
        sta mspdmod+1
        rts
+       lda shiftsig
.else
        ora shiftsig
.fi
		beq godatwr
		jsr repeatex
		ldy tuneheader.framespd
		dey
		bne +
		ldy #maxframespeed
+		sty tuneheader.framespd
		rts
        jmp datawriter


keyGsub	ldx #0+7 ;note / increment framespeed
		lda cbmsig
        ora shiftsig
		bne +
        jmp notewriter
+		jsr repeatex
		ldy tuneheader.framespd
		iny
		cpy #maxframespeed+1
		bmi +
		ldy #1
+		sty tuneheader.framespd
		rts


keyIsub ;Shift+I -> instrument-window
        lda shiftsig
        beq +
        jmp gotoins
+       ldx #12+12+1	;'C' note in 2nd upper octave ;lda #12+12+1	;'C' note in 2nd upper octave
        jmp gonotew


keyKsub
retKeyK rts


keyLsub	ldx #12+2		;'C#' note in upper octave at lower row ;lda #12+3		;'D' note in upper octave at lower row
        lda #legatoon
        ldy #legatooff
        jmp wnotefx


keyMsub ;mute/unmute current track or set multispeed-switch for inst.tables
        lda shiftsig
        beq +
        jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne cimulsp
        ldy curwinposx+ptnwin
        ldx trkselect,y
        jmp MuteSub
+       ldx #0+12		;'H' note in lower octave
        jmp gonotew
cimulsp cmp #inswin
        bne retKeyM
        jsr getcurinsaddr
        lda curwinposx+inswin
        lsr
        tax
        ldy #instcontrolswitchpos
        lda (idatzp),y
        eor mulspmask,x
        sta (idatzp),y
retKeyM rts
mulspmask .byte $20,$40,$80


keyNsub ;Shift+N -> edit instrument-name
        ldx #0+10		;'A' note in lower octave
        lda shiftsig
        beq chnshif ;gonotew
        jsr repeatex
goiname lda #inamewin
        sta currwin
        lda #keymode_insname
        sta keyermode
        rts
chnshif lda cbmsig
        beq gonotew
        jmp cnotemo


keyOsub ;Shift+O -> orderlist
        ldx #12+12+3	;'D' note in 2nd upper octave ;lda #12+2		;'C#' note in upper octave at lower row
        lda shiftsig
        beq gonotew
keyOoli jsr repeatex
        jmp gotooli ;toggoli ;gotooli

        
keyPsub ;pattern-window
        ldx #12+12+5	;'E' note in 2nd upper octave ;lda #12+4		;'D#' note in upper octave at lower row
        lda shiftsig
        beq gonotew
        jmp gotoptn


keySsub	ldx #0+2		;'C#' note in lower octave ;lda #0+3		;'D' note in lower octave
        lda #syncon
        ldy #syncoff
wnotefx sty valuest+1   ;write note-column effect into pattern
        ldy cbmsig
        bne +
		ldy shiftsig
        beq gonotew
        sta valuest+1 
+       jsr repeatex
valuest lda #selfmod
wnotfx3 sta jamnote+1
        jmp wriptno


keyTsub	ldx #12+8		;'G' note in upper octave ;lda #0+7		;'F#' note in lower octave 
        lda shiftsig ;Shift+T -> tone-portamento note-fx 
        beq gonotew
        jsr repeatex ;jmp gotoptn
        lda #portam_nfx+defaultslidespd
        jmp wnotfx3 ;wnotfx2

keyJsub	ldx #0+11		;'A#' note in lower octave ;lda #0+12		;'H' note in lower octave
		lda cbmsig
        beq gonotew
        jsr repeatex
        lda fulljam
        eor #$80
        sta fulljam
        rts

keyHsub ldx #0+9		;'G#' note in lower octave ;lda #0+10		;'A' note in lower octave
.if (HELPTEXT_SUPPORT>0)
		lda cbmsig
        ora shiftsig
        beq gonotew
        jmp ShowHelp
.else
		.byte $2c		;skip        
.fi

keyRsub	ldx #12+6		;'F' note in upper octave ;lda #$ff		
		.byte $2c		;skip
keyYsub	ldx #12+10		;'A' note in upper octave ;lda #0+9	
		.byte $2c		;skip
keyZsub	ldx #0+1		;'C' note in lower octave
		.byte $2c		;skip
keyAt   ldx #12+12+6	;'F' note in 2nd upper octave 
		.byte $2c		;skip
keyColon ldx #12+4		;'D#' note in upper octave at lower row
gonotew	jmp notewriter


keyDot ;increment subtune-number (with C= key)
        ldx #12+3		;'D' note in upper octave at lower row
        lda cbmsig
        beq gonotew
.if (MACHINE>0) ;(SUBTUNE_SUPPORT!=0)
        jsr repeatex
        lda cursubtune
        cmp #maxsubtuneamount-1
        beq +
        inc cursubtune
        jsr setsubt
.fi
+       rts
        
keyComma ;decrement subtune-number (with C=key)
        ldx #12+1		;'C' note in upper octave at lower row
        lda cbmsig
        beq gonotew
.if (MACHINE>0) ;(SUBTUNE_SUPPORT!=0)
        jsr repeatex
        lda cursubtune
        beq +
        dec cursubtune
        jmp setsubt
.else
        rts
.fi
setsubt lda #0
        sta seqindex
        sta (HORIZONTAL_ORDERLIST>0)? curwinposx+oliwin : curwinposy+oliwin
+       lda cursubtune
        jsr player.initzak ;INIT
        ldx #CHANNELAMOUNT-1
-       lda player.currpatt,x
        beq +
        cmp #maxptnamount
        bcs +
        sta currptn,x
        lda #0
        sta ptnindex,x
+       dex
        bpl -
        jmp stopply


keyQsub	ldx #12+1		;'C' note in upper octave
		lda shiftsig
		beq chtroct
        jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne retKeyQ
transDn	lda #<(-1) ;transpose down (-1)
transPt sta trnsadd+1
        jsr getcurtrk
        ldx #pnotesubpos ;note-column
        jsr getptna
        sta trnsend+1
trnsend cpy #selfmod
        beq retKeyQ
        lda (idatzp),y
        beq +
        cmp #maxnotenum
        bcs +
        clc
trnsadd adc #selfmod
        beq +
        cmp #maxnotenum
        bcs +
        sta (idatzp),y
+		iny
        bne trnsend
retKeyQ rts
chtroct lda cbmsig
        bne +
		jmp gonotew
+       jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne retKeyQ
        lda #<(-12)
        jmp transPt


keyWsub ldx #12+3		;'D' note in upper octave 
		lda shiftsig
		beq chCbmW
        jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne retKeyQ
transUp	lda #1
        jmp transPt
chCbmW	lda cbmsig
		bne +
		jmp notewriter
+       jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne retKeyQ
        lda #12
        jmp transPt


keyXsub	ldx #0+3		;'D' note in lower octave
.if (COPYPASTE_SUPPORT>0)
		lda cbmsig
        beq gonotw2
        jsr repeatex
        lda #1 ;signal to delete original in copy-routines
        ldy currwin
        ;cpy #ptnwin
        bne cholicu
        jmp copyPtn
retKeyX rts
cholicu cpy #oliwin
        bne chinscu
        jmp copySeq
chinscu cpy #inswin
        bne retKeyX
        jmp copyIns
.fi

gonotw2 jmp gonotew


keyCsub ldx #$0C ;note / copy(C=/Shift)
.if (COPYPASTE_SUPPORT>0)
		lda cbmsig
        bne +
        jmp cbufend
+       jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne cholico
        lda #0 ;don't delete original
copyPtn sta deltoop+1
        jsr getcurtrk
        ldx #pnotesubpos ;note-column
        jsr getptna
        sty ptnbufdatastart
        sta ptcpend+1
        ldx #0
ptcpend cpy #selfmod
        beq setpdln
        lda (idatzp),y
        sta ptnotebuf,x
        jsr deltoop
        bne ptcpend
setpdln stx firstptnbufdatalen
        stx ptnbufdatalen
        ldx #pinstsubpos ;note-column
        jsr getptna
        ldx #0
-       cpy ptcpend+1
        beq +
        lda (idatzp),y
        sta ptinsbuf,x
        jsr deltoop
        bne -
+       ldx #pfxsubpos ;note-column
        jsr getptna
        ldx #0
-       cpy ptcpend+1
        beq +
        lda (idatzp),y
        sta ptfxbuf,x
        jsr deltoop
        bne -       
+       rts
cholico cmp #oliwin
        bne chinsco
        lda #0 ;don't delete original
copySeq sta deltoos+1
        jsr getcurseqaddr
        sty seqbufdatastart
        ldx #0
-       lda (idatzp),y
        sta seqbuf,x
deltoos lda #selfmod
        beq +
        lda #emptyseqval
        sta (idatzp),y
+       inx
        iny
        cpy #maxseqlen
        bne -
        stx firstseqbufdatalen
        stx seqbufdatalen
        rts
chinsco cmp #inswin ;cmp #inamewin+1 ;inswin/inamewin?
        bne retkeyC ;bpl retkeyC
        lda #0 ;don't delete original
copyIns sta deltooi+1
        jsr getcurinsaddr
        ldy #0
-       lda (idatzp),y
        sta insbuf,y
deltooi lda #selfmod
        beq +
        lda emptyins,y
        sta (idatzp),y
+       iny
        cpy #insbufdatalen
        bne -
retKeyC rts
cbufend lda shiftsig
        bne +
        jmp datawriter
+       lda currwin
        ;cmp #ptnwin
        bne chseqce
        jsr getcurtrk
        lda curwinposy+ptnwin
        clc
        adc ptnindex,y
        sec
        sbc ptnbufdatastart
        bcc retKeyC
        cmp firstptnbufdatalen
        bcs retKeyC
        sta ptnbufdatalen
        rts
chseqce cmp #oliwin
        bne retKeyC
        jsr setseqy
        sec
        sbc seqbufdatastart
        bcc retKeyC
        cmp firstseqbufdatalen
        bcs retKeyC
        sta seqbufdatalen
        rts

deltoop lda #selfmod
        beq +
        lda #0
        sta (idatzp),y
+       iny
        inx
        rts
.else
        jmp datawriter
.fi ;end of COPYPASTE_SUPPORT

keyUsub	ldx #12+12		;'H' (B) note in upper octave ;lda #0+11		;'A#' note in lower octave
		lda shiftsig
        beq +
        jsr repeatex
        lda #slideup_nfx+defaultslidespd
        jmp wnotfx3
+       jmp notewriter

keyVsub	ldx #0+6		;'F' note in lower octave
		lda cbmsig
.if (COPYPASTE_SUPPORT>0)
        bne +
		jmp chptvib ;paste?
+       jsr repeatex
        lda currwin
        ;cmp #ptnwin
        bne cholipa
pastPtn jsr getcurtrk
        ldx #pnotesubpos ;note-column
        jsr getptna
        sta ptpaend+1
        ldx #0
ptpaend cpy #selfmod ;maxptnlen / pattern-length
        beq +
        cpx ptnbufdatalen
        beq +
        lda ptnotebuf,x
        sta (idatzp),y
        inx
        iny
        bne ptpaend
+       ldx #pinstsubpos ;note-column
        jsr getptna
        ldx #0
-       cpy ptpaend+1
        beq +
        cpx ptnbufdatalen
        beq +
        lda ptinsbuf,x
        sta (idatzp),y
        inx
        iny
        bne -
+       ldx #pfxsubpos ;note-column
        jsr getptna
        ldx #0
-       cpy ptpaend+1
        beq +
        cpx ptnbufdatalen
        beq +
        lda ptfxbuf,x
        sta (idatzp),y
        inx
        iny
        bne -
+       rts
cholipa cmp #oliwin
        bne chinspa
        jsr getcurseqaddr
        ldx #0
-       cpy #maxseqlen
        beq +
        cpx seqbufdatalen
        beq +
        lda seqbuf,x
        sta (idatzp),y
        iny
        inx
        bne -
+       rts
chinspa cmp #inswin ;cmp #inamewin+1 ;inswin/inamewin?
        bne retkeyV ;bpl retKeyV
        jsr getcurinsaddr
pastIns ldy #0
-       lda insbuf,y
        sta (idatzp),y
        iny
        cpy #insbufdatalen
        bne -
.else
        beq chptvib
.fi ;end of COPYPASTE_SUPPORT
retKeyV rts
chptvib lda shiftsig
        beq + ;pattern note-column vibrato?
        jsr repeatex
        lda #vibrato_min+defaultvibamp
        jmp wnotfx3 ;wnotfx2
+       jmp notewriter


keySeCol ;semicolon is too close to RETURN key to have a function (maybe combined with Shift/CBM-keys if needed)
        rts

keyMinus ;decrement instrument-number (or octave with C= key)
        jsr repeatex
        lda cbmsig
        beq cdecins
decocta	lda octave
		beq +
		dec octave
+		rts
cdecins lda shiftsig
        bne decpatt
decinst lda currins
        cmp #1
        beq +
        dec currins
+       jmp newinst
decpatt lda currwin
        bne incinst ;retMinu
        ldy curwinposx+0
        ldx trkselect,y
        lda currptn,x  
        cmp #1
        beq retMinu
        dec currptn,x
retMinu rts

keyPlus ;increment instrument-number (or octave with C= key)
        jsr repeatex
        lda cbmsig
        beq cincins
incocta lda octave
		cmp #maxoctave
		bpl +
		inc octave
+		rts
cincins lda shiftsig
        bne incpatt
incinst lda currins
        cmp #maxinstamount ;-1
        beq newinst
        inc currins
newinst lda #0
        sta insindex
        sta curwinposx+inamewin
        rts
incpatt lda currwin
        bne incinst ;retPlus
        ldy curwinposx+0
        ldx trkselect,y
        lda currptn,x
        cmp #maxptnamount
        bcs retPlus
        inc currptn,x
retPlus rts


keyEqual ;(;negate value? - not really relevant as there are no full-range continuous values)
        rts

;freqtb-notemode? 
cnotemo jsr repeatex
		lda notemode
		eor #1
		sta notemode
		rts



keyPound ;insert (in Vice)? ;ldx #12+12+6	;'F' note in 2nd upper octave 
       .if (MACHINE<2)
        rts
       .else
        jsr repeatex
        jmp insert ;rts
       .fi

keyStar ;orderlist? negate value?
        jmp keyOoli ;rts

dummykey rts

