
;=========================== MIDI ROUTINES =============================


.if (HERMIDI_SUPPORT>0)

MIDIcall    ;(A full-blown example can be found in SID-Wizard 1.7 sources/include/midisubs.inc)
        lda #(MACHINE<2)? $11:$0B
        sta bordcol
        lda #0
        sta nOFFcnt+1
        jsr HerMIDI.GetData
EventLp jsr HerMIDI.GetEvent
        bcs rtEvent
        and #$F0 ;eliminate 'channel' info for now
cNoteOn cmp #HerMIDI.MIDI.NoteOn
        bne cNoteOf
        ;lda playmode
        ;bne EventLp
MIDInON inx
        cpx #maxnotenum ;+1
        bcs EventLp
        cpy #0 ;on some keyboards NoteOn vith 0 velocity means Note-Off
        beq NoteOf2
        ;stx jamnote+1
        stx MIDIsig+1
        ;jsr jammer
        jmp EventLp
cNoteOf cmp #HerMIDI.MIDI.NoteOff
        bne chPrChg
        ;lda playmode
        ;bne EventLp
MIDnOFF inx
        cpx #maxnotenum ;+1
        bcs EventLp
NoteOf2 ldy nOFFcnt+1
        txa
        sta nOFFbuf,y
        inc nOFFcnt+1 ;just prescribing it, because new legato-note might come on the same frame
        jmp EventLp
chPrChg cmp #HerMIDI.MIDI.PrgChange
        bne nextEvt
        cpy #1
        bcc EventLp ;nextEvt
        cpy #maxinstamount
        bcs EventLp ;nextEvt
        sty currins
nextEvt jmp EventLp

rtEvent
nOFFcnt ldy #selfmod
        beq doNotON ;diMIDnt
        dey
        lda nOFFbuf,y ;search for noteoff that might arrived for current jamnote
        cmp MIDIsig+1 ;jamnote+1
        bne +
        lda #0
        sta MIDIsig+1
        ;jsr endnote ;done later in 'nokey' part of keyer
+       dec nOFFcnt+1
        bne nOFFcnt
doNotON ldx MIDIsig+1 ;placed AFTER nOFFcnt -> if note is (unlikely) terminated on the same frame, don't start/type it
        beq diMIDnt ;nOFFcnt
        jsr notewr2 ;includes jamming too
diMIDnt ldx MIDIsig+1
        bne +
        ldx #noteoff
+       lda noteCh1,x
        sta VRAM+(instbposy+3)*rowlen+34 ;+VRAM+lastrow*rowlen+34
        lda noteCh2,x
        sta VRAM+(instbposy+3)*rowlen+35 ;VRAM+lastrow*rowlen+35
        lda noteCh3,x
        sta VRAM+(instbposy+3)*rowlen+36 ;VRAM+lastrow*rowlen+36
        lda #bordercolor
        sta bordcol
        rts

nOFFbuf .fill 10,0 ;who has more than 10 fingers that can release on the same 20ms frame? (maybe machines)

HerMIDI .block
INC_SYNCHR = (MACHINE==2) ;if nonzero: synchron-mode READ gets included
INC_ASYNCH = (MACHINE<2)  ;if nonzero: asynchron-mode READ gets included
INC_DIRECT = 0          ;if nonzero:DirectMode READ (DirecRx) gets included
INC_EVENTS = 1          ;if nonzero: 'GetEvent' subroutine gets included
  .include (MACHINE<2)? "HerMIDI-Plus4.asm" : "HerMIDI-C64.asm"
 .bend
.fi
