
;************************** TEDZAKKER PLAYER ***************************
;2023 Hermit Software Hungary (Mihaly Horvath)
;=======================================================================

.weak ;if type not given from outside, 'normal' is the default player to compile
PLAYERTYPE=0
selfmod=0 ;self-modified code default value
MACHINE=1 ;set here, so player.asm can be assembled without setting this from outside, Plus4 is the default machine
CHANNELAMOUNT=2
TED_PAL_CLOCKFREQ=17734470.00 ;Hz
TED_NTSC_CLOCKFREQ=14318180.00 ;Hz
BUS_PAL_CLOCKFREQ=TED_PAL_CLOCKFREQ/20.00 ;Hz (886723.5Hz)
BUS_NTSC_CLOCKFREQ=TED_NTSC_CLOCKFREQ/20.00 ;Hz (715909Hz)
playzp_default=$E6 ;($FE would be the last zeropage, but it's cursor-handling work-areas, $FF is ASC/floating work-area)
maxoctave=9
maxnotenum=(maxoctave+1)*12+1
pattptlo=0
pattpthi=0
fxindexes=0
insindexes=0
insptlo=0
inspthi=0
seqptrlo=0
seqptrhi=0
PLAYER_FOR_EDITOR=0
TED_SOUND_SUPPORT=1
TED_EMULATION_BY_SID_SUPPORT=0
authorinfo_len=40 ;rowlen
orderlist0=$0000 ;just to be independent from editor even with no-subtune
.if (*==0)
*=$2000
player #playerm $2000,0,0 ;standalone
.fi
.endweak

A4_NOTE_FREQ=440.00 ;Hz  (Standard-tuning-compatible:440.00Hz  ;  Verdi-tuning-compatible: 432.76Hz...432.97Hz...433.18Hz)
lowest_pulse_freq_val=$3ff
lowest_pulse_note=10+12*2 ;A-2 ~ 110Hz
inaudible=$3fe


;fine tuning of extra features to have less rastertime/memory-consumption
.if (PLAYERTYPE==0) ;NORMAL/FULL
MULTISPEED_ENTRY_SUPPORT = 1 ;individual routine for multispeed, selectable multispeed for all instrument-tables
 TABLE_MULTISPEED_SEL_SUPPORT = 1 ;depends on multispeed-entry support; to run or not to run different instrument tables in multispeed-calls
FRAME_NOSKIP_SUPPORT = 0 ;don't use rastertime optimization of skipping instrument-table programs / vibrato / slide when new note/pattern/sequence is read on a frame
 FRAMESKIP_NOTEVOL_SUPPORT = 1 ;'depends' on frame-skipping: be able to set note-volume also on the same row as the note
SOUNDSTART_CLICK_SUPPORT = 1 ;click (depending on first row of wf/freq tables) for a very short time: from the beginning of the player till the ghost-register-update at the end of the player-call
 STARTCLICK_VOL_SUPPORT = 1 ;depends on soundstart-click support ;volume of the click is determined by the volume-tablecolumn (and/or notevolume-fx)
TEMPOPROGRAM_SUPPORT = 1 ;funktempo/tempoprogram support
SUBTUNE_SUPPORT = (MACHINE)? 1:0 ;if not set, state of accumulator at init doesn't have any effects, the orderlist/sequence-reading is simplified and has fixed memory location (saves some rastertime)
 SUBTUNE_JUMP_SUPPORT = 0 ;depends on subtune-support, jumping to other subtune from the current orderlist-sequence
MAIN_VOLUME_SUPPORT = 1 ;main volume setting feature
 EXT_MAIN_VOLUME_SUPPORT = 1 ;depends on main-volume support, external volume setting/fading support by a specific call
 MAIN_VOLUME_FADEOUT_SUPPORT = 0 ;depends on main-volume support; fade-out orderlist-effect or external fade-out support
MIXING_MODES_SUPPORT = 1 ;supporting averaging/louder/priorized mixing modes. if not enabled, 'louder' is the default
SYNC_SUPPORT = 1 ;support to synchronize the frequency-counters in every frame (single- and multispeed-call)
PHASE_SUPPORT = 1 ;support to synchronize frequency-counters AND set phase of them at the same time (for pulsewidth simulation)
PACKED_NOP_SUPPORT = 1 ;support the decompression of compressed successive empty rows in patterns (recommended, makes sense only for exported player outside editor)
NOTE_FX_SUPPORT = 1 ;(recommended for smaller footprint) support vibrato/slide/portamento/sync/etc. effects in note-column of pattern
SEQ_FX_SUPPORT = 1 ;support transpose/volume/tempo/tempoprogram/etc. effects in orderlist's sequences
 TRANSPOSE_SUPPORT = 1 ;depends on sequence-effect support; support transpose-effect (called from orderlist)
DETUNE_SUPPORT = 1 ;support detuning of channels (it's independent of slides/vibratos, lasts till next note)
NOTEOFF_TBINDEX_SUPPORT = 1 ;note-off event table-indexes (instrument table-regions to run when a note is released)
TABLE_DELAY_SUPPORT = 1 ;support 00..0F frame-delay values in instrument-tables
NOTEVOLUME_FADE_SUPPORT = 1 ;support volume fade-in/out in volume-table (kinda ADSR-simulation)
;NOTEVOLUME_GAP_SUPPORT = 0 ;support injecting 1-2 frames of silence between consequent notes
LOWFREQ_NOISELOOP_SUPPORT = 1 ;feature: switching to noise-waveform and transposing 3 octaves up automatically to have lower than A-2 notes (utilizing LFSR noise looping artifact)
PORTAMENTO_SUPPORT = 1 ;automatic note-portamento pattern-fx support
VIBRATO_SUPPORT = 1 ;vibrato support (In instrument-tables and patterns)
 VIBRATO_RESTORE_SUPPORT = 1 ;depends on VIBRATO_SUPPORT and PORTAMENTO_SUPPORT ;restore vibrato after portamento automatically?  (legato uses other methods, so its default behaviour is retaining vibratos/slides)
 SLIDES_SUPPRASS_VIB_SUPPORT = 1 ;depends on VIBRATO_SUPPORT ; slide/portamento pattern-effects supprass vibrato-execution in instrument frequency-table
 LEGATO_SUPPRASS_VIB_SUPPORT = 0 ;depends on VIBRATO_SUPPORT ; allow vibrato of instrument-table after legato-effect?
 INCREMENTAL_VIBRATO_SUPPORT = 1 ;depends on VIBRATO_SUPPORT ; a vibrato-type that increments its amplitude by a given value every frame
 DEFAULT_VIBRATO_RATE_SUPPORT = 0 ;if no vibrato was set by instrument-table, an adequate default value is set on new instrument or vibrato-pattern-effect
 GENTLE_VIBRATO_FX_SUPPORT = 1 ;vibrato-amplitude setter pattern effect only prescribes vibrato-amplitude change, and it's performed when vibrato crosses original pitch, therefore no ugly freq.drifting/detune-effect
BALANCED_SLIDE_SUPPORT = 1 ;calculated slide/vibrato which works evenly in all frequency ranges (smaller addition to frequency-value for higher notes, bigger addition in lower ranges)
;ZEROPAGE_RETAIN_SUPPORT = 0 ;save/restore the two used zeropage locations on entry/exit
;(FREQTABLE_SLIDE_SUPPORT = 1 ;became a basic feature - slide support in instrument frequency-table)
;(FASTTEMPO_SUPPORT = 1 ;became a basic feature - if not set, performing sequence/pattern/instrument reading are to be performed on different frames to minimize rastertime-usage peaks, but tempos 0..2 won't work that way)
;(GHOST_REGISTER_SUPPORT = 1 ;(required most of the time) copy data into ghost registers, and write them fast to TED only at the end of current call or beginning of the next call (next frame))
;(TABLE_SPEED_SUPPORT = 0 ;support overall table-speed setting in waveform-table - not so useful as most of the time the tables wouldn't step simultaneausly)
;(VIBRATO_TYPES_SUPPORT = 0 ;vibrate upwards/downvards/incremental - upwards/downwards don't sound too good)
;(TABLE_RESTART_OFF_SUPPORT = 0 ;whether restarting instrument tables on note-starts or not - doesn't make much sense for TED's non-continuous capabilities (lack of PWM/filter))
;(SHORTFRAME_SUPPORT = 0 ;support short-frame signal in waveform-table: on a short frame the wf (and other?) tables are run twice in a call (producing a very short fragment e.g. to have crisp soundstarts)
;(MULTISPEED_PRECALC = 0 ;2nd multispeed-bar calculation is done in main call, only writing ghost to TED when multispeed-part is called (needs ghost-register support))

.elsif (PLAYERTYPE==1) ;MEDIUM
MULTISPEED_ENTRY_SUPPORT = 0
 TABLE_MULTISPEED_SEL_SUPPORT = 0
FRAME_NOSKIP_SUPPORT = 0
 FRAMESKIP_NOTEVOL_SUPPORT = 1
SOUNDSTART_CLICK_SUPPORT = 1
 STARTCLICK_VOL_SUPPORT = 0
TEMPOPROGRAM_SUPPORT = 1
SUBTUNE_SUPPORT = (MACHINE)? 1:0
 SUBTUNE_JUMP_SUPPORT = 0
MAIN_VOLUME_SUPPORT = 1
 EXT_MAIN_VOLUME_SUPPORT = 1
 MAIN_VOLUME_FADEOUT_SUPPORT = 0
MIXING_MODES_SUPPORT = 0
SYNC_SUPPORT = 1
PHASE_SUPPORT = 1
PACKED_NOP_SUPPORT = 1
NOTE_FX_SUPPORT = 1
SEQ_FX_SUPPORT = 1
 TRANSPOSE_SUPPORT = 1
DETUNE_SUPPORT = 1
NOTEOFF_TBINDEX_SUPPORT = 1
TABLE_DELAY_SUPPORT = 1
NOTEVOLUME_FADE_SUPPORT = 1
LOWFREQ_NOISELOOP_SUPPORT = 0
PORTAMENTO_SUPPORT = 1
VIBRATO_SUPPORT = 1
 VIBRATO_RESTORE_SUPPORT = 0
 SLIDES_SUPPRASS_VIB_SUPPORT = 1
 LEGATO_SUPPRASS_VIB_SUPPORT = 0
 INCREMENTAL_VIBRATO_SUPPORT = 0
 DEFAULT_VIBRATO_RATE_SUPPORT = 0
 GENTLE_VIBRATO_FX_SUPPORT = 0
BALANCED_SLIDE_SUPPORT = 0

.elsif (PLAYERTYPE==2) ;LIGHT
MULTISPEED_ENTRY_SUPPORT = 0
 TABLE_MULTISPEED_SEL_SUPPORT = 0
FRAME_NOSKIP_SUPPORT = 0
 FRAMESKIP_NOTEVOL_SUPPORT = 0
SOUNDSTART_CLICK_SUPPORT = 0
 STARTCLICK_VOL_SUPPORT = 0
TEMPOPROGRAM_SUPPORT = 0
SUBTUNE_SUPPORT = (MACHINE)? 1:0
 SUBTUNE_JUMP_SUPPORT = 0
MAIN_VOLUME_SUPPORT = 0
 EXT_MAIN_VOLUME_SUPPORT = 0
 MAIN_VOLUME_FADEOUT_SUPPORT = 0
MIXING_MODES_SUPPORT = 0
SYNC_SUPPORT = 0
PHASE_SUPPORT = 0
PACKED_NOP_SUPPORT = 1
NOTE_FX_SUPPORT = 1
SEQ_FX_SUPPORT = 1
 TRANSPOSE_SUPPORT = 1
DETUNE_SUPPORT = 1
NOTEOFF_TBINDEX_SUPPORT = 0
TABLE_DELAY_SUPPORT = 0
NOTEVOLUME_FADE_SUPPORT = 0
LOWFREQ_NOISELOOP_SUPPORT = 0
PORTAMENTO_SUPPORT = 1
VIBRATO_SUPPORT = 1
 VIBRATO_RESTORE_SUPPORT = 0
 SLIDES_SUPPRASS_VIB_SUPPORT = 0
 LEGATO_SUPPRASS_VIB_SUPPORT = 0
 INCREMENTAL_VIBRATO_SUPPORT = 0
 DEFAULT_VIBRATO_RATE_SUPPORT = 0
 GENTLE_VIBRATO_FX_SUPPORT = 0
BALANCED_SLIDE_SUPPORT = 0

.elsif (PLAYERTYPE==3) ;EXTRA
MULTISPEED_ENTRY_SUPPORT = 1
 TABLE_MULTISPEED_SEL_SUPPORT = 1
FRAME_NOSKIP_SUPPORT = 1
 FRAMESKIP_NOTEVOL_SUPPORT = 0
SOUNDSTART_CLICK_SUPPORT = 1
 STARTCLICK_VOL_SUPPORT = 1
TEMPOPROGRAM_SUPPORT = 1
SUBTUNE_SUPPORT = (MACHINE)? 1:0
 SUBTUNE_JUMP_SUPPORT = 1
MAIN_VOLUME_SUPPORT = 1
 EXT_MAIN_VOLUME_SUPPORT = 1
 MAIN_VOLUME_FADEOUT_SUPPORT = 1
MIXING_MODES_SUPPORT = 1
SYNC_SUPPORT = 1
PHASE_SUPPORT = 1
PACKED_NOP_SUPPORT = 1
NOTE_FX_SUPPORT = 1
SEQ_FX_SUPPORT = 1
 TRANSPOSE_SUPPORT = 1
DETUNE_SUPPORT = 1
NOTEOFF_TBINDEX_SUPPORT = 1
TABLE_DELAY_SUPPORT = 1
NOTEVOLUME_FADE_SUPPORT = 1
LOWFREQ_NOISELOOP_SUPPORT = 1
PORTAMENTO_SUPPORT = 1
VIBRATO_SUPPORT = 1
 VIBRATO_RESTORE_SUPPORT = 1
 SLIDES_SUPPRASS_VIB_SUPPORT = 1
 LEGATO_SUPPRASS_VIB_SUPPORT = 0
 INCREMENTAL_VIBRATO_SUPPORT = 1
 DEFAULT_VIBRATO_RATE_SUPPORT = 1
 GENTLE_VIBRATO_FX_SUPPORT = 1 
BALANCED_SLIDE_SUPPORT = 1

.elsif (PLAYERTYPE==4) ;BARE
MULTISPEED_ENTRY_SUPPORT = 0
 TABLE_MULTISPEED_SEL_SUPPORT = 0
FRAME_NOSKIP_SUPPORT = 0
 FRAMESKIP_NOTEVOL_SUPPORT = 0
SOUNDSTART_CLICK_SUPPORT = 0
 STARTCLICK_VOL_SUPPORT = 0
TEMPOPROGRAM_SUPPORT = 0
SUBTUNE_SUPPORT = 0
 SUBTUNE_JUMP_SUPPORT = 0
MAIN_VOLUME_SUPPORT = 0
 EXT_MAIN_VOLUME_SUPPORT = 0
 MAIN_VOLUME_FADEOUT_SUPPORT = 0
MIXING_MODES_SUPPORT = 0
SYNC_SUPPORT = 0
PHASE_SUPPORT = 0
PACKED_NOP_SUPPORT = 0
NOTE_FX_SUPPORT = 0
SEQ_FX_SUPPORT = 0
 TRANSPOSE_SUPPORT = 0
DETUNE_SUPPORT = 0
NOTEOFF_TBINDEX_SUPPORT = 0
TABLE_DELAY_SUPPORT = 0
NOTEVOLUME_FADE_SUPPORT = 0
LOWFREQ_NOISELOOP_SUPPORT = 0
PORTAMENTO_SUPPORT = 0
VIBRATO_SUPPORT = 0
 VIBRATO_RESTORE_SUPPORT = 0
 SLIDES_SUPPRASS_VIB_SUPPORT = 0
 LEGATO_SUPPRASS_VIB_SUPPORT = 0
 INCREMENTAL_VIBRATO_SUPPORT = 0
 DEFAULT_VIBRATO_RATE_SUPPORT = 0
 GENTLE_VIBRATO_FX_SUPPORT = 0
BALANCED_SLIDE_SUPPORT = 0

.elsif (PLAYERTYPE==5) ;DEMO
MULTISPEED_ENTRY_SUPPORT = 0
 TABLE_MULTISPEED_SEL_SUPPORT = 0
FRAME_NOSKIP_SUPPORT = 0
 FRAMESKIP_NOTEVOL_SUPPORT = 0
SOUNDSTART_CLICK_SUPPORT = 1 ;sound crisp even in single-speed mode
 STARTCLICK_VOL_SUPPORT = 0
TEMPOPROGRAM_SUPPORT = 0 
SUBTUNE_SUPPORT = (MACHINE)? 0:0 ;usually not needed in demos, standalone tunes for parts may be preferred (smaller memory footprint)
 SUBTUNE_JUMP_SUPPORT = 0
MAIN_VOLUME_SUPPORT = 1
 EXT_MAIN_VOLUME_SUPPORT = 1
 MAIN_VOLUME_FADEOUT_SUPPORT = 1 ;good in demos to have automatic fade-out
MIXING_MODES_SUPPORT = 0
SYNC_SUPPORT = 1 ;a demo should sound goond and interesting
PHASE_SUPPORT = 1 ;a demo should have non-conventional sounds
PACKED_NOP_SUPPORT = 1 ;a music in a demo should be as small, as possible
NOTE_FX_SUPPORT = 0
SEQ_FX_SUPPORT = 0
 TRANSPOSE_SUPPORT = 0
DETUNE_SUPPORT = 1 ;essential for solo chorus effect or to simulate roomy ambient
NOTEOFF_TBINDEX_SUPPORT = 0
TABLE_DELAY_SUPPORT = 0
NOTEVOLUME_FADE_SUPPORT = 1 ;drum sounds and epic solos might get a good use of it
LOWFREQ_NOISELOOP_SUPPORT = 0
PORTAMENTO_SUPPORT = 1 ;essential for correct slides to target notes
VIBRATO_SUPPORT = 1 ;essential for more organic, less machinic feel
 VIBRATO_RESTORE_SUPPORT = 0
 SLIDES_SUPPRASS_VIB_SUPPORT = 0
 LEGATO_SUPPRASS_VIB_SUPPORT = 0
 INCREMENTAL_VIBRATO_SUPPORT = 0
 DEFAULT_VIBRATO_RATE_SUPPORT = 0
 GENTLE_VIBRATO_FX_SUPPORT = 0
BALANCED_SLIDE_SUPPORT = 0

.fi



;======================= MUSICDATA SPECIFICATION =======================
;main/common tune-information:
maxsubtuneamount=(MACHINE>0)? 10:1  ;must be a power of 2 (for simple subtune-jump feature restriction) (1 means no subtune-support in editor)
maxptnamount=(MACHINE>0)? 100:8
maxinstamount=(MACHINE>0)? 58:6
tempotable_size=8
defaulttempo=6 ;8
defaultvibrate=2
defaultvibamp=2
defaultslidespd=8
endplayvalue=$80 ;signal-value in orderlist-sequence counter to stop playback on channel


;sequence (orderlist) info:
maxseqlen=(MACHINE>0)? 127:32 ;max. 127 if no subtune-support (128 is too much for the player (readseq) and depacker in editor, 127 is still bearable)
seqendval=$00     ;  00  : end
                  ;01..7F: pattern-number
transpdn_min=$80  ;80..8F: transpose-down
transpup_min=$90  ;90..9F: transpose-up
mainvol_min=$A0   ;A0..AF: set main volume
tempo_min=$B0     ;B0..CF: set track-tempo (consequent tempo-values set a tempoprogram) !!!Not checked for amount, overload fucks player-variable area
tempo_max=$CF     ;D0..DF: Detune (permanent, so no need to duplicate tracks for 'chorus'/'detune'/'phase' kind of effect)
seqdetune_min=$D0 ;E0..EF: fade-out
mfadeout_min=$E0  ;F0..FE: repeat?
                  ;  FF  : jump (index is next byte, above $80: subtune-jump)


;pattern info:
maxptnlen=(MACHINE>0)? (256-ptncolumns)/ptncolumns : 32  ;$54 ;could be higher but then a lot of pointer-handling and indexing would be needed 
ptncolumns=3
;                note-column                 instr.column           fx-column
;             =======================================================================
ptnNOPval=$00   ;   00  : NOP                 00  : NOP              00  : NOP
note_min=1      ; 01..78: note              01..3E: select ins.    01..0F: row-duration (0..F frames) (temporary tempo: shorten/lengthen note/silence)
porta_min=$30   ; ......                      3F  : legato(remem?) 10..1F: slide up
porta_max=$3E   ;   79  : sync-on           .......                20..2F: slide down
legatofx=$3F    ;   7A  : sync-off          .......                30..3F: portamento
;permalega=$40  ;   7B  : legato-on?        ---------------------  ---------------------
syncon=$79      ;   7C  : legato-off?       40..4F: wftable-jmp    40..4F: wftable-jump (e.g. change waveform)
syncoff=$7A     ;   7D  : note-on           50..5F: note-volume    50..5F: note-volume
legatoon=$7B    ;   7E  : note-off          60..6F: voltable-jmp   60..6F: voltable-jump
legatooff=$7C   ; ......                    70..7E: freqtbl-jmp    70..7E: freqtbl-jump (e.g. chord)
noteon=$7D      ;   7F  : gap/stacc.on/off    7F  : staccatto 0/1?   7F  : gap/staccatto on/off?
noteoff=$7E     ; ------------------------  ---------------------  --------------------- 
gap_stacc=$7F   ; 80..8F: vibrato           80..8F: vibrato ampl.  80..8F: vibrato ampl.
slideup_nfx=$90 ; 90..9F: slide up          90..9F: detune(perma.) 90..9F: detune upwards (permanent) (what about phase-setting? wftable-jump allows it though)
slidedn_nfx=$A0 ; A0..AF: slide down        A0..AF: set volume     A0..AF: set volume 
portam_nfx=$B0  ; B0..BF: portamento(next)  B0..BF: set tempo/prg  B0..BF: set tempo / maybe tempoprogram (consequent rows) for track
freqjmp_min=$70 ; ------------------------  ---------------------  ---------------------
packNOP_min=$C0 ; C0..FE: packed NOP        C0..FE: packed NOP     C0..FE: packed NOP (2..$40)
ptnendval=$FF   ;   FF  : end                (FF  : end)            (FF  : end)
detunefx_min=$90
wfjump_min=$40
notevolfx_min=$50
voljump_min=$60


;instrument info:
insnamelen=12 ;instbwidth
insmaindatalen=6
insnamepos=insmaindatalen
insheadersize=insmaindatalen+insnamelen
instbcolumns=3
maxinstblen=(MACHINE>0)? 32:15 ;shouldn't be more than (256-insheadersize)/3
mixingmode_average=0 ;two channels get average-mixed with equal priority (if a channel is silent, the other sets volume directly)
mixingmode_louder=$40 ;the louder channel sets the volume
mixingmode_priority=$80 ;the given channel sets volume directly (2nd channel is priorized if they do it simultaneously)
;main instrument-data: table-startindexes(noteon,noteoff), table-multispeed/restart bits, gap/staccatto
freqtbstartindexpos=0   ;00..01: note-on pointers for freq/volume tables (waveform-table is fix)
voltbstartindexpos=1    ;02..04: note-off pointers for wf/freq/volume tables respectively
wftbnoteoffindexpos=2   ;  05  : multispeed/note-restart/gap bits:  bit7..5: multispeed-voltable($80),multispeed-freqtable($40),multispeed-wftable($20)
freqtbnoteoffindexpos=3 ;                                           bit4..2: restart voltable/freqtable/wftable on note-on event
voltbnoteoffindexpos=4  ;                                           bit1..0: gap between consequent notes (0..3 frames) (usable as staccatto at fast speeds)
instcontrolswitchpos=5
wfmultiswitch=$20  ;  WF/control-table       Frequency-table          Volume-table
                   ;=======================================================================
instbendval=$00    ;    00  : end               00  : end                00  : end
delay_max=$0F      ;  01..0F: delay(NOP)      01..0F: delay(repeat)    01..0F: delay(repeat)
pulsewf_min=$20    ;  10..1F: sync+speed      10..1F: slide up         10..1F: fade in (note vol.envelope slide up)
slidedown_min=$20  ;  20..2F: pulse+speed     20..2F: slide down       20..2F: fade out (note vol.envelope slide down)
fadeout_min=$20    ;  30..3F: sync+pulse+sp   30..3F: detune up        30..3F: set note volume and 'priority' mixing-mode for instrument
detune_min=$30     ;  40..4F: noise+speed     40..5F: rel.note up      40..4F: set note volume and 'louder' mixing-mode for instrument
notevol_min=$30    ;  50..5F: sync+noise+sp     60  : incr.vibrato?    50..5F: set note volume and 'averaging' mixing-mode (envelope 'sustain level') 
noisewf_min=$40    ;  60..6F: silence           61  : ?(shrt/mul/chrd) 60..6F: ?
relnote_min=$40    ;  70..7F: (pulse-sweep?)  62..7F: rel.note down    70..7F: ?
mix_loud_min=$40   ;  80..FE: pulse + PHASE     80  : vibrato (nextb)  8x..7x: tremolo (8x..Cx:amplitude 1..3, x:rate)
mix_avg_min=$50    ;                          81..F8: abs.note C0-H9   D0..DF: ?  (gap/staccatto?)
silence_min=$60    ;                          F9..FE: freq. 3F9..3FE  (E0..FE: jump to 00..1F?) 
reldn_incv_min=$60 ;                            FF  : jump(tgt:next)     FF  : jump (target in next row)
phase_min=$80 ;  FF  : jump (target: next row)                 
vibrato_min=$80    ;                       
sync_bitvalue=$10  ;                          
jumpval=$FF        ; 
slideup_min=$10    ;(wftable nybble2: 0:NOP, 1..E:set tablespeeds/phase, F:short-frame ; vibrato next byte: vol(lonybble)+rate(hinybble))




;=========================== PLAYER CODE ===============================
.weak
TED=$FF00
SID=$D400
.endweak

.if (TED_SOUND_SUPPORT>0)
freq1lo=TED+14 ;$FF0E; channel1 freq. lo ;actually the value the osc.up-counter is set to when turns around, and oscillator counters count up to $3FF, then it toggles between 0 & 1 -> pulse waveform
freq2lo=TED+15 ;$FF0F; channel2 freq. lo ;freq.value $3FE keeps value 1 for the oscillator, value $3FF produces the lowest frequency 108.243Hz, $3FD the highest (ultrasound): 55.42kHz 
freq2hi=TED+16 ;$FF10; channel2 freq. hi ;(clock-frequency of sound-oscillators is 4th of the main CPU/mainboard frequency(PAL:0.886MHz): 221.5kHz
sndctrl=TED+17 ;$FF11; bit7:"D/A mode":sync-oscillators (phasing between channels? digi-samples?), bit6:osc2-noise, bit5:osc2-pulse, bit4:osc1-on/off, bit3..0:volume (0..8) 
freq1hi=TED+18 ;$FF12; bit1..0:channel1 freq.hi,s charset/bitmap pointer 'bitmapaddr' too
.fi
pulse1=$10 ;volumetable: 0,6,16,26,36,46,56,66,75,75,75,75,75,75,75,75 //
pulse2=$20
noise=$40
sync=$80
.if (TED_EMULATION_BY_SID_SUPPORT>0)
SIDfreq1lo=SID+0
SIDfreq1hi=SID+1
SIDfreq2lo=SID+7
SIDfreq2hi=SID+8
SIDctrl1=SID+4
SIDctrl2=SID+11
SIDctrl3=SID+18 ;not uned but need to mute it
SIDvolume=SID+24
SID_PWl1=SID+2
SID_PWh1=SID+3
SID_PWl2=SID+9
SID_PWh2=SID+10
SID_AD1=SID+5
SID_SR1=SID+6
SID_AD2=SID+12
SID_SR2=SID+13
SIDfiltsw=SID+17
.fi



playerm .macro
player_top
.logical \1
PLAYER_FOR_EDITOR=\2
playzp = (\3==0) ? playzp_default : playzp_default+1
wftbstartindex=(PLAYER_FOR_EDITOR!=0)? insheadersize:insmaindatalen  ;waveform-table startindex is fix



;jumptable and player-variables
;------------------------------

.if (PLAYER_FOR_EDITOR==0)
;jumptable:
INIT    jmp initzak
PLAY    jmp playsnd
MULPLAY jmp (MULTISPEED_ENTRY_SUPPORT!=0) ? playmul : playsnd ;retplay
SETMVOL jmp (MAIN_VOLUME_SUPPORT!=0 && EXT_MAIN_VOLUME_SUPPORT!=0)? (MAIN_VOLUME_FADEOUT_SUPPORT!=0)? extmvol : fx_main_volume : retplay
.enc screen ;player and author-info (can be overlapping and overwritten by variables to save space)
playerinfo .text "tedzakker ",VERSION," by hermit"
playerinfo_end
           .text ";" ;separator character between player-info and author-info
authorinfo .cerror (variables_end-variables<authorinfo_len),"No variable-space for the full author-info." ;author-info will be copied to variables area on export
.enc none
.fi
variables ;variables (can overlap and overwrite player/author info during operation, thus saving space)
tempotables .for i=0,i<CHANNELAMOUNT,i=i+1
             .fill tempotable_size,defaulttempo+$80
            .next
.if (TEMPOPROGRAM_SUPPORT!=0)
tempotbcnt .fill CHANNELAMOUNT,0 ;tempoprogram-table counter (position of current tempo)
.else
tracktempo .fill CHANNELAMOUNT,0 ;individual track-tempos
.fi
tempocnt   .fill CHANNELAMOUNT,1 ;tempo-counter 
pattcnt    .fill CHANNELAMOUNT,0 ;pattern-counter (position of currently played note-row or note & ins & fx-row if no packed NOP support present)
.if (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0)
ipattcnt .fill CHANNELAMOUNT,0
fpattcnt .fill CHANNELAMOUNT,0
.fi
seqcnt     .fill CHANNELAMOUNT,0 ;currently played sequence (orderlist) position
currpatt .fill CHANNELAMOUNT,0 ;currently played pattern on the channel
currnote .fill CHANNELAMOUNT,0 ;current discrete note (A-0..H-9) on the channel
currinst .fill CHANNELAMOUNT,0 ;1 ;currently selected instrument on the channel
wftbcnt    .fill CHANNELAMOUNT,0 ;waveform-table counter (indexes the data directly, relative to instrument-basepointer)
freqtbcnt  .fill CHANNELAMOUNT,0 ;frequency-table counter (indexes the data directly, relative to instrument-basepointer)
voltbcnt   .fill CHANNELAMOUNT,0 ;volume-table counter (indexes the data directly, relative to instrument-basepointer)
.if (TABLE_DELAY_SUPPORT!=0)
wfdelaycnt  .fill CHANNELAMOUNT,0 ;wf-table delay-counter
frqdelaycnt .fill CHANNELAMOUNT,0 ;freq-table delay-counter
voldelaycnt .fill CHANNELAMOUNT,0 ;volume-table delay-counter
.fi
.if (NOTEVOLUME_FADE_SUPPORT!=0)
fadespdcnt .fill CHANNELAMOUNT,0 ;counter for fade (note volume-envelope)
fadespd .fill CHANNELAMOUNT,0 ;note volume-envelope speed
.fi
notevol .fill CHANNELAMOUNT,0 ;per-channel theoretical volume (envelope), before writing to TED it's mixed together in a way (average/prio/louder)
.if (FRAME_NOSKIP_SUPPORT==0 && FRAMESKIP_NOTEVOL_SUPPORT!=0)
notevol_fx .fill CHANNELAMOUNT,0 ;to make note volume effect work on the same row as the note
.fi
frelindex .fill CHANNELAMOUNT,0 ;freqtable - position of current relative value to add to base-note (usable for legato to return to this position in table)
.if (PORTAMENTO_SUPPORT!=0)
frelshift .fill CHANNELAMOUNT,0 ;the value to add to base-note (help from freq.program to portamento)
.fi
legatomode .fill CHANNELAMOUNT,0 ;used for permanent legato ($40) and to prescribe portamento-notefx($B0..$BF). legato is reset by legato off or new instrument (or portamento/legato-instfx/pattfx?)
vibslide .fill CHANNELAMOUNT,0 ;$0x:NOP $1x:slideup, $2x:slidedown, $3x:portamento, $3F:legato ($6x:incr.vibrato?), >=$8x:vibrato (2nd nybble amplitude), ($40:permanent legato?)
.if (VIBRATO_SUPPORT!=0)
 .if (PORTAMENTO_SUPPORT!=0 && VIBRATO_RESTORE_SUPPORT!=0)
vibstore .fill CHANNELAMOUNT,0 ;used to recover vibrato after portamento
 .fi
 .if (SLIDES_SUPPRASS_VIB_SUPPORT!=0 || LEGATO_SUPPRASS_VIB_SUPPORT!=0)
vibsuprass .fill CHANNELAMOUNT,0 ;used to stop vibrato when (and until) slide/legato is executed by pattern-fx (stop the slide by zero-value)
 .fi
vibrate .fill CHANNELAMOUNT,defaultvibrate*8 ;0 ;vibrato-rate (frequency)
vibracnt .fill CHANNELAMOUNT,defaultvibrate*2 ;0 ;vibrato rate counter
 .if (INCREMENTAL_VIBRATO_SUPPORT!=0 || GENTLE_VIBRATO_FX_SUPPORT!=0)
vibrampl .fill CHANNELAMOUNT,0 ;used by incremental vibrato as incremental amplitude-accumulation storage, or by gentle vibrato-fx to stare amplitude temporarily
 .fi
.fi
.if (LOWFREQ_NOISELOOP_SUPPORT!=0)
lowfreqsig .fill CHANNELAMOUNT,0 ;identifies notes lower than A-2 that should use 'noiseloop' automatically to produce lower pitches
.fi
.if (DETUNE_SUPPORT!=0)
detune .fill CHANNELAMOUNT,0 ;frequency low-byte add-amount of detune-upwards (independent of slides/vibratos/arps)
.fi
.if (SEQ_FX_SUPPORT!=0 && TRANSPOSE_SUPPORT!=0)
transpose .fill CHANNELAMOUNT,0 ;relative value (plus/minus) to add to currently played note
.fi
.if (MIXING_MODES_SUPPORT!=0)
mixingmode .fill CHANNELAMOUNT,0 ;averaging/priorizing/louder(automatic) mixing modes
.fi
.if (SYNC_SUPPORT!=0 || PHASE_SUPPORT!=0)
syncmode .fill CHANNELAMOUNT,0 ;sync.effect/phase: bit4($10): synchronize sounds at every player-call (frames/multispeed-frames), bit7($80):sync at note-start and set phase
.fi
waveform .fill CHANNELAMOUNT,0 ;individual desired waveforms of channels, so noise waveform absence/clash on channels can be handled by TED-writer
.if (FRAME_NOSKIP_SUPPORT==0) ;|| (SOUNDSTART_CLICK_SUPPORT!=0 && STARTCLICK_VOL_SUPPORT!=0) )
frame1sig .fill CHANNELAMOUNT,0 ;signals 1st frame (waveform?) of a fresh note, used to skip continuous play-routines (tables/vibrato/fading) on that frame to avoid rastertime-usage peaks
 .if (SOUNDSTART_CLICK_SUPPORT!=0 && STARTCLICK_VOL_SUPPORT!=0)
frame1vol .fill CHANNELAMOUNT,0 ;tells click-handler the volume of 1st frame
 .fi
.fi
.if (MAIN_VOLUME_SUPPORT!=0 && MAIN_VOLUME_FADEOUT_SUPPORT!=0)
mainvolfadecnt .byte 0
.fi
.if (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0)
npackcnt .fill CHANNELAMOUNT,0
ipackcnt .fill CHANNELAMOUNT,0
fpackcnt .fill CHANNELAMOUNT,0
.fi
variables_end

;ghost-registers
;.if(GHOST_REGISTER_SUPPORT!=0)
freqlo_gho .fill CHANNELAMOUNT,<inaudible
freqhi_gho .fill CHANNELAMOUNT,>inaudible
;.fi
sndctrl_gho = playzp+1 ; .byte 0 ;populated inside ghostregister-writer routine (where zeropage can be reused) from value 0 till final value to write into TEDs

;constants
.if (SUBTUNE_SUPPORT!=0)
subtchindex .byte range(CHANNELAMOUNT) * maxsubtuneamount ;might give subtune/orderlist-pointer indexes 
subtune_amount=subtchindex+1 ;2nd byte: subtune-amount of the tune written by packer in editor
.else
subtchindex .byte range(CHANNELAMOUNT) * (maxseqlen+1) ;orderlist/sequence indexes relative to the orderlist written by packer in editor
seq0_len=subtchindex+1 ;written by packer in editor (start-index of 2nd sequence in the orderlist)
.fi
.if (TEMPOPROGRAM_SUPPORT!=0)
tempotable_offsets .byte range(CHANNELAMOUNT) * tempotable_size
tempotbcnt_startvalues .byte <( range(CHANNELAMOUNT) * tempotable_size - 1 )
.fi
.if (TED_SOUND_SUPPORT>0)
freqhi_ghondex .byte (freq1hi-freq2hi),0 ;spacing for frequency-registers of TED
.fi
;mutemask .byte $ff-pulse1, $ff-(pulse2+noise)
pulsewfval .byte pulse1,pulse2 ;pulse-waveform values for channel 1 & 2
;otherchannelnum .byte 1,0 ;used to check other channel's value in case of commonly controlled registers

normal_range_freqtable = round ( 1024.00 - BUS_PAL_CLOCKFREQ / 8.00 / ( A4_NOTE_FREQ * 2**(range(-24,63)/12.00) ) ) ;TED sound-frequency is derived by: freq=busclock/4/(1024-registervalue)/2
freqtablo ;.byte <(lowest_pulse_freq_val)
          .byte <(normal_range_freqtable)
          .byte range($80+maxnotenum,(<inaudible)+1)
freqtabhi ;.byte >(lowest_pulse_freq_val)
          .byte >(normal_range_freqtable) ;freq. hi table can be compressed by storing only every 4th value, and (lsr;lsr)-ing in player-code
          .fill (<inaudible+1-($80+maxnotenum)),$03

.if (BALANCED_SLIDE_SUPPORT!=0) ;used for lower frequencies to have a sensible range from fine to coarse slide/vibrato values
exptables .byte 00,01,02,03,04,05,06,08,10,12,14,16,20,24,28,32 ;for octave3
          .byte 00,01,02,03,04,06,08,10,12,16,20,24,32,40,48,64 ;for octave2
.fi

.if (TED_EMULATION_BY_SID_SUPPORT>0)
SID_ADSRval .byte $00,$F0 ;constant ADSR values for TED-simulation
SID_PWval .byte $00,$08
SIDvolConv .byte $0,$2,$4,$6,$8,$A,$C,$E,$F,$F,$F,$F,$F,$F,$F,$F

TED_PAL_SOUNDCLOCK=BUS_PAL_CLOCKFREQ/8.00 ;110840.4375Hz
C64_BUS_PAL_CLOCKFREQ = 985248.00 ;Hz
SID_FREQDIV = 256**3 / C64_BUS_PAL_CLOCKFREQ ;17.02841924Hz
TEDtoSID_DIVIDEND = TED_PAL_SOUNDCLOCK * SID_FREQDIV ;1887437.4385
TEDtoSIDfreqTable .word round ( TEDtoSID_DIVIDEND * 2.00 / ( 1024.00 - range($0380*2,$03C0*2)/2.00 )  )
.fi



;============================ INIT ROUTINE =============================
cmd_rts=$60
cmd_jmp=$4C

initzak 
.if (SUBTUNE_SUPPORT!=0)
        sta subtune+1
.fi
        lda #cmd_rts
        sta goplcnt ;modify readseq/advaseq to subroutine for orderlist-sequence reading here
.if (MAIN_VOLUME_SUPPORT!=0)
        lda #$0F
        sta mainvol+1
 .if (MAIN_VOLUME_SUPPORT!=0 && MAIN_VOLUME_FADEOUT_SUPPORT!=0)
        lda #0
        sta mfadspd+1
 .fi
.fi
        ldx #CHANNELAMOUNT-1
.if (PLAYER_FOR_EDITOR==0)
initlp  lda #1 ;tempocnt,x must be set to 1 if tempos are counted from 1 up, not 0
        sta tempocnt,x ;the initial value is set so the init routine triggers seq/ptn read of 1st tick
        lda #0
        sta seqcnt,x
        sta currinst,x 
        sta notevol,x
 .if (FRAME_NOSKIP_SUPPORT==0 && FRAMESKIP_NOTEVOL_SUPPORT!=0)
        sta notevol_fx,x
 .fi
        sta waveform,x
 .if (SEQ_FX_SUPPORT!=0 && TRANSPOSE_SUPPORT!=0)
        sta transpose,x
 .fi
 .if (DETUNE_SUPPORT!=0)
        sta detune,x   ;decided to make it permanent to avoid pattern-duplications, now reset in init routine only
 .fi                   ;(also 5 cycles of rastertime saved this way and Orderlist-FX of detuning is possible too)
 .if (SYNC_SUPPORT!=0 || PHASE_SUPPORT!=0)
        sta syncmode,x
 .fi
        ;sta legatomode,x
        ;sta vibslide,x
 .if (LOWFREQ_NOISELOOP_SUPPORT!=0)
        sta lowfreqsig,x
 .fi
 .if (TEMPOPROGRAM_SUPPORT!=0)
        ldy tempotable_offsets,x
        lda #$80+defaulttempo
        sta tempotables,y
        lda tempotbcnt_startvalues,x
        sta tempotbcnt,x
 .else
        lda #defaulttempo
        sta tracktempo,x
 .fi
        jsr readseq ;resets pattcnt,x ; ipattcnt,x ; fpattcnt,x
.else ;PLAYER_FOR_EDITOR:
-       lda #0
        sta playerpcnt,x
 .if (SEQ_FX_SUPPORT!=0 && TRANSPOSE_SUPPORT!=0)
        sta transpose,x
 .fi
 .if (DETUNE_SUPPORT!=0)
        sta detune,x   ;decided to make it permanent to avoid pattern-duplications, now reset in init routine only
 .fi
        ;lda #0 ;ldacurrins ;in editor
        sta currinst,x ;softini shouldn't contain this because pos.play needs currinst,x
        lda #<(-1)
        sta seqcnt,x
        lda playmark,x
markply ldy #selfmod
        bne +
 .if (TEMPOPROGRAM_SUPPORT!=0)
        ldy tempotable_offsets,x
        lda #$80+defaulttempo
        sta tempotables,y
 .else
        lda #defaulttempo
        sta tracktempo,x
 .fi
        lda #0 ;play from beginning
+       sta markcnt
-       jsr advaseq ;resets pattcnt,x ; ipattcnt,x ; fpattcnt,x
        lda currpatt,x
        sta playerpatt,x ;for editor
        lda markcnt
        bpl -
        dex
        bpl --
softini .if (PLAYER_FOR_EDITOR!=0)
        lda #0
        sta minutes
        sta seconds
        sta FramCnt+1
        .fi
        ldx #CHANNELAMOUNT-1 ;'softini' is useful for pattern/position callback
initlp  lda #<inaudible
        sta freqlo_gho,x
        lda #>inaudible
        sta freqhi_gho,x
        lda #1
        sta tempocnt,x
        lda #0
        sta notevol,x
 .if (FRAME_NOSKIP_SUPPORT==0 && FRAMESKIP_NOTEVOL_SUPPORT!=0)
        sta notevol_fx,x
 .fi
 .if (SYNC_SUPPORT!=0 || PHASE_SUPPORT!=0)
        sta syncmode,x
 .fi
        sta legatomode,x
        sta vibslide,x
 .if (LOWFREQ_NOISELOOP_SUPPORT!=0)
        sta lowfreqsig,x
 .fi
        sta waveform,x
        sta currnote,x
        sta stopmutesig,x
 .if (MIXING_MODES_SUPPORT!=0)
        ;lda #mixingmode_average
        sta mixingmode,x
 .fi
 .if (TEMPOPROGRAM_SUPPORT!=0)
        lda tempotbcnt_startvalues,x
        sta tempotbcnt,x
 .fi   ;init position in instrument 0 (not really necessary, just for safety)
        lda #wftbstartindex
        sta wftbcnt,x
        lda #insheadersize+maxinstblen+1
        sta freqtbcnt,x
        lda #insheadersize+(maxinstblen+1)*2
        sta voltbcnt,x
 ;.if (TABLE_DELAY_SUPPORT!=0)
 ;       lda #$ff ;lda #lowest_pulse_note
 ;       sta frqdelaycnt,x ;sta currnote,x
 ;.fi
.fi ;end of PLAYER_FOR_EDITOR
.if (TED_EMULATION_BY_SID_SUPPORT>0)
        lda SID_ADSRval,x
        sta SID_AD1,x
        sta SID_AD2,x
        lda SID_PWval,x
        sta SID_PWl1,x
        sta SID_PWl2,x
.fi
        dex
        bpl initlp
        lda #cmd_jmp
        sta goplcnt ;modify readseq/advaseq back to 'inline' routine for player

silence lda #0
.if (TED_SOUND_SUPPORT>0)
        sta sndctrl
.fi
.if (TED_EMULATION_BY_SID_SUPPORT>0)
        sta SIDvolume
        sta SIDfiltsw
        sta SIDctrl1
        sta SIDctrl2
        sta SIDctrl3
.fi
retinit rts




;====================== MULTISPEED PLAY-ROUTINE ========================
.if (MULTISPEED_ENTRY_SUPPORT!=0)
playmul ldy #%11100000 ;multispeed-signal (must be bigger than $80 when nonzero, so 'bit' can test it too)
        jmp playsn2
.fi




;====================== SINGLE-SPEED PLAY-ROUTINE ======================
playsnd 
.if (MULTISPEED_ENTRY_SUPPORT!=0)
        ldy #0
playsn2 sty mulpsig+1
.fi

.if (SOUNDSTART_CLICK_SUPPORT==0 && FRAME_NOSKIP_SUPPORT!=0)
        jsr ghostwr ;at the beginning if no frame-skipping, to have more stable sync.fx
.fi
.if (SUBTUNE_SUPPORT!=0 && SUBTUNE_JUMP_SUPPORT!=0)
        lda #$ff
        sta stjpsig+1
.fi




        ldx #CHANNELAMOUNT-1
chnloop 




;===================== CHANNEL LOOP STARTS HERE ========================




.if (MULTISPEED_ENTRY_SUPPORT!=0)
mulpsig ldy #selfmod ;multispeed?
        beq singlechn
 .if (FRAME_NOSKIP_SUPPORT==0)
        lda frame1sig,x ;frameskipping? -> skip multispeed too on the channel for 1st frame
        beq plcnmul
        jmp nextchn ;frameskipping in case of multispeed-call
 .fi
plcnmul jmp setipt2 ;playcont
.fi




;----------------------- single-speed channel loop ---------------------
singlechn

.if (MAIN_VOLUME_SUPPORT!=0 && MAIN_VOLUME_FADEOUT_SUPPORT!=0)
 .if (PLAYER_FOR_EDITOR!=0)
        lda playmode
        beq mvolfade_end ;don't execute fade-out while jamming
 .fi
mfadspd ldy #selfmod
        beq mvolfade_end
        lda mainvol+1
        beq mvolfade_end
        dec mainvolfadecnt
        bne mvolfade_end
        sty mainvolfadecnt
        dec mainvol+1      ;compensated in jamming mode in editor
mvolfade_end
.fi

        lda #0 ;reset fx-values, processchn will set them if needed
.if (NOTE_FX_SUPPORT!=0)
        sta notefx+1
.fi
        sta instfx+1
        sta pattfx+1 ;Accumulator=0 here


.if (FRAME_NOSKIP_SUPPORT==0)
 .if (SOUNDSTART_CLICK_SUPPORT!=0)
        lda frame1sig,x ;holds first row of waveform-table value here
        beq nofskip
        and #$0F 
        cmp #$0F ;'shortframe' value for row 1 of wf-table decides: click or not
        bne noshrtf
  .if (TED_SOUND_SUPPORT>0)
   .if (STARTCLICK_VOL_SUPPORT==0)
        lda #8+$40+$10 ;make the click audible by setting volume/wf temporarily (volume to fix max. value)
   .else
        lda frame1vol,x ;holds first row volume-table value here
        and #$0F
        ora #$40+$10 ;make click audible by setting wf and volume (to 0..F depending on frame1sig value set in 'initins')
   .fi
        sta sndctrl
        ldy freqhi_ghondex,x
        lda freq1hi   ;preserve current character/bitmap data address
        ora #3 ;select topmost frequency range
        sta freq2hi,y
        lda #$F8 ;set the frequency to a suitable value (to sound as a click/kick)
        sta freq1lo,x
  .fi
  .if (TED_EMULATION_BY_SID_SUPPORT>0)
   .if (STARTCLICK_VOL_SUPPORT==0)
        lda #$0F
   .else
        lda frame1vol,x ;holds first row volume-table value here
        and #$0F
        tay
        lda SIDvolConv,y
   .fi
        sta SIDvolume
        lda #$81
        sta SIDctrl2 
        lda #$F8
        sta SIDfreq2hi
  .fi
noshrtf lda #0
 .fi
        sta frame1sig,x ;Accumulator=0 here in either case (legacy from fx-initializer)
nofskip
.fi


.if (PLAYER_FOR_EDITOR!=0)
        lda playmode
        bne +
        jmp playcont ;if jamming in editor, don't run tempo/pattern-handling, just playcont
+       cmp #pattplaymode
        beq cntempo
.fi
        lda seqcnt,x ; > $80? - end of playback on channel, stop tempo-counting (tables/vibratos still executed though)
        bpl cntempo
goplayc jmp playcont ;bmi retinit ;retghos ;retplay ;sequence ended?


cntempo dec tempocnt,x
        bne goplayc ;retghos ;bpl retghos ;retplay ;if 'bpl', tempos are from 0..F, but better if 'bne' and tempo=1 is the fastest
.if (TEMPOPROGRAM_SUPPORT!=0)
advtmpr ldy tempotbcnt,x ;advance in tempo-program
        iny
        lda tempotables,y
        bpl +
        ldy tempotbcnt_startvalues,x
+       and #$7f
.else
        lda tracktempo,x
.fi
        sta tempocnt,x
.if (PLAYER_FOR_EDITOR!=0)
        sta currtempo,x ;in editor
.fi
.if (TEMPOPROGRAM_SUPPORT!=0)
        tya
        sta tempotbcnt,x
.fi




;===================== PROCESS ONE ROW OF PATTERN ======================




readptn ldy currpatt,x
.if (PLAYER_FOR_EDITOR!=0)
        tya
        sta playerpatt,x ;for editor
        lda pattcnt,x
        sta playerpcnt,x ;for editor
.fi
p_ptnl1 lda pattptlo,y
        sta playzp+0
p_ptnh1 lda pattpthi,y
        sta playzp+1
p_ptnf1 lda fxindexes,y
        sta fxoffs+1


readins 
p_ptni1 lda insindexes,y
        clc
        adc (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0) ? ipattcnt,x : pattcnt,x
        tay
.if (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0)
        lda ipackcnt,x
        bne ipckNOP
.fi
        lda (playzp),y
        beq advapti ;readins_end ;readfx ;no need to check upper range, done in editor already
.if (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0)
        cmp #packNOP_min
        bcc cilegat
        sbc #packNOP_min-1 ;Carry=1 here
        sta ipackcnt,x
        jmp advapti
ipckNOP dec ipackcnt,x
        jmp readins_end
.fi
cilegat cmp #maxinstamount+1 ;legatofx
        bcc setinst
setifx  sta instfx+1
        jmp advapti ;readins_end ;readfx
setinst sta currinst,x 
        lda #0
        sta legatomode,x
advapti
.if (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0)
        inc ipattcnt,x
.fi
readins_end


readfx  lda (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0) ? fpattcnt,x : pattcnt,x
        clc
fxoffs  adc #selfmod
        tay
.if (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0)
        lda fpackcnt,x
        bne fpckNOP
.fi
        lda (playzp),y
        beq advaptf ;readnot
.if (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0)
        cmp #packNOP_min
        bcc setptfx
        sbc #packNOP_min-1 ;Carry=1 here
        sta fpackcnt,x
        jmp advaptf
fpckNOP dec fpackcnt,x
        jmp readfx_end
.fi
setptfx sta pattfx+1
advaptf 
.if (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0)
        inc fpattcnt,x
.fi
readfx_end


readnote
        ldy pattcnt,x
.if (PLAYER_FOR_EDITOR==0)
rdnextr iny
        lda (playzp),y ;next value in pattern
        sta nextval+1
        dey
.fi
.if (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0)
        lda npackcnt,x
        bne npckNOP
.fi
        lda (playzp),y
        beq goadvpt ;NOP? ;no need to check upper range, done in editor already
        bpl setiptr ;note-FX or packed NOP?
.if (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0)
        cmp #packNOP_min
        bcc +
        sbc #packNOP_min-2 ;Carry=1 here
        sta npackcnt,x
npckNOP dec npackcnt,x
        beq goadvpt ;advaptn
        jmp playcont ;rts ;jmp retpchn
.fi
+
.if (NOTE_FX_SUPPORT!=0)
        cmp #portam_nfx ;note-column prescribed portamento?
        bcc setntfx
        ora legatomode,x ;prescribe portamento-noteFX? $B0..$BF: %1L11xxxx ('L':legato, xxxx:speed)
        jmp storleg
setntfx cmp #slideup_nfx
        bcc + ;shift range $90..$BF to $10..$3F
        sbc #vibrato_min ;Carry is set by 'cmp'
+       sta notefx+1
.fi
goadvpt jmp advaptn ;readptn_end
newnote .if (SEQ_FX_SUPPORT!=0 && TRANSPOSE_SUPPORT!=0)
         clc
         adc transpose,x
        .fi
        sta currnote,x
.if (SOUNDSTART_CLICK_SUPPORT==0 && FRAME_NOSKIP_SUPPORT==0)
        inc frame1sig,x
.fi
        lda legatomode,x
        bpl +
        and #$7F
        sta vibslide,x
        and #$40 ;change back to NOP (or legato-mode if exists)
        jmp storleg
+       bne legato 
        lda #legatofx ;pre-set
        cmp instfx+1  ;ldy vibslide,x ;legatomode,x ;legato/portamento?
        beq legato 
        lda pattfx+1
        cmp #porta_min ;legatofx ;bmi initins ;vibrato doesn't prevent instrument-initialization
        bcc initins ;slide?
        cmp #legatofx
        beq legato
        bcs initins
.if (PORTAMENTO_SUPPORT!=0)
portam  sta vibslide,x
.fi
        jmp advaptn ;greadptn_end
setiptr ldy currinst,x ;FROM HERE THE INSTRUMENT-POINTER IS USED, NOT PATTERN-POINTER
        beq goadvpt ;don't run non-existing zero-instrument (would cause unpredictable results)
        pha
p_insl1 lda insptlo,y
        sta playzp+0
p_insh1 lda inspthi,y
        sta playzp+1
        pla
csyncfx cmp #syncon
        bcc newnote
.if (NOTE_FX_SUPPORT!=0 && SYNC_SUPPORT!=0)
        beq setsync
.fi
cnoteon cmp #noteon
        bcs cnotoff
.if (NOTE_FX_SUPPORT!=0)
clegafx cmp #legatoon
 .if (SYNC_SUPPORT!=0)
        bcs legmode
grcnytg lda #0
setsync sta syncmode,x ;lda #sync_bitvalue
        jmp advaptn ;readptn_end
 .else
        bcc advaptn ;readptn_end
 .fi
legmode beq + ;legato-on?
        lda #$00
        .byte $2c ;skip
+       lda #$40 ;#permalega 
.fi
storleg sta legatomode,x ;sta vibslide,x ;legatofx ;$80 ;permanent legato
        jmp advaptn ;readptn_end

cnotoff beq setgton ;skipped here from 'cnoteon' (otherwise 'setgton' would be too far)
        ;cmp #gap_stacc
        ;bcs gapstac
setgoff 
.if (NOTEOFF_TBINDEX_SUPPORT!=0)
        ldy #wftbnoteoffindexpos
        lda (playzp),y
        beq + ;if zero, no noteoff-program for wf-table
        sta wftbcnt,x
 .if (TABLE_DELAY_SUPPORT!=0)
        lda #0
        sta wfdelaycnt,x
 .fi
+       ldy #freqtbnoteoffindexpos
        lda (playzp),y
        beq + ;if zero, no noteoff-program for freq-table
        sta freqtbcnt,x
 .if (TABLE_DELAY_SUPPORT!=0)
        lda #0
        sta frqdelaycnt,x
 .fi
+       ldy #voltbnoteoffindexpos
        lda (playzp),y
        bne setvpos ;if no gateoff-pointer set, mute notevolume on note-off 
.else
        lda #0
.fi
.if (NOTEVOLUME_FADE_SUPPORT!=0)
        sta fadespd,x ;stop possible executing fade-in
.fi
noffvol sta notevol,x ;noteoff? note-fx?
        jmp advaptn

legato  lda #0
        sta vibslide,x ;stop existing vibrato/slide for this time (table/fx can start it again
.if (TABLE_DELAY_SUPPORT!=0)
        sta frqdelaycnt,x ;don't fukk with vibrato while legating
.fi
        lda frelindex,x ;better vibrato-retainer solution for legato (restarts freq. table from latest rel.note) 
        sta freqtbcnt,x ;cause freq.program to reload latest relative note
.if (VIBRATO_SUPPORT!=0 && LEGATO_SUPPRASS_VIB_SUPPORT!=0)
        lda #$ff
        sta vibsuprass,x
.fi
        jmp advaptn

initins lda #0 ;fresh note-start
.if (PLAYER_FOR_EDITOR!=0)
        sta stopmutesig,x
.fi
.if (TABLE_DELAY_SUPPORT!=0)
        sta wfdelaycnt,x
        sta frqdelaycnt,x
.fi
;.if (DETUNE_SUPPORT!=0)
;        sta detune,x   ;decided to make it permanent to avoid pattern-duplications, now reset in init routine only
;.fi
        sta vibslide,x
;.if (SYNC_SUPPORT!=0 || PHASE_SUPPORT!=0)
;        sta syncmode,x
;.fi
.if (VIBRATO_SUPPORT!=0)
 .if (PORTAMENTO_SUPPORT!=0 && VIBRATO_RESTORE_SUPPORT!=0)
        sta vibstore,x
 .fi
 .if (INCREMENTAL_VIBRATO_SUPPORT!=0 || GENTLE_VIBRATO_FX_SUPPORT!=0)
        sta vibrampl,x
 .fi
 .if (SLIDES_SUPPRASS_VIB_SUPPORT!=0 || LEGATO_SUPPRASS_VIB_SUPPORT!=0)
        sta vibsuprass,x
 .fi
 .if (DEFAULT_VIBRATO_RATE_SUPPORT!=0)
        lda #defaultvibrate*8
        sta vibrate,x
        lsr
        lsr
        sta vibracnt,x
 .fi
.fi
        ldy #freqtbstartindexpos
        lda (playzp),y
        sta freqtbcnt,x

        lda #wftbstartindex
        sta wftbcnt,x
.if (SOUNDSTART_CLICK_SUPPORT!=0)
        tay
        lda (playzp),y ;first row of waveform-table controls click-behaviour
 .if (FRAME_NOSKIP_SUPPORT==0)
        sta frame1sig,x
 .else
        and #$0F 
  .if (STARTCLICK_VOL_SUPPORT==0)
        cmp #$0F ;'shortframe' value for row 1 of wf-table decides: click or not
        bne setgton
   .if (TED_SOUND_SUPPORT>0)
        lda #8+$40+$10 ;make the click audible by setting volume/wf temporarily (volume to fix max. value)
        sta sndctrl
        ldy freqhi_ghondex,x
        lda freq1hi   ;preserve current character/bitmap data address
        ora #3 ;select topmost frequency range
        sta freq2hi,y
        lda #$F8 ;set the frequency to a suitable value (to sound as a click/kick)
        sta freq1lo,x
   .fi
   .if (TED_EMULATION_BY_SID_SUPPORT>0)
        lda #$0F
        sta SIDvolume
        lda #$81
        sta SIDctrl2 
        lda #$F8
        sta SIDfreq2hi
   .fi
  .else
        sta frame1s+1
  .fi
 .fi
.fi

setgton ldy #voltbstartindexpos
        lda (playzp),y
setvpos sta voltbcnt,x
.if (SOUNDSTART_CLICK_SUPPORT!=0 && STARTCLICK_VOL_SUPPORT!=0)
        tay
 .if (FRAME_NOSKIP_SUPPORT==0)
        lda (playzp),y
        sta frame1vol,x
 .else
frame1s lda #selfmod 
        cmp #$0F ;'shortframe' value for row 1 of wf-table decides: click or not
        bne ininvol
        lda pattfx+1 ;check 3rd column pattern-FX early to support click-volume setting to a degree at least if no frameskipping
        cmp #notevolfx_min
        bcc +
        cmp #voljump_min
        bcc ++
+       lda (playzp),y
+       and #$0F
  .if (TED_SOUND_SUPPORT>0)
        ora #$40+$10 ;make click audible by setting wf and volume (to 0..F depending on frame1sig value set in 'initins')
        sta sndctrl
        ldy freqhi_ghondex,x
        lda freq1hi   ;preserve current character/bitmap data address
        ora #3 ;select topmost frequency range
        sta freq2hi,y
        lda #$F8 ;set the frequency to a suitable value (to sound as a click/kick)
        sta freq1lo,x
  .fi
  .if (TED_EMULATION_BY_SID_SUPPORT>0)
        tay
        lda SIDvolConv,y
        sta SIDvolume
        lda #$81
        sta SIDctrl2 
        lda #$F8
        sta SIDfreq2hi
  .fi
 .fi
.fi
ininvol lda #0
.if (TABLE_DELAY_SUPPORT!=0)
        sta voldelaycnt,x
.fi
;.if (NOTEVOLUME_FADE_SUPPORT!=0)
;        sta fadespd,x
;.fi
;.if (MIXING_MODES_SUPPORT!=0)
;        sta mixingmode,x
;.fi




;========================= ADVANCE IN PATTERN ==========================




advaptn
.if (PLAYER_FOR_EDITOR!=0)
        lda playmode
        ;cmp #stopmode
        bne + ;beq goplcnt ;retpchn ;if tune stopped, jamming mode -> no advance in pattern
        rts
.fi
+       inc pattcnt,x
readptn_end



.if (PLAYER_FOR_EDITOR==0)
nextval lda #selfmod
        cmp #ptnendval
        bne goplcnt ;retpchn
.else
return0 nop ;modified by editor to RTS when needed: return-point for keyboard-jamming / pos.play
        ldy currpatt,x
        lda ptnlen,y
        sec
        sbc #1
        bcc +
        cmp pattcnt,x
        bcs goplcnt ;retpchn
+       lda playmode ; & beq retpchn ;if tune stopped, jamming mode -> no advance in sequence 
        cmp #pattplaymode
        beq rnewptn
.fi




;===================== ORDERLIST/SEQUENCE HANDLING =====================




 .if (SUBTUNE_SUPPORT!=0 && SUBTUNE_JUMP_SUPPORT!=0)
stjpsig lda #selfmod
        bpl restseq
 .fi
advaseq inc seqcnt,x
.if (PLAYER_FOR_EDITOR!=0)
        dec markcnt
.fi
readseq 
.if (SUBTUNE_SUPPORT!=0)
subtune lda #selfmod 
readsq2 clc
        adc subtchindex,x ;corresponds to orderlist/sequence-pointers
        tay
p_seql1 lda seqptrlo,y
        sta playzp+0
p_seqh1 lda seqptrhi,y
        sta playzp+1
        ldy seqcnt,x
        lda (playzp),y
.else
        lda seqcnt,x
readsq3 clc
        adc subtchindex,x ;corresponds to indexes of sequence-starts relative to orderlist
        tay
p_olip1 lda orderlist0,y
.fi
        bne +
endplay lda #endplayvalue
        sta seqcnt,x
.if (PLAYER_FOR_EDITOR!=0 && RUNNABLE_EXPORT_SUPPORT>0)
        sta FullyPlayed
.fi
        bne goplcnt ;jmp goplcnt  ;retpchn rts
+
.if (SEQ_FX_SUPPORT!=0)
        bmi seqfx
.else
        bmi advaseq
.fi
setpatt sta currpatt,x
rnewptn lda #0 ;#<(-1)
        sta pattcnt,x
.if (PACKED_NOP_SUPPORT!=0 && PLAYER_FOR_EDITOR==0)
        sta ipattcnt,x
        sta fpattcnt,x
        ;lda #0
        sta npackcnt,x
        sta ipackcnt,x
        sta fpackcnt,x
.fi
goplcnt jmp playcont ;rts ;command is changed to RTS by 'init' routine temporarily, then back to JMP for player



;----------------------orderlist-sequence effects-----------------------
.if (SEQ_FX_SUPPORT!=0)
seqfx   cmp #jumpval
        bne cseqfxB
jumpseq
 .if (PLAYER_FOR_EDITOR!=0 && RUNNABLE_EXPORT_SUPPORT>0)
        sta FullyPlayed
        tya
  .if (SUBTUNE_SUPPORT!=0)
        iny
  .else
        sec
        sbc subtchindex,x
  .fi
        cmp (SUBTUNE_SUPPORT!=0) ? (playzp),y : orderlist0+1,y ;this address need not to be set on export (only used by editor)
        beq goplcnt ;retpchn ;safety-hack to avoid freeze (endless loop to same position in editor)
 .else
  .if (SUBTUNE_SUPPORT!=0)
        iny
  .fi
 .fi
p_olip2 lda (SUBTUNE_SUPPORT!=0) ? (playzp),y : orderlist0+1,y ;next value in sequence
 .if (SUBTUNE_SUPPORT!=0 && SUBTUNE_JUMP_SUPPORT!=0)
        bpl setseqp ;subtune-jump or normal jump?
        and #maxsubtuneamount-1 ;this works only if subtune-amount is a power of 2  ;7 ;$7F
        sta subtune+1
        sta stjpsig+1
restseq lda #0
 .fi
setseqp sta seqcnt,x
        jmp (SUBTUNE_SUPPORT!=0) ? readseq : readsq3

cseqfxB cmp #tempo_min ;$B0
        bcc cseqfxA
 .if (DETUNE_SUPPORT!=0)
cseqfxD cmp #seqdetune_min ;$D0
        bcc trktmpo
  .if (MAIN_VOLUME_SUPPORT!=0 && MAIN_VOLUME_FADEOUT_SUPPORT!=0)
cseqfxE cmp #mfadeout_min ;$E0
        bcs mvfdout
  .fi
        and #$0F
        sta detune,x   ;decided to make it permanent to avoid pattern-duplications, now reset in init routine only
        jmp advaseq
 .fi
 .if (MAIN_VOLUME_SUPPORT!=0 && MAIN_VOLUME_FADEOUT_SUPPORT!=0)
  .if (DETUNE_SUPPORT==0)
        cmp #mfadeout_min ;$E0
        bcc trktempo        
  .fi 
mvfdout ;asl ;$E0=%1110_0000, bit4=0, so 3 'ASL' commands are enough and no need for 'AND $0F' whatever
        asl
        asl
        asl
        sta mfadspd+1
        sta mainvolfadecnt
        jmp advaseq
 .fi
trktmpo 
 .if (TEMPOPROGRAM_SUPPORT!=0)
        lda tempotbcnt_startvalues,x 
        sta tempotbcnt,x ;tempocnt is already reset here
        stx xstore0+1 ;sbc #(tempo_min-$80) ;Carry already set by 'bcc'
        tax
temprlp 
p_olip3 lda (SUBTUNE_SUPPORT!=0) ? (playzp),y : orderlist0,y
 .if (DETUNE_SUPPORT!=0 || MAIN_VOLUME_FADEOUT_SUPPORT!=0)
        cmp #tempo_max+1
        bcs tmprend
 .fi
        sec
        sbc #tempo_min
        bcc tmprend ;next value is tempo? then set tempoprogram, else single tempo
regtmpo iny ;register a tempo-value in tempotable
  .if (PLAYER_FOR_EDITOR!=0)
        dec markcnt
  .fi
        inx
        sta tempotables,x
        bcs temprlp 
tmprend lda tempotables,x
        ora #$80 ;put an end to the tempo-program
        sta tempotables,x
xstore0 ldx #selfmod
        tya
  .if (SUBTUNE_SUPPORT==0)
        sec
        sbc subtchindex,x
  .fi
        sta seqcnt,x
        jmp (SUBTUNE_SUPPORT!=0) ? readseq : readsq3
 .else
        and #$0f
        sta tempocnt,x
        sta tracktempo,x
        jmp advaseq
 .fi

cseqfxA 
 .if (MAIN_VOLUME_SUPPORT!=0)
        cmp #mainvol_min
        bcc transpo
        and #$0F
        sta mainvol+1
  .if (MAIN_VOLUME_FADEOUT_SUPPORT!=0)
        lda #0
        sta mfadspd+1
  .fi
        jmp advaseq
 .fi

transpo 
 .if (SEQ_FX_SUPPORT!=0 && TRANSPOSE_SUPPORT!=0)
        sec
        sbc #transpup_min
        sta transpose,x
 .fi
        jmp advaseq
.fi




;=================== CONTINUOUS PLAY (tbl/slide/fx) ==================== 




playcont
.if (FRAME_NOSKIP_SUPPORT==0)
        lda frame1sig,x ;frameskipping? -> skip multispeed too on the channel for 1st frame
        bne goptnfx ;frameskipping in case of single-speed call
.fi


setipt2 
.if (PLAYER_FOR_EDITOR!=0)
        ldy currnote,x
        beq goptnfx ;don't play table when note-volume is zero
        ldy stopmutesig,x
        bne goptnfx
.fi
        ldy currinst,x
        bne p_insl2 ;don't run non-existing zero-instrument (would cause unpredictable results)
goptnfx jmp patternfx
p_insl2 lda insptlo,y
        sta playzp+0
p_insh2 lda inspthi,y
        sta playzp+1


;------------------ Volume-table program execution ---------------------
.if (MULTISPEED_ENTRY_SUPPORT!=0 && TABLE_MULTISPEED_SEL_SUPPORT!=0)
        ldy #instcontrolswitchpos
        lda (playzp),y
        sta mulpval+1
        bmi volprog ;check volume-table multispeed switch-bit
        lda mulpsig+1
        beq volprog
        jmp dofade_end
.fi
volprog 
.if (TABLE_DELAY_SUPPORT!=0)
        lda voldelaycnt,x
        beq readvol
        dec voldelaycnt,x
        jmp volprog_end
.fi
readvol ldy voltbcnt,x
.if (PLAYER_FOR_EDITOR!=0)
        tya
        sta voltbpos,x ;in editor (this avoids display phase differences)
.fi
        lda (playzp),y
        beq volprog_end ;dofade_end 
        bpl csetfad ;delay/set/fade?
        cmp #jumpval
        bne voltadv ;tremolo / gap?
voltjmp iny
        lda (playzp),y
.if (PLAYER_FOR_EDITOR!=0)
        ldy #voltbstartindexpos
        clc
        adc (playzp),y ;editor should calculate this when packing tune
        cmp voltbcnt,x ;safety check to avoid freeze in editor
        beq volprog_end
.fi
        sta voltbcnt,x
        jmp readvol
csetfad cmp #notevol_min ;accu==01..$7f here
        bpl setnotv ;volume-setting or fade/delay?
.if (NOTEVOLUME_FADE_SUPPORT!=0)
cvoldly cmp #delay_max+1
        bpl setfade ;fade / delay?
.fi
.if (TABLE_DELAY_SUPPORT!=0)
vodelay sec
        sbc #1
        sta voldelaycnt,x
.fi
        jmp voltadv
setnotv 
.if (MIXING_MODES_SUPPORT!=0)
        ldy #mixingmode_average
        cmp #mix_avg_min ;mixing mode? $3x/$5x
        bpl +
        ldy #mixingmode_louder
        cmp #mix_loud_min
        bpl +
        ldy #mixingmode_priority
+       and #$0F
        sta notevol,x
        tya
        sta mixingmode,x
.else
        and #$0F
        sta notevol,x
.fi
.if (NOTEVOLUME_FADE_SUPPORT!=0)
        lda #0
setfade sta fadespd,x
        and #$0F
        sta fadespdcnt,x
.fi
voltadv inc voltbcnt,x
volprog_end
.if (NOTEVOLUME_FADE_SUPPORT!=0)
dofade  lda fadespd,x
        beq dofade_end
        dec fadespdcnt,x
        bpl dofade_end
        tay
        and #$0F ;clear the upper bits
        sta fadespdcnt,x
        lda #0 ;used to saturate bottom wrapping
        cpy #fadeout_min
        bcc fadein ;fade in / out ?
fadeout dec notevol,x
        bpl dofade_end
        bmi setnvol ;jmp setnvol
fadein  sec
        adc notevol,x
        cmp #$10 ;check if accumulated value went over $0F
        bmi setnvol
        lda #$0F ;saturate top wrapping
setnvol sta notevol,x
.fi
dofade_end


;---------------- Frequency-table program execution --------------------
.if (MULTISPEED_ENTRY_SUPPORT!=0 && TABLE_MULTISPEED_SEL_SUPPORT!=0)
        lda mulpsig+1
        beq frqprog
        bit mulpval+1
        bvc gofrend ;check frequency-table multispeed switch-bit
.fi
frqprog 
.if (TABLE_DELAY_SUPPORT!=0)
        lda frqdelaycnt,x
        ;bmi gofrend ;stop execution when >$80 (may be used by slide-fx to priorize)
        beq readfrq
        dec frqdelaycnt,x
        jmp frqprog_end ;vib/slide
.fi
readfrq ldy freqtbcnt,x
.if (PLAYER_FOR_EDITOR!=0)
        tya
        sta freqtbpos,x ;in editor (this avoids display phase differences)
.fi
        lda (playzp),y
        bne +
gofrend jmp frqprog_end
+       bpl chrelno
        cmp #jumpval
        beq frqtjmp
.if (VIBRATO_SUPPORT!=0)
        cmp #vibrato_min
        beq setvibr
.fi
        and #$7F
        jmp absnote
frqtjmp iny
        lda (playzp),y
.if (PLAYER_FOR_EDITOR!=0)
        ldy #freqtbstartindexpos
        clc
        adc (playzp),y ;editor should calculate this when packing tune
        cmp freqtbcnt,x ;safety check to avoid freeze in editor
        beq gofrend ;frqprog_end
.fi
        sta freqtbcnt,x
        jmp readfrq
chrelno cmp #relnote_min
        bcs chkupdn ;note or delay/slide/detune?
        cmp #detune_min
        bmi chfrdly ;detune or slide/delay?
.if (DETUNE_SUPPORT!=0)
setdetu and #$0F
        sta detune,x
.fi
        jmp frtbadv
chfrdly cmp #delay_max+1
.if (TABLE_DELAY_SUPPORT!=0)
        bcs setslid ;slide/delay?
frdelay sec
        sbc #1
        sta frqdelaycnt,x
        jmp frtbadv
.else
        bcc frtbadv
.fi
setslid sta vibslide,x ;ldy vibslide,x ;bmi frqprog_end don't ruin existing (patt.fx-initiated?) vibrato - done in 'dofx'
        jmp frtbadv
.if (VIBRATO_SUPPORT!=0)
setvibr 
 .if ( (SLIDES_SUPPRASS_VIB_SUPPORT!=0 || LEGATO_SUPPRASS_VIB_SUPPORT!=0) && VIBRATO_RESTORE_SUPPORT!=0)
        cmp vibsuprass,x
        bcc frqprog_end ;if slide/portamento-patternfx in progress (vibsuprass=$ff), don't start the vibrato yet
 .fi
        inc freqtbcnt,x ;slide/vib. pattern-fx should have the priority over this
 .if ( (SLIDES_SUPPRASS_VIB_SUPPORT!=0 || LEGATO_SUPPRASS_VIB_SUPPORT!=0) && VIBRATO_RESTORE_SUPPORT==0)
        cmp vibsuprass,x
        bcc frtbadv ;if slide/portamento-patternfx in progress (vibsuprass=$ff), skip the vibrato-setting, only advance in table
 .fi
        iny
 .if (INCREMENTAL_VIBRATO_SUPPORT!=0)
        sta acstore+1
        lda (playzp),y
        and #$0F ;sallang OFF :)
acstore ora #selfmod        
 .else
        ora (playzp),y ;$80 + (1st and) 2nd nybble of next freq.table-row
 .fi
        sta vibslide,x
 .if (PORTAMENTO_SUPPORT!=0 && VIBRATO_RESTORE_SUPPORT!=0)
        sta vibstore,x ;to continue vibrato automatically after portamento(/legato)
 .fi
        lda (playzp),y
        and #$F0
        lsr
        sta vibrate,x
        lsr
        lsr
        sta vibracnt,x
        jmp frtbadv
.fi
chkupdn cmp #reldn_incv_min ;sets Carry flag to determine relative note-change: up or down
.if (VIBRATO_SUPPORT!=0 && INCREMENTAL_VIBRATO_SUPPORT!=0)
        beq setvibr ;incremental vibrato?  ;beq frqprog_end ;? whatever (e.g. incr.vibrato/shortframe/etc.)
.fi
relnote pha
        tya
        sta frelindex,x
        pla
        and #$3F
        bcc relntup ;using Carry set above at 'chkupdn'
relntdn ora #$C0 ;convert $6x..$7F to $Ex..$FF 'subtract' value
relntup clc
;.if (SEQ_FX_SUPPORT!=0 && TRANSPOSE_SUPPORT!=0)
;        adc transpose,x ;this caused a bug of transposing the last note of a pattern before the next transpose event in orderlist
;        clc ;negative ($80..$FF) transpose would turn Carry to 1 with the 'adc' above
;.fi
.if (PORTAMENTO_SUPPORT!=0)
        sta frelshift,x
.fi
        adc currnote,x
absnote 
.if (LOWFREQ_NOISELOOP_SUPPORT!=0)
        sec
        sbc #lowest_pulse_note ;Carry set by previous cmp
        sta lowfreqsig,x ;tell TED-register writer to change to 'noiseloop'
        bcs + ;deep notes? using 'noiseloop' range
        adc #lowest_pulse_note+3*12+1 ;Carry is 0 here, no need to set
+       tay
        lda freqtablo,y
        sta freqlo_gho,x
        lda freqtabhi,y
.else
+       tay
        ;cpy #lowest_pulse_note
        ;bcc frtbadv
        lda freqtablo-lowest_pulse_note,y
        sta freqlo_gho,x
        lda freqtabhi-lowest_pulse_note,y        
.fi
        sta freqhi_gho,x
frtbadv inc freqtbcnt,x
frqprog_end


;------------------ Waveform-table program execution -------------------
.if (MULTISPEED_ENTRY_SUPPORT!=0 && TABLE_MULTISPEED_SEL_SUPPORT!=0)
        lda mulpsig+1
        beq wfprog
mulpval lda #selfmod
        and #wfmultiswitch ;check wf-table multispeed switch-bit
        beq gowpend ;wfprog_end ;multisped wf-table?
.fi
wfprog  
.if (TABLE_DELAY_SUPPORT!=0)
        lda wfdelaycnt,x
        beq readwf
        dec wfdelaycnt,x
gowpend jmp wfprog_end
.fi
readwf  ldy wftbcnt,x
.if (PLAYER_FOR_EDITOR!=0)
        tya
        sta wftbpos,x ;in editor (this avoids display phase differences)
.fi
        lda (playzp),y
        beq wfprog_end
        cmp #jumpval
        bcc setdwfs ;jump or set delay + waveform + phase&syncmode?
wftbjmp iny
        lda (playzp),y
.if (PLAYER_FOR_EDITOR!=0)
        clc
        adc #wftbstartindex  ;editor should calculate this when packing tune
        cmp wftbcnt,x ;safety check to avoid freeze in editor
        beq wfprog_end
.fi
        sta wftbcnt,x
        jmp readwf
setdwfs
.if (TABLE_DELAY_SUPPORT!=0)
        cmp #delay_max+1
        bcc wfdelay ;only delay setting? (00..0F)
.fi
setwfrm 
.if (SYNC_SUPPORT!=0 || PHASE_SUPPORT!=0)
        sta syncmode,x
        cmp #phase_min
        bcs setpuls
.fi
        and #$60
chsilen cmp #silence_min ;bigger than $20: set pulse, lower: set silence
        bcs setsile
chnoise cmp #noisewf_min
setnois bcs writewf
setpuls lda pulsewfval,x
        .byte $2C ;skip
setsile lda #0 ;pre-set silence
writewf sta waveform,x
.if (TABLE_DELAY_SUPPORT!=0)
wfdelay lda (playzp),y
 .if (PHASE_SUPPORT!=0)
        bmi wftbadv
 .fi
        and #$0f
        beq wftbadv
 .if (SOUNDSTART_CLICK_SUPPORT!=0) 
        cmp #$0F ;shortframe/soundstart-click?
        beq wftbadv
 .fi
        sec
        sbc #1
        sta wfdelaycnt,x
.fi
wftbadv inc wftbcnt,x
wfprog_end


;----------------------- Slide/Vibrato/Portamento ----------------------
;Slide, portamento, vibrato, incremental vibrato ;playzp+0 and playzp+1 can be reused here
discrnote=playzp+0
freqmod=playzp+1 
.if (MULTISPEED_ENTRY_SUPPORT!=0)
        lda mulpsig+1 ;could be placed into the single-speed call instead (not editor-jammode friendly btw)
        beq dovibsl ;bne govsend ;no multispeed needed for vibrato/slide, no pattern-FX to be performed in multispeed-call
        jmp nextchn ;skip also patternfx in case of multispeed
.fi
dovibsl  
.if (BALANCED_SLIDE_SUPPORT!=0)
        lda currnote,x  ;calculate difference of target note and current pitch
        clc
        adc frelshift,x ;transpose,x 
        sta discrnote
        tay ;from now on Y is the discrete note-pitch (portamento destroys it after usage)
.fi
        lda vibslide,x
        bne chvibsl
govsend jmp dovibsl_end
chvibsl
.if (VIBRATO_SUPPORT!=0) 
        bpl +
vibrato and #$0F
        jmp vibrat2
+
 .if (INCREMENTAL_VIBRATO_SUPPORT!=0)
        cmp #reldn_incv_min
        bcc +
incvibr lda vibrampl,x
        jmp vibrat2
+
 .fi
.fi

.if (PORTAMENTO_SUPPORT!=0)
chporta cmp #porta_min
        bcc chslide
        cmp #legatofx ;porta_max+1
        beq govsend ;govsend ;bcs govsend ;bcc portame ;bcs govsend ;portamento or legato (legato = high-speed portamento)
        ;lda #$ff ;high portamento-speed (legato) - now using better method in readnote: jumping back in freqtb
        ;sta freqmod
portame
        and #$0F
 .if (BALANCED_SLIDE_SUPPORT==0)
        sta freqmod  
        lda currnote,x  ;calculate difference of target note and current pitch
        ;clc Carry=0 here by cmp #legatofx
        adc frelshift,x ;transpose,x 
        sta discrnote
 .else  ;for portamento this should be calculated in advance to have final difference in freqmod before checking
  ;.if (LOWFREQ_NOISELOOP_SUPPORT!=0) ;this can be omitted thanks to 'exptables' used below
  ;      cpy #lowest_pulse_note ;l
  ;      bcc wrfreqm
  ;.fi
        cpy #lowest_pulse_note+2*12 ;first 2 normal octaves need a little bit of boost
        bcs ++      
        cpy #lowest_pulse_note+1*12 
        bcs + ;bcs wrfreqm
        adc #16 ;Carry=0 here ;asl ;*2
+       tay ;asl ;*4
        lda exptables,y ;better than simple multiplication (asl), because fine granularity of small values remains
+       sta freqmod
        lda discrnote
 .fi
 .if (LOWFREQ_NOISELOOP_SUPPORT!=0)
        sec
        sbc #lowest_pulse_note
        sta lowfreqsig,x
        bcs +
        adc #lowest_pulse_note+3*12+1 ;Carry is set by previous 'sbc'
+       tay
        lda freqtablo,y ;-lowest_pulse_note,y
        sbc freqlo_gho,x
        pha
        lda freqtabhi,y ;-lowest_pulse_note,y
 .else
        tay
        lda freqtablo-lowest_pulse_note,y
        sbc freqlo_gho,x
        pha
        lda freqtabhi-lowest_pulse_note,y
 .fi
        sbc freqhi_gho,x
        tay
        pla
        bcs portaup
portadn adc freqmod ;targetfreq < currentfreq; check if (currentfreq-targetfreq) > -freqmod
        tya
        adc #0 ;freqmod_hi ;add Carry
        bcs portend ; >= ?
        bcc subfreq ; < ?
portaup sbc freqmod ;targetfreq >= currentfreq; check if (targetfreq-currentfreq) > freqmod
        tya
        sbc #0 ;freqmod_hi ;subtract Carry
        bcc portend ; < ?
        jmp addfreq
portend lda discrnote ;lda currnote,x  ;calculate difference of target note and current pitch
 .if (LOWFREQ_NOISELOOP_SUPPORT!=0)
        sec
        sbc #lowest_pulse_note
        sta lowfreqsig,x
        bcs +
        adc #lowest_pulse_note+3*12+1 ;Carry is set by previous 'cmp'
+       tay
        lda freqtablo,y ;-lowest_pulse_note,y 
        sta freqlo_gho,x
        lda freqtabhi,y ;-lowest_pulse_note,y
 .else
        tay
        lda freqtablo-lowest_pulse_note,y 
        sta freqlo_gho,x
        lda freqtabhi-lowest_pulse_note,y
 .fi
        sta freqhi_gho,x
 .if (VIBRATO_SUPPORT!=0 && VIBRATO_RESTORE_SUPPORT!=0)
restovi lda vibstore,x ;restore vibrato if exists (by freq-table)
        sta vibslide,x
        lda vibrate,x
        lsr
        lsr
        sta vibracnt,x
 .fi
        jmp dovibsl_end
;.else
;        cmp #porta_min
;        bcs dovibsl_end ;ignore effects above portamento
.fi

chslide cmp #slidedown_min ;sets carry based on direction of slide
        and #$0F
.if (BALANCED_SLIDE_SUPPORT==0)
        sta freqmod
        bcc addfrq2
        bcs subfreq
.else
        jmp calcfm2
.fi


subfreq lda freqlo_gho,x
        sbc freqmod
        sta freqlo_gho,x
        bcs dovibsl_end ;govend2
        dec freqhi_gho,x
govend2 jmp dovibsl_end


.if (VIBRATO_SUPPORT!=0)
vibrat2 sta freqmod
dovibra lda vibracnt,x
        bne +
        lda vibrate,x
+       sec
        sbc #2
        sta vibracnt,x
        asl
        cmp vibrate,x
        bcs (BALANCED_SLIDE_SUPPORT==0) ? subfreq : calcfreqmod

 .if (INCREMENTAL_VIBRATO_SUPPORT!=0 || GENTLE_VIBRATO_FX_SUPPORT!=0)
champla asl ;Carry=0 if the value wasn't bigger than $7F (which is the case)
        eor vibrate,x ;XOR-comparison instead of 'cmp' preserves Carry-flag
        bne (BALANCED_SLIDE_SUPPORT==0) ? addfreq : calcfreqmod
  .if (INCREMENTAL_VIBRATO_SUPPORT!=0)
        lda vibslide,x ;cpy #vibrato_min 
        bmi chgentv ;bcs chgentv ;normal vibrato or incremental? if normal, jump to gentle-vibrato setting or 'subfreq'
        and #$0F ;Carry=1 here 
        clc ;warning: Carry altered to 0, 'sec' is needed some rows below before entering 'subfreq'
        adc vibrampl,x ;adc freqmod
        sta vibrampl,x ;sta freqmod;accumulate amplitude-value
        sta freqmod ;sta vibrampl,x
   .if (GENTLE_VIBRATO_FX_SUPPORT!=0)
        bcc addfreq  ;jmp addfreq ;no calculated freq.modify for incremental vibrato-type
   .fi
  .fi
chgentv ;check 'gentle vibrato' amplitude prescription
  .if (GENTLE_VIBRATO_FX_SUPPORT!=0)
        lda vibrampl,x
        beq (BALANCED_SLIDE_SUPPORT==0) ? addfreq : calcfreqmod
        sta freqmod
        ora #vibrato_min 
        sta vibslide,x ;make it permanent
  .if (PORTAMENTO_SUPPORT!=0 && VIBRATO_RESTORE_SUPPORT!=0)
        sta vibstore,x
  .fi
        lda #0 ;acknowledge
        sta vibrampl,x
  .fi
 .fi
.fi

.if (BALANCED_SLIDE_SUPPORT!=0)
calcfreqmod ;using Y (discrnote) to determine octave, but freqhi_gho could be used too, as 0..1 values are octave0, 2 is octave 1
        lda freqmod       ;(Though discrnote is needed by 'portamento' anyway, so using it in Y eats less memory)
calcfm2 php ;store Carry
  ;.if (LOWFREQ_NOISELOOP_SUPPORT!=0) ;this can be omitted thanks to 'exptables' used below
  ;      cpy #lowest_pulse_note ;l
  ;      bcc wrfreqm
  ;.fi
        cpy #lowest_pulse_note+2*12 ;first 2 normal octaves need a little bit of boost
        bcs ++      
        cpy #lowest_pulse_note+1*12 
        bcs + ;bcs wrfreqm
        adc #16 ;Carry=0 here ;asl ;*2
+       tay ;asl ;*4
        lda exptables,y ;better than simple multiplication (asl), because fine granularity of small values remains
+       plp ;restore Carry
        bcc addfrq2
        sta freqmod
        bcs subfreq
.fi

addfreq lda freqmod
addfrq2 adc freqlo_gho,x
        sta freqlo_gho,x
        bcc dovibsl_end
        inc freqhi_gho,x
dovibsl_end




;----------------------- pattern effect handling -----------------------
patternfx ;vibrato-slide handler already skips this in case of multispeed-call (mulpsig+1!=0)
.if (PLAYER_FOR_EDITOR!=0)
        lda playmode
        beq patternfx_end ;if jamming mode in editor, don't initiate any effects
.fi
.if (FRAME_NOSKIP_SUPPORT==0 && FRAMESKIP_NOTEVOL_SUPPORT!=0)
        lda notevol_fx,x
        beq +
        sta notevol,x
        lda #0
        sta notevol_fx,x
+
 .fi
 .if (NOTE_FX_SUPPORT!=0)
notefx  lda #selfmod
        beq instfx  
        jsr dofx
 .fi
instfx  lda #selfmod
        beq pattfx
        jsr dofx
pattfx  lda #selfmod
        beq patternfx_end
        jsr dofx
patternfx_end




;=================== END OF ONE CHANNEL'S PROCESSING ===================




nextchn dex
        bmi +
        jmp chnloop ;next channel
+
.if (SOUNDSTART_CLICK_SUPPORT==0 && FRAME_NOSKIP_SUPPORT!=0)
        rts        
.fi




;========================= WRITE VALUES TO TED =========================




ghostwr 
.if (TED_SOUND_SUPPORT>0)
        lda freq1hi   ;preserve current character/bitmap data address
        and #%11111100
        sta chaddst+1
.fi

mixing  
.if (PLAYER_FOR_EDITOR!=0)
        ldx #CHANNELAMOUNT-1
-       lda currnote,x ;note 0 is silence in editor (used by pos.play with Shift+Space)
        bne +
        sta notevol,x
+       dex
        bpl -
.fi
.if (MIXING_MODES_SUPPORT!=0)
        lda notevol+0
        bne c1valid ;1st channel volume is zero or not?
prio2nd lda notevol+1 ;set volume to 2nd channel
        jmp (MAIN_VOLUME_SUPPORT==0) ? maindiv : compens
c1valid clc
        adc notevol+1 ;adding for averaging
        cmp notevol+0 ;2nd channel volume is zero?
        beq (MAIN_VOLUME_SUPPORT==0) ? maindiv : compens ;set volume to 1st channel 
mixboth bit mixingmode+1 ;here both sounds are turned on, mixingmode determines what to do
        bmi prio2nd      ;2nd channel has the priority if not averaging, that's why it's here
        bit mixingmode+0
        bmi prio1st
        bvs louder
        bit mixingmode+1
        bvc avermix
louder  lda notevol+0
        cmp notevol+1
        bcc prio2nd
prio1st lda notevol+0
compens asl ;*2 ;000XXXX0
avermix
 .if (MAIN_VOLUME_SUPPORT==0)
        lsr
 .else
        and #$FE
 .fi
.else ;the default mixing mode is 'louder' (the louder current note-volume affects/sets the common TED-volume)
        lda notevol+0
        cmp notevol+1
        bcs maindiv
        lda notevol+1
.fi

maindiv 
.if (MAIN_VOLUME_SUPPORT!=0)
;method1: unrolled loop; 46/44 cycles (without 0-checking), size: 31/29 bytes (loop-version:53/51 cycles, 18/17 bytes (depending on averager 'asl' optimization)
 .if (MIXING_MODES_SUPPORT==0) ;mixing modes already shifted the value one step left for averager compensation
        asl          ;2 ;*2  ;000XXXX0 ;multiplier to upper nybble, 0 to lower nybble
 .fi ;this optimization is only for method 1, for method2 (smallest memory footprint), comment it out
        asl          ;2 ;*4  ;-> Accu = 00XXXX00
        beq maindiv_end ;save some cycles if nothing to mix
        asl          ;2 ;*8  ;-> Accu = 0XXXX000
        asl          ;2 ;*16 ;-> Accu = XXXX0000
chMuMSB asl          ;2  ;check MSB of multiplier ;                  -> Carry <- XXX00000
        bcc +        ;3/2 ;add or not to add?
mainvol adc #selfmod ;0/2 ;add multiplicand+1 (1..$10)               ->   Accu = XXXrVVVV ;'X':multiplier, 'r':result, 'V':volume
+       asl          ;2  ;check next bit of multiplier and           -> Carry <- XXrVVVV0
        bcc +        ;3/2
        adc mainvol+1;0/4 ;add multiplicand+1 to shifted partial result-> Accu = XXrrVVVV
+       asl          ;2                                              -> Carry <- XrrVVVV0
        bcc +        ;3/2
        adc mainvol+1;0/4                                            ->   Accu = XrrrVVVV
+       asl          ;2                                              -> Carry <- rrrVVVV0
        bcc +        ;3/2
        adc mainvol+1;0/4                                              -> Accu = rrrrVVVV
+       lsr          ;2 ;shift result to lower nybble (divide by 16)   -> Accu = 0rrrrVVV
        lsr          ;2                                                -> Accu = 00rrrrVV
        lsr          ;2                                                -> Accu = 000rrrrV
        lsr          ;2                                                -> Accu = 0000rrrr
;method2: this method takes maximum 7+4*16-1 = 70 cycles! size: 16 bytes, unrolled version would take 48 cycles for 35 bytes)
;        sta playzp   ;3  
;        lda #0       ;2   ;we're accumulating quasi-multiplication result in Accu
;        ldx #4       ;2   ;initial state: playerzp=0000abcd, Accu=0000000, Carry=unknown, mainvol=0000efgh
;-       ror playzp   ;5   ;check next bit of multiplier
;        bcc +        ;3/2 ;adding based on state of multiplier-bit
;mainvol adc #selfmod ;0/2 ;last addition will be the most significant
;+       lsr          ;2   ;by having this at the end, range is reduced from $00..$1F to $00.$0F when exiting loop
;        dex          ;2   ;repeat addition for all the 4 bits
;        bne -        ;3/2
;other method could be using exp.table, which is faster (only lookop and add/sub) but less precise
;using 'mainvol' as multiplier and having it always in high-nybble complicates things and gives only 2 cycles' gain
        bne maindiv_end
        lda #1 ;don't allow to mix to 0 value -> avoids clicking when fading out (needs zero checking at beginning of 'maindiv')
maindiv_end          ;(unfortunately volume 0 = silence is lost with this hack, but workaround is easy: music can be stopped for zero volume)
.fi
.if (TED_SOUND_SUPPORT>0)
        sta sndctrl_gho ;register volume nybble
.fi
.if (TED_EMULATION_BY_SID_SUPPORT>0)
        tay
        lda SIDvolConv,y
        sta SIDvolume
.fi


.if (SYNC_SUPPORT!=0 || PHASE_SUPPORT!=0)
        lda syncmode+0 ;pre-check and merge sync-mode for both channels
        ora syncmode+1
        sta syncher+1
.fi
        ldx #CHANNELAMOUNT-1 
wrwavef lda sndctrl_gho
        ldy notevol,x
        beq +
.if (PLAYER_FOR_EDITOR!=0)
        ldy stopmutesig,x
        bne +
.fi
        ora waveform,x
.if (LOWFREQ_NOISELOOP_SUPPORT!=0)
        ldy lowfreqsig,x ;set noiseloop when low frequency is detected
        bpl +
        and #$FF-pulse2
        ora #noise ;switch to noiseloop
.fi
+
.if (PLAYER_FOR_EDITOR!=0)
        ldy playmode
        beq + ;only mute tune, not jammed instruments
        and mutesolo,x
+
.fi
        sta sndctrl_gho

.if (SYNC_SUPPORT!=0 || PHASE_SUPPORT!=0)
 .if (PHASE_SUPPORT!=0 && TED_SOUND_SUPPORT>0) ;no 'PHASE' emulated on SID yet
phaser  bit syncher+1
        bpl + ;no phase-request on any channels?
        lda #0 ;and #$F0 ;normal phase for normal channel (need to set normal too, as 'sync' bit uses that too)
        sta playzp
        ldy syncmode,x
        bpl adcfreq
        tya
        and #$7F
        asl
        asl
        rol playzp
        asl
        rol playzp
adcfreq ;clc ;rol above clears Carry
        adc freqlo_gho,x
  ;.if (TED_SOUND_SUPPORT>0)
        sta freq1lo,x
  ;.fi
        lda freqhi_gho,x
        adc playzp ;add with Carry
  ;.if (TED_SOUND_SUPPORT>0)
        ldy freqhi_ghondex,x
        and #%00000011 ;frequency-high is only the lower 2 bits
        ora chaddst+1
        sta freq2hi,y 
  ;.fi 
 .fi
+       dex
        bpl wrwavef

syncher lda #selfmod
        and #sync_bitvalue+phase_min
        beq +
 .if (TED_SOUND_SUPPORT>0)
        lda #$80 ;D/A mode (sync,start-output-high) bit
        ora sndctrl
        sta sndctrl
 .fi
 .if (TED_EMULATION_BY_SID_SUPPORT>0)
        lda #$09
        sta SIDctrl1
        sta SIDctrl2
 .fi
+

 .if (PHASE_SUPPORT!=0 && TED_SOUND_SUPPORT>0)
        nop ;some extra cycles needed for stabler PHASE operation on real TED machine
 .fi
        lda sndctrl_gho ;this is fairly close to both the syncher and the final freq.writer -> less audible when switching
 .if (TED_SOUND_SUPPORT>0)
        sta sndctrl 
 .fi
 .if (PHASE_SUPPORT!=0 && TED_SOUND_SUPPORT>0)
        cmp (playzp,x) ;around minimum 20 cycles delay is needed till 'wrifreq' for stable operation (enough time to reset counters)
        cmp playzp,x   ;needed in VICE emulator for better PHASE stability?
 .fi
        ldx #CHANNELAMOUNT-1
-       
 .if (PHASE_SUPPORT!=0)
        lda syncmode,x
        bpl +
        lda #0
        sta syncmode,x ;perform phasing only once (at note-start or when set in table)
+
 .fi
.fi
.if (DETUNE_SUPPORT!=0)
        lda detune,x
        clc
        adc freqlo_gho,x
.else
        lda freqlo_gho,x
.fi
;.if (TED_SOUND_SUPPORT>0)
        sta freq1lo,x
;.fi
        lda freqhi_gho,x
.if (DETUNE_SUPPORT!=0)
        adc #0 ;add Carry
.fi
.if (TED_SOUND_SUPPORT>0)
        ldy freqhi_ghondex,x
        and #%00000011 ;frequency-high is only the lower 2 bits
chaddst ora #selfmod
        sta freq2hi,y  
.else
 .if (TED_EMULATION_BY_SID_SUPPORT>0) 
        sta freq1hi,x
 .fi
.fi
        dex
.if (SYNC_SUPPORT!=0 || PHASE_SUPPORT!=0)
        bpl -
.else
        bpl wrwavef
 .if (TED_SOUND_SUPPORT>0)
        lda sndctrl_gho
        sta sndctrl 
 .fi
.fi

.if (TED_EMULATION_BY_SID_SUPPORT>0)
        lda freq1lo ;freqlo_gho+0
        ldx freq1hi ;freqhi_gho+0
        jsr convFreq
        sta SIDfreq1lo
        stx SIDfreq1hi 
        ldy #$01 ;$40       
        lda notevol+0
        beq wrSIDc1
 .if (PLAYER_FOR_EDITOR!=0)
        lda stopmutesig+0
        bne wrSIDc1
 .fi
        lda sndctrl_gho
        and #pulse1 ;$10
        beq wrSIDc1
        ldy #$41
wrSIDc1 sty SIDctrl1
        lda freq2hi ;freqhi_gho+1
        and #$03
        tax
        lda freq2lo ;freqlo_gho+1
        jsr convFreq
        sta playzp+0
        ldy #$01 ;$40
        lda notevol+1
        beq wrSIDc2
 .if (PLAYER_FOR_EDITOR!=0)
        lda stopmutesig+1
        bne wrSIDc2
 .fi
        lda sndctrl_gho
        and #pulse2+noise ;$20, $40
        beq wrSIDc2
        ldy #$41
        cmp #noise
        bcc wrSIDc2
        txa
        lsr
        ror playzp+0
        lsr
        ror playzp+0
        lsr
        ror playzp+0
        tax
        ldy #$81
wrSIDc2 sty SIDctrl2 
        lda playzp+0
        sta SIDfreq2lo
        stx SIDfreq2hi
        rts
.if (TED_SOUND_SUPPORT==0)
freq1lo .byte 0
freq2lo .byte 0
freq1hi .byte 0
freq2hi .byte 0
.fi

convFreq ;input: A=TEDfreqLo, X=TEDfreqHi; output: A=SIDfreqLo, X=SIDfreqHi
        ldy #3+1 ;causes division by 8
        cpx #$02 ;test TEDfreqHi
        bcs TEDfH23 ;TEDfreq == $000...$1FF or $2?         
TEDfH01 cpx #$01 ;inputcase: %0H_LLLLLLLL  ; Carry = (X==1)
        ror      ;outputcase: A=%HLLLLLL0
        iny ;Y=4+1 causes division by 16
        bne SIDlkup ;jump  
TEDfH23 beq SIDlkup ;inputcase: %10_LLLLLLLL -> outputcase: A=%LLLLLLL0
TEDfrH3 cmp #$FA
        bcc + ;ultravoice($3FA..$3FD) or no-sound($3FE) ? -> make it 'inaudible'
        lda #0
        beq wrifrqX ;jump
+       dey ;inputcases: %11_0LLLLLLL, %11_10LLLLLL, %11_110LLLLL, %11_1110LLLL 
        asl ; exitcases: Y3-%LLLLLLL0, Y2-%LLLLLL00, Y1-%LLLLL000, Y0-%LLLL0000 
        bcs TEDfrH3    
SIDlkup and #$FE ;looking up words not bytes
        tax   
        lda TEDtoSIDfreqTable+1,x ;TableHi
        sta playzp+0
        lda TEDtoSIDfreqTable+0,x ;TableLo
        dey ;Y=1..5 -> Y=0..4
        beq + ;Y==0? -> no division needed
        bpl divTres
        asl
        rol playzp+0
        bcc + ;out of SID-range? -> saturate to SIDvalue=$FFFF (3.8kHz)
        tya ;lda #$ff
wrifrqX tax
        rts
divTres lsr playzp+0
        ror 
        dey   ;left-shift Y (1..5) times
        bne divTres
+       ldx playzp+0
.fi

retplay rts




;========================== PATTERN EFFECTS ============================




dofx    bmi chvibfx ;>=vibrato_min? halving range


chfrjmp cmp #freqjmp_min ;$70
        bcc chvojmp
fx_freqtable_jump
        ldy currinst,x 
        beq retfx ;don't run non-existing zero-instrument (would cause unpredictable results)
        pha
p_insl3 lda insptlo,y
        sta playzp+0
p_insh3 lda inspthi,y
        sta playzp+1
        pla
        and #$0F
        clc
        ldy #freqtbstartindexpos
        adc (playzp),y
        sta freqtbcnt,x
.if (TABLE_DELAY_SUPPORT!=0)
        lda #0
        sta frqdelaycnt,x
.fi
retfx   rts        


chvojmp cmp #voljump_min ;$60
        bcc cportfx
fx_voltable_jump ;can be used better for note-volume setting with ADSR simulation
        ldy currinst,x 
        beq retfx
        pha
p_insl4 lda insptlo,y
        sta playzp+0
p_insh4 lda inspthi,y
        sta playzp+1
        pla
        and #$0F
        clc
        ldy #voltbstartindexpos
        adc (playzp),y
        sta voltbcnt,x
.if (SOUNDSTART_CLICK_SUPPORT!=0 && STARTCLICK_VOL_SUPPORT!=0 && FRAME_NOSKIP_SUPPORT==0)
        tay
        lda (playzp),y
        sta frame1vol,x
.fi
.if (TABLE_DELAY_SUPPORT!=0)
        lda #0
        sta voldelaycnt,x
.fi
        rts


cportfx cmp #porta_min ;$30
        bcc cslidfx


cnotevo cmp #notevolfx_min ;$50
        bcc chwfjmp
fx_note_volume
        and #$0F
.if (FRAME_NOSKIP_SUPPORT!=0 || FRAMESKIP_NOTEVOL_SUPPORT==0)
        sta notevol,x
.else
        sta notevol_fx,x
.fi
.if (SOUNDSTART_CLICK_SUPPORT!=0 && STARTCLICK_VOL_SUPPORT!=0 && FRAME_NOSKIP_SUPPORT==0)
        sta frame1vol,x
.fi
        rts


chwfjmp cmp #wfjump_min ;$40
        bcc retfx ;no portamento performed here (already done in 'readptn')
fx_wftable_jump
        and #$0F
        clc
        adc #wftbstartindex
        sta wftbcnt,x
.if (TABLE_DELAY_SUPPORT!=0)
        lda #0
        sta wfdelaycnt,x 
.fi
        rts


chvibfx 
.if (VIBRATO_SUPPORT!=0)
        cmp #detunefx_min ;$90
        bcs ctmpofx
fx_vibrato_amp
 .if (GENTLE_VIBRATO_FX_SUPPORT!=0)
        ldy vibslide,x
        bpl usualvi ;if incremental vibrato, set as usual, if normal vibrato (>$80) is already running, only prescribe it
        and #$0F
        sta vibrampl,x ;prescribe gentle vibrato
        rts
 .fi
usualvi sta vibslide,x
 .if (PORTAMENTO_SUPPORT!=0 && VIBRATO_RESTORE_SUPPORT!=0)
        sta vibstore,x
 .fi
 .if (INCREMENTAL_VIBRATO_SUPPORT!=0)
        and #$0F
        sta vibrampl,x
 .fi
        lda vibrate,x
 .if (DEFAULT_VIBRATO_RATE_SUPPORT!=0)
        bne +
        lda #defaultvibrate*8
        sta vibrate,x
 .fi
        lsr
        lsr
        sta vibracnt,x
+       rts
.fi


ctmpofx cmp #tempo_min ;$B0
        bcc (MAIN_VOLUME_SUPPORT!=0 || DETUNE_SUPPORT!=0) ? chvolfx : retfx2
.if (PLAYER_FOR_EDITOR!=0)
        cmp #packNOP_min
        bcs retfx
.fi
fx_set_tempo
.if (TEMPOPROGRAM_SUPPORT!=0)
        ldy tempotable_offsets,x
.fi
        and #$0f
        sta tempocnt,x
.if (TEMPOPROGRAM_SUPPORT!=0)
        ora #$80
        sta tempotables,y
.else
        sta tracktempo,x
.fi
retfx2  rts


cslidfx cmp #slideup_min ;$10
        bcc fx_rowtime
fx_slides
        ;and #$3F
        sta vibslide,x
.if (VIBRATO_SUPPORT!=0 && SLIDES_SUPPRASS_VIB_SUPPORT!=0)
        and #$0f
        beq +
        lda #$ff ;inform freq.table program not to allow vibrato till the slide is over (zeroed)
+       sta vibsuprass,x ;vibslide,x ;stop slide, allows execution of vibrato in freq.table
.fi
;.if (TABLE_DELAY_SUPPORT!=0)  ; && FRAME_NOSKIP_SUPPORT!=0)
;        and #$0f  ;supprassing freq.table seems not a good idea, maybe only to override delayed vibrato
;        beq + ;value is 0 to continue freq.table if slide-value is set to 0
;        lda #$ff ;priorize slide over instrument-freq.table execution (temporarily?) 
;+       sta frqdelaycnt,x 
;.fi
        rts


fx_rowtime ;time of current row (temporary tempo)
        and #$0f
        ;clc 
        ;adc tempocnt,x
        sta tempocnt,x
        rts


chvolfx
.if (MAIN_VOLUME_SUPPORT!=0)
        cmp #mainvol_min ;$A0
        bcc (DETUNE_SUPPORT!=0) ? cdetufx : retfx2
fx_main_volume
        and #$0F
        sta mainvol+1
 .if (MAIN_VOLUME_FADEOUT_SUPPORT!=0)
        lda #0
        sta mfadspd+1
 .fi
        rts

 .if (MAIN_VOLUME_FADEOUT_SUPPORT!=0)
extmvol cmp #$10
        bcc fx_main_volume ;> $10 ? -> init fadeout  (called from outside)
        sta mfadspd+1
        sta mainvolfadecnt
        rts
 .fi
.fi


cdetufx
.if (DETUNE_SUPPORT!=0)
 .if (MAIN_VOLUME_SUPPORT==0)
        cmp #mainvol_min
        bcs retfx2
 .fi
 .if (VIBRATO_SUPPORT==0)
        cmp #detunefx_min
        bcc retfx2
 .fi
fx_detune_phase
        and #$0F
        sta detune,x ;decided to make it permanent to avoid pattern-duplications, now reset in init routine only
        rts
.fi




;=======================================================================
.here
player_bottom
.endm ;player-macro ends here




;=======================================================================
