
;============================== TUNEDATA ===============================
;music header and packed data immediately follows the player
;*=$4000 
;.align $100 ;this shouldn't be here in exported tune
;.warn"Address of tune-data = ",*

tuneheader_size=$10
tuneheader .block ;if new parameters are to be added, they mustn't be inserted, so the format stays the same between versions
formatspec .text "TZW1"         ;0   ;TEDzakker Workfile magic ID
baseaddress    .word tuneheader ;4,5 ;absolute address of originally saved data, needed to calculate (shift) pointertable and its addresses
playertype     .byte 0          ;6   ;PLAYERTYPE ;converted from text to number - doesn't work all way round, need to set by software at init
subtune_amount .byte 0          ;7   ;(don't even change the order of these parameters, so you we can keep backwards kompatibility)
ins_amount     .byte 0          ;8
ptn_amount     .byte 0          ;9   ;final pattern-amount based on last non-empty pattern or used_ptn_amount if it's bigger
framespd       .byte 1          ;10
defaultptlen   .byte defptnlen  ;11
playtime0      .word $0000      ;12,13 ;detected duration of 1st subtune in seconds (set automatically after a playback of the whole subtune)
;ptrtables_addr .word pointertables ;$0000 ;absolute base-address of pointertables (not necessary as the structure of file-tail is well known)
;What's new to add? Add it here! ;bytes inbetween are kept for expansion coming later
*=tuneheader+tuneheader_size
.bend
tuneheader_end 


;.text "------------ TUNE PACK-AREA -------------"
packed_data_start
.if (MACHINE>0)
 .fill $100+2,0 ;give a little gap (around a pattern's maximal size) for in-place decompression
.else
 .fill maxseqlen*CHANNELAMOUNT+2,0 ;ins_maxsize,0 ;maxptnlen,0
.fi
depack_data_start

emptyseqval=seqendval
emptywfval=instbendval
emptyfrval=instbendval
emptyvoval=instbendval

;.warn"Address of orderlists = ",*
orderlists
orderlist0
.for i=0, i<maxsubtuneamount, i=i+1
 .for j=0,j<CHANNELAMOUNT,j=j+1
  .fill maxseqlen,emptyseqval ;j+i*16
  .byte seqendval
 .next
.next

;.warn"Address of instruments = ",*
instruments
.for i=1, i<=maxinstamount, i=i+1 ;0 instrument is needed to have some gap for in-place decompression
 #emptyinsm
.next

;.warn"Address of patterns = ",*
patterns
.for i=1, i<=maxptnamount, i=i+1
 .fill maxptnlen,ptnNOPval ;emptynoteval ;.fill defptnlen,emptynoteval ;note
 .byte ptnendval
 ;.fill maxptnlen-defptnlen,emptynoteval
 .fill maxptnlen,ptnNOPval ;emptyinsval ;inst/fx
 .byte ptnendval
 .fill maxptnlen,ptnNOPval ;emptyfxval ;fx/fxval
 .byte ptnendval
.next

tunedata_end
;.warn"End-address of tune-data = ",*
;.cwarn(*>=$8000),"Tune-data reaches ROM area, saving of the whole tune might be in risk. ",*



;***********************************************************************
;player used by the editor
.include "player.asm"
player #playerm *,1,0 ;editor's player instance

;==================== AUXILIARY TUNEDATA (for editor) ==================

;editor's pointertables
pointertables .segment

;.warn"Address of subtune-sequence low-pointers = ",*
seqptrlo ; ch0-st0lo, ch0-st1lo, ... ch0-stmaxlo  ;  ch1-st0lo, ch1-st1lo, ...
.for j=0, j<CHANNELAMOUNT, j=j+1
 .for i=0, i<maxsubtuneamount, i=i+1
  .byte <(  orderlists + i * (maxseqlen+1)*CHANNELAMOUNT + ( j*(maxseqlen+1) )  )
 .next
.next
seqptrhi ; ch0-st0hi, ch0-st1hi, ... ch0-stmaxhi  ;  ch1-st0hi, ch1-st1hi, ...
.for j=0, j<CHANNELAMOUNT, j=j+1
 .for i=0, i<maxsubtuneamount, i=i+1
  .byte >(  orderlists + i * (maxseqlen+1)*CHANNELAMOUNT + ( j*(maxseqlen+1) )  )
 .next
.next

;.warn"Address of instrument-pointers = ",*
insptlo
.byte <emptyins
.for i=0, i<maxinstamount, i=i+1
 .byte <(  instruments + i * (insheadersize+(maxinstblen+1)*instbcolumns)  )
.next
inspthi
.byte >emptyins
.for i=0, i<maxinstamount, i=i+1
 .byte >(  instruments + i * (insheadersize+(maxinstblen+1)*instbcolumns)  )
.next

;.warn"Address of pattern-pointers = ",*
pattptlo
.byte <emptyptn
.for i=0, i<maxptnamount, i=i+1
 .byte <(  patterns + i * ((maxptnlen+1)*ptncolumns)  )
.next
pattpthi
.byte >emptyptn
.for i=0, i<maxptnamount, i=i+1
 .byte >(  patterns + i * ((maxptnlen+1)*ptncolumns)  )
.next
insindexes
.byte 1
.for i=0, i<maxptnamount, i=i+1
 .byte (maxptnlen+1)
.next
fxindexes
.byte 2
.for i=0, i<maxptnamount, i=i+1
 .byte (maxptnlen+1)*2
.next

.endm ;pointertables

.if (MACHINE<2)
 #pointertables
.fi


;.align $100 ;temporary pointertable-storage for the exported/saved tune/workfile
;maxseqamount=maxsubtuneamount*CHANNELAMOUNT
pointertemp 
seqpl1tmp .fill maxsubtuneamount+1,0
seqph1tmp .fill maxsubtuneamount+1,0
seqpl2tmp .fill maxsubtuneamount+1,0
seqph2tmp .fill maxsubtuneamount+1,0
inspltmp .byte <emptyins ;for non-existent inst.0
         .fill maxinstamount,0
insphtmp .byte >emptyins ;for non-existent inst.0 
         .fill maxinstamount,0
ptnpltmp .byte <emptyptn ;for non-existent patt.0
         .fill maxptnamount,0
ptnphtmp .byte >emptyptn ;for non-existent patt.0
         .fill maxptnamount,0
ptniitmp .byte 1 ;for non-existent patt.0
         .fill maxptnamount,0
ptniftmp .byte 2 ;for non-existent patt.0
         .fill maxptnamount,0


ptnlen  .byte 1
        .fill maxptnamount,defptnlen ;pattern-length registry for the editor


.if (COPYPASTE_SUPPORT)
ptnbufdatastart .byte 0
firstptnbufdatalen .byte 0       
ptnbufdatalen .byte 0
ptnotebuf .fill maxptnlen,ptnNOPval ;emptynoteval
          .byte ptnendval

ptinsbuf .fill maxptnlen,ptnNOPval ;emptyinsval ;inst/fx
         .byte ptnendval

ptfxbuf .fill maxptnlen,ptnNOPval ;emptyfxval ;fx/fxval
        .byte ptnendval

seqbufdatastart .byte 0 ;to determine length when buffer gets shortened by Shift+C
firstseqbufdatalen .byte 0
seqbufdatalen .byte 0
seqbuf .fill maxseqlen,emptyseqval
       .byte seqendval

insbufdatalen=insbuf_end-insbuf ;for this to work insbuf structure should match TUNEDATA structure
insbuf  ;amount of following bytes (before inst.name) must match 'insmaindatalen' 
 #emptyinsm
insbuf_end
.fi

emptyinsm .macro  ;amount of following bytes (before inst.name) must match 'insmaindatalen' 
 .byte insheadersize+maxinstblen+1   ;freqtable-index
 .byte insheadersize+(maxinstblen+1)*2 ;volumetable-index
 .fill 3,0 ;noteoff-pointers
 .byte %01111100 ;table multispeed/restart/gap-staccatto bits
 .fill insnamelen,"."
 .fill maxinstblen,emptywfval ;this table has fix position at 'insheadersize' from base of instrument, no need for index
 .byte instbendval
 .fill maxinstblen,emptyfrval ;flexibe position in exported tune, index is in instrument main-data
 .byte instbendval
 .fill maxinstblen,emptyvoval ;flexibe position in exported tune, index is in instrument main-data
 .byte instbendval
.endm
emptyins
 #emptyinsm
emptyins_end

emptyptn
 .byte 0,0,0
emptyptn_end


.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
relocdata .segment

 .if (RELOCATION_SUPPORT>0) ;&& PLAYABLE_EXPORT_SUPPORT>0)
;================================================================================================
;Relocation table generator based on the new SID-Wizard relocator by Soci/Singular, utilizing 64tass union/struct capabilities
;Basically the player code is compiled twice to different locations. This small macro
;compares the resulting binaries and creates relocation entries for the changed addresses.

;create the relocation-list
;relocm .segment
relolist .var ()
         .for i=0, i < len(explayer), i=i+1
relodiff  .var (explayer2[i]-explayer[i]) & $ff
          .if relodiff == 0 ;Case: no difference in current code
          .elsif relodiff == 1 ;Case: difference in high-byte is $100, relocation needed in current code
relolist   .var relolist..(PLAYERADDR+i-2,) ;append relocation-list
          .else ;invalid difference in high-byte, maybe due to some tricky code
           .error "Not possible to relocate player-code at memory address ",player+i,"!"
          .fi
         .next

;.endm ;end of 'relocm' segment


;.align $100 ;avoid overlapping tune-data area
reloctable	.word relolist ;,0 ;resulted relocation-list
			;.word $0000 ;end of relocation table - later in DataPtr, as those commands also need relocation

 .fi ;end of RELOCATION_SUPPORT

;-----------------------------------------------------------------------------------
;addresses of absolute-instructions which point to music data 
DataPtr ;.block
    .word explayer.p_ptnl1, explayer.p_ptnh1, explayer.p_ptnf1, explayer.p_ptni1
    .word explayer.p_insl1, explayer.p_insh1
    .if (SUBTUNE_SUPPORT!=0)
     .word explayer.p_seql1, explayer.p_seqh1
    .else
     .word explayer.p_olip1
     .if (SEQ_FX_SUPPORT!=0)
      .word explayer.p_olip2
      .if (TEMPOPROGRAM_SUPPORT!=0)
       .word explayer.p_olip3
      .fi
     .fi
    .fi
    .word explayer.p_insl2, explayer.p_insh2, explayer.p_insl3, explayer.p_insh3, explayer.p_insl4, explayer.p_insh4
    ;.word $0000 ;this also means an end for relocation-table
;.bend
DataPtr_end
reloctable_end

;------------------
;this table tells which zeropage-pointer (set by packer) to load to operands of instructions given in 'DataPtr' above
PtrValu ;(numeric value tells what amount to add to the address)
        .byte ptnptloadd,0, ptnpthiadd,0, ptnfxindexadd,0, ptninsindexadd,0
        .byte insptloadd,0, inspthiadd,0
        .if (SUBTUNE_SUPPORT!=0)
         .byte seqptloadd,0, seqpthiadd,0
        .else
         .byte orderlistadd,0
         .if (SEQ_FX_SUPPORT!=0)
          .byte orderlistadd,1
          .if (TEMPOPROGRAM_SUPPORT!=0)
           .byte orderlistadd,0
          .fi
         .fi
        .fi
        .byte insptloadd,0, inspthiadd,0, insptloadd,0, inspthiadd,0, insptloadd,0, inspthiadd,0
        ;.byte 0         ;signs end of player-setter data 
PtrValu_end


 .if (RELOCATION_SUPPORT>0)
zeroplistl .var ()
zeroplisth .var ()
zeroplista .var ()
         .for i=0, i < len(explayer), i=i+1
          .if (explayer3[i]!=explayer[i]) ;Case: no difference in current code
zeroplistl .var zeroplistl..(<(PLAYERADDR+i),) ;append relocation-list
zeroplisth .var zeroplisth..(>(PLAYERADDR+i),) ;append relocation-list
zeroplista .var zeroplista..((explayer[i]&$FF)-playzp_default,)
           ;.cwarn (1),PLAYERADDR+i," ",(explayer[i]&$FF)-playzp_default
          .fi
         .next
zeroptablel .byte zeroplistl ;,0
zeroptableh .byte zeroplisth ;,0
zeroptablea .byte zeroplista ;,0
zeroptablea_end
 .fi

.endm ;relocdata


 .if (MACHINE<2)
  #relocdata
 .fi

.fi ;end of PLAYABLE_EXPORT_SUPPORT || RUNNABLE_EXPORT_SUPPORT

