;========================== TUNE PACKER ================================

packmode_workfile=0
packmode_release=1
packworkfile
        lda #packmode_workfile
packtune    ;in-place compression of tune-data, input: A=0:workfile target, A>0:playable/runnable target (no ins.names stored)
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
        sta packmod+1
.fi
        lda #<packed_data_start
        ldx #>packed_data_start
        sta compzp+0
        stx compzp+1
.if (SUBTUNE_SUPPORT==0)
        sta orderlistadd+0
        stx orderlistadd+1
.fi
        ;lda #<pointertemp
        ;ldx #>pointertemp
        ;sta ptrzp+0
        ;stx ptrzp+1

        jsr psubtun
        jsr pinstru
        jsr ppatter
        jsr regptr

.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
packmod ldy #selfmod
        ;cpy #packmode_workfile
        bne setendp
.fi
        ldy #authorinfo_len-1
-       lda authorinfo,y
        sta (compzp),y ;author-info to the end of packed workfile
        dey
        bpl -
        lda #authorinfo_len
        jsr compadd

setendp lda compzp+0
        sta tuneendptr+0
        lda compzp+1
        sta tuneendptr+1

.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
        lda packmod+1
        ;cmp #packmode_workfile
        beq +
        jmp setplayer ;jsr setplayer
.fi
+       lda #PLAYERTYPE ;`PLAYERTYPE ;convert char to int
        sta tuneheader.playertype

retpack rts


;----------------------- pack orderlists (sequences)
psubtun lda #$ff
        sta tuneheader.subtune_amount
        ldx #0 ;pack subtune-orderlists (sequences)
        stx used_ptn_amount
stdetlp lda seqptrlo,x
        sta datzp+0
        lda seqptrhi,x
        sta datzp+1
        jsr resetvs
        ldy #maxseqlen-1
-       lda (datzp),y
        bit validsig
        bmi +
        cmp #0
        beq ++
        stx tuneheader.subtune_amount ;register subtune 
        jsr regvali
.if (SUBTUNE_SUPPORT==0 && (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0) )
        cpx #0
        bne +
        sty ystore2+1
        iny
        iny
        sty explayer.seq0_len
ystore2 ldy #selfmod
.fi
+       jsr regusedptn
        sta (compzp),y 
+       dey
        bpl -
        cpx tuneheader.subtune_amount
        bne emps1pt
        lda compzp+0
        sta seqpl1tmp,x
        lda compzp+1
        sta seqph1tmp,x
        jsr compad0
        jmp +
emps1pt lda #0
        sta seqpl1tmp,x
        sta seqph1tmp,x
+       lda seqptrlo+maxsubtuneamount,x
        sta datzp+0
        lda seqptrhi+maxsubtuneamount,x
        sta datzp+1
        ldy #maxseqlen-1
-       lda (datzp),y
        bit validsig
        bmi +
        cmp #0
        beq ++
        stx tuneheader.subtune_amount
        jsr regvali
+       jsr regusedptn
        sta (compzp),y 
+       dey
        bpl -
        cpx tuneheader.subtune_amount
        bne emps2pt
        lda compzp+0
        sta seqpl2tmp,x
        lda compzp+1
        sta seqph2tmp,x
        jsr compad0
        jmp +
emps2pt lda #0
        sta seqpl2tmp,x
        sta seqph2tmp,x
+       inx
        cpx #maxsubtuneamount
        beq +
        jmp stdetlp
+       inc tuneheader.subtune_amount
        rts

regusedptn 
        cmp #1
        bcc retrupt
        cmp #maxptnamount+1 ;-1
        bcs retrupt
        cmp used_ptn_amount
        bcc retrupt
        pha
        dey
        lda (datzp),y ;check if $FF preceedes the number, then don't treat it as pattern-number
        iny
        cmp #jumpval
        beq +
        pla
        sta used_ptn_amount
        rts
+       pla
retrupt rts
used_ptn_amount .byte 0 ;pattern-amount based on last pattern used in orderlists


;------------------------------------- pack instruments
ins_maxsize=insheadersize+(maxinstblen+1)*3
pinstru lda #0
        sta tuneheader.ins_amount
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
        lda #<(insnametemp-insnamepos)
        ldx #>(insnametemp-insnamepos)
        sta inametmptr+0
        stx inametmptr+1
.fi
        ldx #1
ispcklp jsr pck1ins
        inx
        cpx #maxinstamount+1
        bne ispcklp
retipck rts

pack1inst
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
        lda #packmode_workfile
        sta packmod+1
.fi
;pack one instrument, its number is given in X, target in 'compzp', set packmode!
pck1ins lda insptlo,x
        sta datzp+0
        lda inspthi,x
        sta datzp+1
        ldy #wftbnoteoffindexpos
        lda (datzp),y
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
		beq +
        ldy packmod+1
        ;cmp #packmode_workfile
        beq +
		sec
		sbc	#insheadersize-insmaindatalen
+	    ldy #wftbnoteoffindexpos	
.fi
		sta (compzp),y
		ldy #freqtbnoteoffindexpos
		lda (datzp),y
		sta frgoffs+1
		ldy #voltbnoteoffindexpos
		lda (datzp),y
		sta vogoffs+1
		ldy #instcontrolswitchpos
		lda (datzp),y
		sta (compzp),y
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
        ldy packmod+1
        ;cpy #packmode_workfile
        beq cpiname
buiname ldy #insnamepos ;make backups of instrument-names to temp.area
-       lda (datzp),y
inmtemp sta (inametmptr),y
        iny
        cpy #insnamepos+insnamelen
        bne -
incinpt lda #insnamelen ;increment instrument-name temp. pointer
        clc
        adc inametmptr+0
        sta inametmptr+0
        bcc +
        inc inametmptr+1
+       lda #insnamepos ;insmaindatalen ;default is omitting (skipping) instr.name from target        
        jsr adtempz
        jmp packitb
.fi
cpiname ldy #insnamepos
-       lda (datzp),y
        sta (compzp),y
        iny
        cpy #insnamepos+insnamelen
        bne -
        lda #insheadersize ;correct tempzp: setting it AFTER ins.name
        jsr adtempz

packitb lda #wftbstartindex
        jsr cpinstb

        lda tempzp+0
		sec
		sbc compzp+0
        ldy #freqtbstartindexpos
        sta (compzp),y
frgoffs	lda #selfmod
		beq +
		sec
		sbc #insheadersize+(maxinstblen+1)*1
		clc
		adc (compzp),y
+		ldy #freqtbnoteoffindexpos
		sta (compzp),y
packftb lda #maxinstblen+1
        jsr cpinstb
        
        lda tempzp+0
		sec
		sbc compzp+0
        ldy #voltbstartindexpos
        sta (compzp),y
vogoffs	lda #selfmod
		beq +
		sec
		sbc #insheadersize+(maxinstblen+1)*2
		clc
		adc (compzp),y
+	    ldy #voltbnoteoffindexpos
		sta (compzp),y
packvtb lda #maxinstblen+1
        jsr cpinstb
        
        cpx tuneheader.ins_amount
        bne emptipt
        lda compzp+0
        sta inspltmp+1,x
        lda compzp+1
        sta insphtmp+1,x
        lda inssize
        jsr compadd
        jmp +
emptipt lda #0 ;if empty instrument inbetween used instruments, its pointer is 0
        sta inspltmp+1,x
        sta insphtmp+1,x        
+       rts

;pack one instrument-table, input: Accu=table-baseindex relative to instrument
cpinstb jsr datzadd
        jsr resetvs
        ldy #$ff
        sty compad1+1
        ldy #maxinstblen-1
- 		dey
		lda (datzp),y
		cmp #jumpval
		bne +
		lda tempzp+0
		sec
		sbc compzp+0
		.byte $2c ;skip
+		lda #0
		iny
		clc
		adc (datzp),y
        bit validsig
        bmi +
        cmp #0
        beq ++
        stx tuneheader.ins_amount
        jsr regvali
+       sta (tempzp),y
+       dey
		bpl -
clositb cpx tuneheader.ins_amount
        bne retcpit
        lda #0
        ldy compad1+1 ;length
        iny
+       sta (tempzp),y
        iny
        tya
        pha 
        clc
        adc tempzp+0
        sta tempzp+0
        bcc +
        inc tempzp+1
+       pla
        clc
        adc inssize
        sta inssize
        lda #0
        sta validsig
retcpit rts


;---------------------------- pack patterns
ppatter lda #0
        sta tuneheader.ptn_amount      
        ldx #maxptnamount ;-1 ;no pattern 0 used
ptdetlp lda pattptlo,x ;loop to copy & compress used patterns
        sta datzp+0
        lda pattpthi,x
        sta datzp+1
        ldy ptnlen,x ;#maxptnlen-1 ;loop to detect last used pattern
        dey
-       lda (datzp),y
        bne +
        dey
        bpl -
        lda #maxptnlen+1
        jsr datzadd ;copy & compress pattern
        ldy ptnlen,x ;#maxptnlen-1 ;loop to detect last used pattern
        dey
-       lda (datzp),y
        bne +
        dey
        bpl -
        lda #maxptnlen+1
        jsr datzadd ;copy & compress pattern
        ldy ptnlen,x ;#maxptnlen-1 ;loop to detect last used pattern
        dey
-       lda (datzp),y
        bne +
        dey
        bpl -
        dex
        bne ptdetlp ;no pattern 0
+       stx tuneheader.ptn_amount

        lda used_ptn_amount
        cmp tuneheader.ptn_amount
        bcc +
        sta tuneheader.ptn_amount

+       lda tuneheader.ptn_amount
        beq retpptn

        ldx #1 ;no pattern 0 used
ptcmplp lda pattptlo,x ;loop to copy & compress used patterns
        sta datzp+0
        lda pattpthi,x
        sta datzp+1
        lda compzp+0
        sta ptnpltmp+1,x
        lda compzp+1
        sta ptnphtmp+1,x
        lda #0
        sta inscolu
        jsr cppatt2
        clc
        adc #1 ;accounting endvalue $FF
        sta ptniitmp+1,x
        lda #ptnendval
        sta (compzp),y
        iny
        jsr compad2
        lda #$FF
        sta inscolu ;tell depacker it's instr.column
        lda #maxptnlen+1
        jsr cppattn
        clc
        adc #1 ;accounting endvalues ($FF) at table-ends
        adc ptniitmp+1,x
        sta ptniftmp+1,x
        lda #ptnendval
        sta (compzp),y
        iny
        jsr compad2
        lda #0
        sta inscolu
        lda #maxptnlen+1
        jsr cppattn
        lda #ptnendval
        sta (compzp),y
        iny
        jsr compad2
        cpx tuneheader.ptn_amount ;#maxptnamount
        beq retpptn
        inx
        bne ptcmplp
retpptn rts

.if (PACKED_NOP_SUPPORT!=0)
cppattn jsr datzadd ;copy & compress pattern
cppatt2 ;jsr resetvs
        ldy ptnlen,x
        sty plenst2+1
        dey
        sty plenst3+1
        stx xstore7+1
        lda compzp+0
        sta packtgt+1
        lda compzp+1
        sta packtgt+2
        ldy #0
        ldx #0
        stx packcnt
-       lda (datzp),y
        bne nonNOP
itisNOP inc packcnt
plenst3 cpy #selfmod
        bcs +
        lda packcnt
        cmp #(ptnendval-packNOP_min)+1
        bcs +
        iny
        jmp -
+       jsr putPNOP
        jmp advasrc
nonNOP  cmp #packNOP_min ;accidental $FF-endsignal or packed NOPs written by user should be substituted with zero 
        bcs itisNOP ;no need to set Accumulator=0
        lda packcnt
        beq writetg
        jsr putPNOP
writetg lda (datzp),y
        jsr checkinvalidinst
        jsr packtgt
advasrc iny
plenst2 cpy #selfmod
        bcc -
        txa ;exiting with compressed length in Accumulator and Y
        tay
xstore7 ldx #selfmod
        rts

putPNOP lda packcnt
        cmp #1
        bne +
        lda #0
        jmp packtgt
+       clc
        adc #packNOP_min-2
packtgt sta selfmodA,x
        inx
        lda #0
        sta packcnt
        rts
.else
cppattn jsr datzadd ;copy & compress pattern
cppatt2 ldy ptnlen,x
-       lda (datzp),y
        cmp #packNOP_min ;accidental $FF-endsignal or packed NOPs written by user should be substituted with zero 
        bcc +
        lda #0 ;for non-valid FX ($FF or packed-NOP value)
+       jsr checkinvalidinst
        sta (compzp),y
        dey
        bpl -
        lda ptnlen,x
        tay
        rts
.fi

checkinvalidinst 
        bit inscolu
        bpl +
        cmp #$3F ;not instrument-selection?
        bcs +
        cmp tuneheader.ins_amount ;selecting valid instrument?
        bcc +
        beq +
        lda #0 ;if non-valid instrument, substitute it with 0 (NOP) in export
+       rts

packcnt .byte 0	
inscolu .byte 0


;--------------------------- copy and register pointer-tables
regptr  
.if (SUBTUNE_SUPPORT!=0)
        jsr ldcompzp
        sta seqptloadd+0
        stx seqptloadd+1
.fi
        ldy #0  
-       lda seqpl1tmp,y
        sta (compzp),y
        iny
        cpy tuneheader.subtune_amount 
        bne -
        jsr compad2

        ldy #0  
-       lda seqpl2tmp,y
        sta (compzp),y
        iny
        cpy tuneheader.subtune_amount 
        bne -
        jsr compad2

.if (SUBTUNE_SUPPORT!=0)
        jsr ldcompzp
        sta seqpthiadd+0
        stx seqpthiadd+1
.fi
        ldy #0  
-       lda seqph1tmp,y
        sta (compzp),y
        iny
        cpy tuneheader.subtune_amount 
        bne -
        jsr compad2

        ldy #0  
-       lda seqph2tmp,y
        sta (compzp),y
        iny
        cpy tuneheader.subtune_amount 
        bne -
        jsr compad2

        jsr ldcompzp
        sta insptloadd+0
        stx insptloadd+1
        ldy tuneheader.ins_amount 
-       lda inspltmp+1,y
        sta (compzp),y
        dey
        bpl -
        ldy tuneheader.ins_amount 
        jsr compad3

        jsr ldcompzp
        sta inspthiadd+0
        stx inspthiadd+1
        ldy tuneheader.ins_amount 
-       lda insphtmp+1,y
        sta (compzp),y
        dey
        bpl -
        ldy tuneheader.ins_amount 
        jsr compad3

        jsr ldcompzp
        sta ptnptloadd+0
        stx ptnptloadd+1
        ldy tuneheader.ptn_amount 
-       lda ptnpltmp+1,y
        sta (compzp),y
        dey
        bpl -
        ldy tuneheader.ptn_amount 
        jsr compad3

        jsr ldcompzp
        sta ptnpthiadd+0
        stx ptnpthiadd+1
        ldy tuneheader.ptn_amount 
-       lda ptnphtmp+1,y
        sta (compzp),y
        dey
        bpl -
        ldy tuneheader.ptn_amount 
        jsr compad3

        jsr ldcompzp
        sta ptninsindexadd+0
        stx ptninsindexadd+1
        ldy tuneheader.ptn_amount 
-       lda ptniitmp+1,y
        sta (compzp),y
        dey
        bpl -
        ldy tuneheader.ptn_amount 
        jsr compad3

        jsr ldcompzp
        sta ptnfxindexadd+0
        stx ptnfxindexadd+1
        ldy tuneheader.ptn_amount 
-       lda ptniftmp+1,y
        sta (compzp),y
        dey
        bpl -
        ldy tuneheader.ptn_amount 
        jsr compad3

        rts


;----------------------------------------------
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
;Set player pointertable-addresses and other misc.data
setplayer
 .if (MACHINE==2)
        lda #$34
        sta banksel ;get data from RAM under I/O-area
 .fi
        ldx #(DataPtr_end-DataPtr)-2 ;ldx #(PtrValu_end-PtrValu)-1
-       ;txa
        ;asl
        ;tay
        lda DataPtr+0,x ;lda DataPtr,y
        sta datzp+0
        lda DataPtr+1,x ;lda DataPtr+1,y
        sta datzp+1
        ldy PtrValu+0,x
        sty zpload1+1
        iny
        sty zpload2+1
        ldy #1
zpload1 lda $11;selfmod
        clc
        adc PtrValu+1,x
        sta (datzp),y
        iny
zpload2 lda $11;selfmod
        adc #0 ;Add Carry
        sta (datzp),y
        dex
        dex
        bpl -
 .if (MACHINE==2)
        lda #$35
        sta banksel
 .fi
 .if (SUBTUNE_SUPPORT!=0)
        lda tuneheader.subtune_amount
        sta explayer.subtune_amount
 .fi
        ldy #authorinfo_len-1
-       lda authorinfo,y
        sta explayer.authorinfo,y
        dey
        bpl -
        rts
.fi ;end of PLAYABLE_EXPORT_SUPPORT || RUNNABLE_EXPORT_SUPPORT



;---------------------------- misc. routines for packer
ldcompzp lda compzp+0
         ldx compzp+1
        rts

compad0 lda #0
compad1 ldy #selfmod
        iny
compad4 sta (compzp),y
compad3 iny
compad2 tya
compadd clc
        adc compzp+0
        sta compzp+0
        bcc resetvs
        inc compzp+1
resetvs lda #0
        sta validsig
        rts

datzadd clc
        adc datzp+0
        sta datzp+0
        bcc +
        inc datzp+1
+       rts

regvali dec validsig
        sty compad1+1      ;register data-length (info to increase compressed data's pointer)
        rts

adtempz sta inssize
adtmpz2 clc
        adc compzp+0
        sta tempzp+0
        lda compzp+1
        adc #0 ;add Carry
        sta tempzp+1
        rts

validsig .byte 0
inssize .byte 0



;============================= RELOCATION ==============================

.if (RELOCATION_SUPPORT>0)
relocate
        lda relocaddr	;calculate difference
reloca2 sec
		sbc #>PLAYERADDR
		sta relocdiff
		bne reloptr
        jmp retrelo ;if no need for relocation
reloptr
 .if (SUBTUNE_SUPPORT!=0)
relsubp lda tuneheader.subtune_amount 
        asl
        sta twicest+1
        ldy #0  
-       lda (seqpthiadd),y
        clc
        adc relocdiff
        sta (seqpthiadd),y
        iny
twicest cpy #selfmod ;tuneheader.subtune_amount 
        bne -
        jsr compad2
 .fi
relinsp ldy tuneheader.ins_amount
-       lda (inspthiadd),y
        clc
        adc relocdiff
        sta (inspthiadd),y
        dey
        bpl -
relpatp ldy tuneheader.ptn_amount
-       lda (ptnpthiadd),y
        clc
        adc relocdiff
        sta (ptnpthiadd),y
        dey
        bpl -

reloply 
 .if (MACHINE==2)
        lda #$34
        sta banksel ;get reloc-data from RAM under I/O area
 .fi
;relocate zeropage-accesses
        ldx #0
-       lda zeroptablel,x
        sta zeropad+1
        lda zeroptableh,x
        sta zeropad+2
        lda zeropaddr ;#playzp_default
        clc
        adc zeroptablea,x
zeropad sta selfmodA
        inx
        cpx #(zeroptablea_end-zeroptablea)
        bne -
;relocate player-code
        lda #>reloctable
        sta reloclp+2
        sta reltadd+2
        ldx #0 ;loop to relocate player-code
reloclp lda reloctable,x ;self-written when needed
        sta datzp+0
        inx
reltadd lda reloctable,x ;self-written when needed
        sta datzp+1
        beq retrelo
		ldy #2	;we modify only 2nd (hi) address-byte of absolute-addressing 6502 instructions in player code
		lda (datzp),y
		clc
		adc relocdiff
		sta (datzp),y
		inx	;go to next relocation-pointer
		bne reloclp
		inc reloclp+2	;in case relocation table would be bigger than 256 bytes
		inc reltadd+2
		bne reloclp
retrelo
 .if (MACHINE==2)
        lda #$35
        sta banksel
 .fi
        rts

unrelocate	;set everything back to relative of PLAYERADDR (resume relocation, not to affect further exports)
		lda #0	;negate relocation-difference
		sec
		sbc relocdiff	;calculate difference backwards
		beq retrelo
		sta relocdiff	;reset reloc.address
		jmp reloptr ;reloply

relocdiff .byte $00	;hi-address relative to base address


.fi

